// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.programStrategy;

import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Liste des droits d''un service pour un programme particulier
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Program2Department
    implements Serializable, Comparable<Program2Department>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8120554493119735971L;

    // Generate 2 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 4 associations
    private ProgramPrivilege programPrivilege;

    /**
     * Identifiant du privilège (droit) sur les programmes
     * @return this.programPrivilege ProgramPrivilege
     */
    public ProgramPrivilege getProgramPrivilege()
    {
        return this.programPrivilege;
    }

    /**
     * Identifiant du privilège (droit) sur les programmes
     * @param programPrivilegeIn ProgramPrivilege
     */
    public void setProgramPrivilege(ProgramPrivilege programPrivilegeIn)
    {
        this.programPrivilege = programPrivilegeIn;
    }

    private Department department;

    /**
     * Identifiant interne d''un service
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Identifiant interne d''un service
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private Location location;

    /**
     * Lieu sur lequel le département a les droits
     * @return this.location Location
     */
    public Location getLocation()
    {
        return this.location;
    }

    /**
     * Lieu sur lequel le département a les droits
     * @param locationIn Location
     */
    public void setLocation(Location locationIn)
    {
        this.location = locationIn;
    }

    private Program program;

    /**
     * Code unique du programme
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Code unique du programme
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Program2Department instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Program2Department))
        {
            return false;
        }
        final Program2Department that = (Program2Department)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Program2Department}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Program2Department}.
         * @return new Program2DepartmentImpl()
         */
        public static Program2Department newInstance()
        {
            return new Program2DepartmentImpl();
        }

        /**
         * Constructs a new instance of {@link Program2Department}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param updateDate Timestamp
         * @param programPrivilege ProgramPrivilege
         * @param department Department
         * @param program Program
         * @return newInstance
         */
        public static Program2Department newInstance(Timestamp updateDate, ProgramPrivilege programPrivilege, Department department, Program program)
        {
            final Program2Department entity = new Program2DepartmentImpl();
            entity.setUpdateDate(updateDate);
            entity.setProgramPrivilege(programPrivilege);
            entity.setDepartment(department);
            entity.setProgram(program);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Program2Department}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDate Timestamp
         * @param programPrivilege ProgramPrivilege
         * @param department Department
         * @param location Location
         * @param program Program
         * @return newInstance Program2Department
         */
        public static Program2Department newInstance(Timestamp updateDate, ProgramPrivilege programPrivilege, Department department, Location location, Program program)
        {
            final Program2Department entity = new Program2DepartmentImpl();
            entity.setUpdateDate(updateDate);
            entity.setProgramPrivilege(programPrivilege);
            entity.setDepartment(department);
            entity.setLocation(location);
            entity.setProgram(program);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Program2Department o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Program2Department.java merge-point
}