// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user;

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.referential.ObjectType;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Droits calculés pour un utilisateur à partir d'autres entités implémentant la gestion des droits.
 * Le but est l'amélioration des performances de synchronisation entre bases locale et distante. Les
 * droits sont calculés en début d'importation des données et n'ont pas à être recalculés pour
 * chaque donnée pour laquelle des droits sont appliqués.
 * Créé d'après l'étude sur l'amélioration des performances V3 (cf. mantis 10528).
 * Remplie à partir de la procédure PL/SQL F_FILL_PERSON_SESSION
 */
// HibernateEntity.vsl annotations merge-point
public abstract class PersonSessionVessel
    implements Serializable, Comparable<PersonSessionVessel>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -64174703645674439L;

    // Generate 8 attributes
    private Long id;

    /**
     * 
     * @return this.id Long
     */
    public Long getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Long
     */
    public void setId(Long idIn)
    {
        this.id = idIn;
    }

    private Timestamp startDateTime;

    /**
     * 
     * @return this.startDateTime Timestamp
     */
    public Timestamp getStartDateTime()
    {
        return this.startDateTime;
    }

    /**
     * 
     * @param startDateTimeIn Timestamp
     */
    public void setStartDateTime(Timestamp startDateTimeIn)
    {
        this.startDateTime = startDateTimeIn;
    }

    private Timestamp endDateTime;

    /**
     * Attribut obligatoire : lorsque la valeur n'est pas renseigné dans les portefeuilles on lui
     * assigne une valeur par défaut suprérieure à toute autre date.
     * @return this.endDateTime Timestamp
     */
    public Timestamp getEndDateTime()
    {
        return this.endDateTime;
    }

    /**
     * Attribut obligatoire : lorsque la valeur n'est pas renseigné dans les portefeuilles on lui
     * assigne une valeur par défaut suprérieure à toute autre date.
     * @param endDateTimeIn Timestamp
     */
    public void setEndDateTime(Timestamp endDateTimeIn)
    {
        this.endDateTime = endDateTimeIn;
    }

    private Boolean readVessel;

    /**
     * 
     * @return this.readVessel Boolean
     */
    public Boolean isReadVessel()
    {
        return this.readVessel;
    }

    /**
     * 
     * @param readVesselIn Boolean
     */
    public void setReadVessel(Boolean readVesselIn)
    {
        this.readVessel = readVesselIn;
    }

    private Boolean writeData;

    /**
     * 
     * @return this.writeData Boolean
     */
    public Boolean isWriteData()
    {
        return this.writeData;
    }

    /**
     * 
     * @param writeDataIn Boolean
     */
    public void setWriteData(Boolean writeDataIn)
    {
        this.writeData = writeDataIn;
    }

    private Boolean validateData;

    /**
     * L'utilisateur a t il les droits de validation ? (renseigné à partir des privilèges sur les
     * programmes)
     * @return this.validateData Boolean
     */
    public Boolean getValidateData()
    {
        return this.validateData;
    }

    /**
     * L'utilisateur a t il les droits de validation ? (renseigné à partir des privilèges sur les
     * programmes)
     * @param validateDataIn Boolean
     */
    public void setValidateData(Boolean validateDataIn)
    {
        this.validateData = validateDataIn;
    }

    private Boolean readData;

    /**
     * 
     * @return this.readData Boolean
     */
    public Boolean isReadData()
    {
        return this.readData;
    }

    /**
     * 
     * @param readDataIn Boolean
     */
    public void setReadData(Boolean readDataIn)
    {
        this.readData = readDataIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 4 associations
    private ObjectType objectType;

    /**
     * Liste des types d'objets qui peuvent etre associés à la photo ou à un fichier attaché. Cette
     * liste
     * ne peut pas etre modifiée par l'utilisateur.
     * généralement, il s'agit des noms des tables (en majuscule + underscore)
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Liste des types d'objets qui peuvent etre associés à la photo ou à un fichier attaché. Cette
     * liste
     * ne peut pas etre modifiée par l'utilisateur.
     * généralement, il s'agit des noms des tables (en majuscule + underscore)
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    private Program program;

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    private PersonSession personSession;

    /**
     * Tête de grappe de droits calculés pour un utilisateur à partir d'autres entités implémentant
     * la
     * gestion des droits. Le but est l'amélioration des performances de synchronisation entre bases
     * locale
     * et distante. Les droits sont calculés en début d'importation des données et n'ont pas à être
     * recalculés pour chaque donnée pour laquelle des droits sont appliqués.
     * Créé d'après l'étude sur l'amélioration des performances V3 (cf. mantis 10528).
     * @return this.personSession PersonSession
     */
    public PersonSession getPersonSession()
    {
        return this.personSession;
    }

    /**
     * Tête de grappe de droits calculés pour un utilisateur à partir d'autres entités implémentant
     * la
     * gestion des droits. Le but est l'amélioration des performances de synchronisation entre bases
     * locale
     * et distante. Les droits sont calculés en début d'importation des données et n'ont pas à être
     * recalculés pour chaque donnée pour laquelle des droits sont appliqués.
     * Créé d'après l'étude sur l'amélioration des performances V3 (cf. mantis 10528).
     * @param personSessionIn PersonSession
     */
    public void setPersonSession(PersonSession personSessionIn)
    {
        this.personSession = personSessionIn;
    }

    private Vessel vessel;

    /**
     * Navire, ou plus généralement un usager de la ressource.
     * Peut etre un navire de peche professionnel ou non, un navire scientifique, un pêcheur à pied,
     * un
     * groupement de navires, etc.
     * @return this.vessel Vessel
     */
    public Vessel getVessel()
    {
        return this.vessel;
    }

    /**
     * Navire, ou plus généralement un usager de la ressource.
     * Peut etre un navire de peche professionnel ou non, un navire scientifique, un pêcheur à pied,
     * un
     * groupement de navires, etc.
     * @param vesselIn Vessel
     */
    public void setVessel(Vessel vesselIn)
    {
        this.vessel = vesselIn;
    }

    /**
     * Returns <code>true</code> if the argument is an PersonSessionVessel instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof PersonSessionVessel))
        {
            return false;
        }
        final PersonSessionVessel that = (PersonSessionVessel)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link PersonSessionVessel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link PersonSessionVessel}.
         * @return new PersonSessionVesselImpl()
         */
        public static PersonSessionVessel newInstance()
        {
            return new PersonSessionVesselImpl();
        }

        /**
         * Constructs a new instance of {@link PersonSessionVessel}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param startDateTime Timestamp
         * @param endDateTime Timestamp
         * @param readVessel Boolean
         * @param writeData Boolean
         * @param readData Boolean
         * @param updateDate Timestamp
         * @param objectType ObjectType
         * @param program Program
         * @param personSession PersonSession
         * @param vessel Vessel
         * @return newInstance
         */
        public static PersonSessionVessel newInstance(Timestamp startDateTime, Timestamp endDateTime, Boolean readVessel, Boolean writeData, Boolean readData, Timestamp updateDate, ObjectType objectType, Program program, PersonSession personSession, Vessel vessel)
        {
            final PersonSessionVessel entity = new PersonSessionVesselImpl();
            entity.setStartDateTime(startDateTime);
            entity.setEndDateTime(endDateTime);
            entity.setReadVessel(readVessel);
            entity.setWriteData(writeData);
            entity.setReadData(readData);
            entity.setUpdateDate(updateDate);
            entity.setObjectType(objectType);
            entity.setProgram(program);
            entity.setPersonSession(personSession);
            entity.setVessel(vessel);
            return entity;
        }

        /**
         * Constructs a new instance of {@link PersonSessionVessel}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param startDateTime Timestamp
         * @param endDateTime Timestamp
         * @param readVessel Boolean
         * @param writeData Boolean
         * @param validateData Boolean
         * @param readData Boolean
         * @param updateDate Timestamp
         * @param objectType ObjectType
         * @param program Program
         * @param personSession PersonSession
         * @param vessel Vessel
         * @return newInstance PersonSessionVessel
         */
        public static PersonSessionVessel newInstance(Timestamp startDateTime, Timestamp endDateTime, Boolean readVessel, Boolean writeData, Boolean validateData, Boolean readData, Timestamp updateDate, ObjectType objectType, Program program, PersonSession personSession, Vessel vessel)
        {
            final PersonSessionVessel entity = new PersonSessionVesselImpl();
            entity.setStartDateTime(startDateTime);
            entity.setEndDateTime(endDateTime);
            entity.setReadVessel(readVessel);
            entity.setWriteData(writeData);
            entity.setValidateData(validateData);
            entity.setReadData(readData);
            entity.setUpdateDate(updateDate);
            entity.setObjectType(objectType);
            entity.setProgram(program);
            entity.setPersonSession(personSession);
            entity.setVessel(vessel);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(PersonSessionVessel o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getStartDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStartDateTime().compareTo(o.getStartDateTime()));
            }
            if (this.getEndDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDateTime().compareTo(o.getEndDateTime()));
            }
            if (this.isReadVessel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isReadVessel().compareTo(o.isReadVessel()));
            }
            if (this.isWriteData() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isWriteData().compareTo(o.isWriteData()));
            }
            if (this.getValidateData() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getValidateData().compareTo(o.getValidateData()));
            }
            if (this.isReadData() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isReadData().compareTo(o.isReadData()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// PersonSessionVessel.java merge-point
}