// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * Liste des profils pouvant &#234;tre affect&#233;s &#224; un utilisateur.
 * </p>
 * <p>
 * Pour la v1, les valeurs identifi&#233;es sont :
 * </p>
 * <p>
 * - Administrateur de r&#233;f&#233;rentiel (pour info, pas encore de synonyme LDAP)
 * : donne acc&#232;s aux fonctionnalit&#233;s d&#8217;aministration du r&#233;f&#233;rentiel, ainsi
 * qu&#8217;aux autres fonctionn lit&#233; d&#8217;administration (ex :
 * programmes/strat&#233;gies).
 * </p>
 * <p>
 * - Observateur (pour info, synonyme LDAP = SIH_ROBS) : donne acc&#232;s en
 * consultation sur le r&#233;f&#233;rentiel (hors donn&#233;es navires). Si portefeuilles
 * rattach&#233;s &#224; l'observateur, alors droits en saisie sur la fonctionnalit&#233;
 * correspondant au type du portefeuille (gestion des mar&#233;es observ&#233;es,
 * calendriers d'activit&#233;s navires, ...). Si superviseur de portefeuille,
 * alors droits de correction sur les donn&#233;es saisies dans les
 * portefeuilles supervis&#233;s.
 * </p>
 * <p>
 * - Projet (pour info, synonyme LDAP = SIH_PROJET) : utilisateur membre de
 * l'&#233;quipe projet du syst&#232;me ISIH : membre droits de consultation et de
 * saisie que pour un observateur.
 * </p>
 * <p>
 * - Utilisateur (pour info, synonyme LDAP = SIH_AUTRE) : utilisateur su
 * syst&#232;me ISIH : pour la v1, ce profil ne donne acc&#232;s &#224; aucune
 * fonctionnalit&#233; du syst&#232;me Allegro.
 * <br>    </p>
 * <p>
 * </p>
 * <p>
 * <u>note 1 :</u> les droits d'acc&#232;s en saisie sur les fonctions
 * (superviseur, activit&#233; sur les navires, mar&#233;es observ&#233;es) ne sont donc
 * pas g&#233;r&#233;s ici, mais par l'interm&#233;diaire des portefeuilles (cf classe
 * &quot;Portefeuille Navire&quot;).
 * </p>
 * <p>
 * <u>note 2 :</u> le synonyme LDAP &quot;SIH_AUTRE&quot; n'est pas utilis&#233; pour le
 * moment : il correspond &#224; un utilisateur sans profil particulier
 * </p>
 * <p>
 * Nombre de lignes : 4
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class UserProfil
    implements Serializable, Comparable<UserProfil>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6935757165121081554L;

    // Generate 4 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * Synonyme du profil dans LDAP
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * Synonyme du profil dans LDAP
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private String name;

    /**
     * 
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * 
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 1 associations
    /**
     * Returns <code>true</code> if the argument is an UserProfil instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof UserProfil))
        {
            return false;
        }
        final UserProfil that = (UserProfil)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link UserProfil}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link UserProfil}.
         * @return new UserProfilImpl()
         */
        public static UserProfil newInstance()
        {
            return new UserProfilImpl();
        }


        /**
         * Constructs a new instance of {@link UserProfil}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param updateDate Timestamp
         * @return newInstance UserProfil
         */
        public static UserProfil newInstance(String label, String name, Timestamp updateDate)
        {
            final UserProfil entity = new UserProfilImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(UserProfil o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// UserProfil.java merge-point
}