// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user;

import fr.ifremer.adagio.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * Liste des profils pouvant &#234;tre affect&#233;s &#224; un utilisateur.
 * </p>
 * <p>
 * Pour la v1, les valeurs identifi&#233;es sont :
 * </p>
 * <p>
 * - Administrateur de r&#233;f&#233;rentiel (pour info, pas encore de synonyme LDAP)
 * : donne acc&#232;s aux fonctionnalit&#233;s d&#8217;aministration du r&#233;f&#233;rentiel, ainsi
 * qu&#8217;aux autres fonctionn lit&#233; d&#8217;administration (ex :
 * programmes/strat&#233;gies).
 * </p>
 * <p>
 * - Observateur (pour info, synonyme LDAP = SIH_ROBS) : donne acc&#232;s en
 * consultation sur le r&#233;f&#233;rentiel (hors donn&#233;es navires). Si portefeuilles
 * rattach&#233;s &#224; l'observateur, alors droits en saisie sur la fonctionnalit&#233;
 * correspondant au type du portefeuille (gestion des mar&#233;es observ&#233;es,
 * calendriers d'activit&#233;s navires, ...). Si superviseur de portefeuille,
 * alors droits de correction sur les donn&#233;es saisies dans les
 * portefeuilles supervis&#233;s.
 * </p>
 * <p>
 * - Projet (pour info, synonyme LDAP = SIH_PROJET) : utilisateur membre de
 * l'&#233;quipe projet du syst&#232;me ISIH : membre droits de consultation et de
 * saisie que pour un observateur.
 * </p>
 * <p>
 * - Utilisateur (pour info, synonyme LDAP = SIH_AUTRE) : utilisateur su
 * syst&#232;me ISIH : pour la v1, ce profil ne donne acc&#232;s &#224; aucune
 * fonctionnalit&#233; du syst&#232;me Allegro.
 * <br>    </p>
 * <p>
 * </p>
 * <p>
 * <u>note 1 :</u> les droits d'acc&#232;s en saisie sur les fonctions
 * (superviseur, activit&#233; sur les navires, mar&#233;es observ&#233;es) ne sont donc
 * pas g&#233;r&#233;s ici, mais par l'interm&#233;diaire des portefeuilles (cf classe
 * &quot;Portefeuille Navire&quot;).
 * </p>
 * <p>
 * <u>note 2 :</u> le synonyme LDAP &quot;SIH_AUTRE&quot; n'est pas utilis&#233; pour le
 * moment : il correspond &#224; un utilisateur sans profil particulier
 * </p>
 * <p>
 * Nombre de lignes : 4
 * </p>
 * </body>
 * </html>
 * @see UserProfil
 */
public interface UserProfilDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link UserProfil}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of UserProfil from the persistent store.
     * @param id
     * @return UserProfil
     */
    public UserProfil get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of UserProfil from the persistent store.
     * @param id
     * @return UserProfil
     */
    public UserProfil load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link UserProfil}.
     *
     * @return the loaded entities.
     */
    public Collection<UserProfil> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of UserProfil and adds it to the persistent store.
     * @param userProfil
     * @return UserProfil
     */
    public UserProfil create(UserProfil userProfil);

    /**
     * <p>
     * Does the same thing as {@link #create(UserProfil)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param userProfil
     * @return Object
     */
    public Object create(int transform, UserProfil userProfil);

    /**
     * Creates a new instance of UserProfil and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of UserProfil
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<UserProfil> create(Collection<UserProfil> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(UserProfil)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<UserProfil> entities);

    /**
     * <p>
     * Creates a new <code>UserProfil</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param id 
     * @param label Synonyme du profil dans LDAP
     * @param name 
     * @param updateDate 
     * @return UserProfil
     */
    public UserProfil create(
        Integer id,
        String label,
        String name,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param id 
     * @param label Synonyme du profil dans LDAP
     * @param name 
     * @param updateDate 
     * @return UserProfil
     */
    public Object create(
        int transform,
        Integer id,
        String label,
        String name,
        Timestamp updateDate);


    /**
     * Updates the <code>userProfil</code> instance in the persistent store.
     * @param userProfil
     */
    public void update(UserProfil userProfil);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<UserProfil> entities);

    /**
     * Removes the instance of UserProfil from the persistent store.
     * @param userProfil
     */
    public void remove(UserProfil userProfil);

    /**
     * Removes the instance of UserProfil having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<UserProfil> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<UserProfil> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.administration.user.UserProfilDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.administration.user.UserProfilDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final UserProfil entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,UserProfil)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.administration.user.UserProfilDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,UserProfil)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}