// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.batch.denormalized;

import fr.ifremer.adagio.core.dao.referential.pmfm.Parameter;
import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import fr.ifremer.adagio.core.dao.referential.pmfm.Unit;
import java.io.Serializable;

/**
 * Table technique stockant les critères de classement d'un lot, ainsi que les critères de
 * classement des lots père (par héritage).
 * ATTENTION : Table technique. (RAZ des données possible).
 * Elle est remplie par le traitement de dénormalisation des lots.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DenormalisedBatchSortingValue
    implements Serializable, Comparable<DenormalisedBatchSortingValue>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 3680955763262753048L;

    // Generate 4 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Integer rankOrder;

    /**
     * Numéro d'ordre du critère de classement.
     * Calculé par le traitement de dénormalisation.
     * Le numéro d'ordre est différent de SORTING_MEASUREMENT.RANK_ORDER, car cette table inclut les
     * critères de classement hérités.
     * Le premier critère par ordre de ce RANK_ORDER sera le premier critère du lot père le plus
     * haut dans l'arbre.
     * Le dernier critère sera le dernier critère du lot courant.
     * @return this.rankOrder Integer
     */
    public Integer getRankOrder()
    {
        return this.rankOrder;
    }

    /**
     * Numéro d'ordre du critère de classement.
     * Calculé par le traitement de dénormalisation.
     * Le numéro d'ordre est différent de SORTING_MEASUREMENT.RANK_ORDER, car cette table inclut les
     * critères de classement hérités.
     * Le premier critère par ordre de ce RANK_ORDER sera le premier critère du lot père le plus
     * haut dans l'arbre.
     * Le dernier critère sera le dernier critère du lot courant.
     * @param rankOrderIn Integer
     */
    public void setRankOrder(Integer rankOrderIn)
    {
        this.rankOrder = rankOrderIn;
    }

    private Boolean isInherited;

    /**
     * Indique si le critère de classement a été recopié depuis un critère de classement d'un lot
     * père (par héritage) ou non.
     * Calculé par le traitement de dénormalisation.
     * Valeurs possibles : Oui (=1) ou Non (=0).
     * @return this.isInherited Boolean
     */
    public Boolean isIsInherited()
    {
        return this.isInherited;
    }

    /**
     * Indique si le critère de classement a été recopié depuis un critère de classement d'un lot
     * père (par héritage) ou non.
     * Calculé par le traitement de dénormalisation.
     * Valeurs possibles : Oui (=1) ou Non (=0).
     * @param isInheritedIn Boolean
     */
    public void setIsInherited(Boolean isInheritedIn)
    {
        this.isInherited = isInheritedIn;
    }

    private Float numericalValue;

    /**
     * Valeur numérique du critère de classement, s'il s'agit d'un critère de classement numérique.
     * Recopié à partir de SORTING_MEASUREMENT.NUMERICAL_VALUE
     * @return this.numericalValue Float
     */
    public Float getNumericalValue()
    {
        return this.numericalValue;
    }

    /**
     * Valeur numérique du critère de classement, s'il s'agit d'un critère de classement numérique.
     * Recopié à partir de SORTING_MEASUREMENT.NUMERICAL_VALUE
     * @param numericalValueIn Float
     */
    public void setNumericalValue(Float numericalValueIn)
    {
        this.numericalValue = numericalValueIn;
    }

    // Generate 5 associations
    private Pmfm pmfm;

    /**
     * PMFM correspondant au critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.PMFM_FK.
     * @return this.pmfm Pmfm
     */
    public Pmfm getPmfm()
    {
        return this.pmfm;
    }

    /**
     * PMFM correspondant au critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.PMFM_FK.
     * @param pmfmIn Pmfm
     */
    public void setPmfm(Pmfm pmfmIn)
    {
        this.pmfm = pmfmIn;
    }

    private QualitativeValue qualitativeValue;

    /**
     * Valeur qualitative du critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.QUALITATIVE_VALUE_FK
     * @return this.qualitativeValue QualitativeValue
     */
    public QualitativeValue getQualitativeValue()
    {
        return this.qualitativeValue;
    }

    /**
     * Valeur qualitative du critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.QUALITATIVE_VALUE_FK
     * @param qualitativeValueIn QualitativeValue
     */
    public void setQualitativeValue(QualitativeValue qualitativeValueIn)
    {
        this.qualitativeValue = qualitativeValueIn;
    }

    private DenormalizedBatch denormalizedBatch;

    /**
     * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
     * d'optimisation de l'exploitation de ces données.
     * Des champs additionnels sont également calculés dans cette table.
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @return this.denormalizedBatch DenormalizedBatch
     */
    public DenormalizedBatch getDenormalizedBatch()
    {
        return this.denormalizedBatch;
    }

    /**
     * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
     * d'optimisation de l'exploitation de ces données.
     * Des champs additionnels sont également calculés dans cette table.
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @param denormalizedBatchIn DenormalizedBatch
     */
    public void setDenormalizedBatch(DenormalizedBatch denormalizedBatchIn)
    {
        this.denormalizedBatch = denormalizedBatchIn;
    }

    private Parameter parameter;

    /**
     * Paramètre correspondant au critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.PMFM_FK, puis PMFM.PARAMETER_FK
     * @return this.parameter Parameter
     */
    public Parameter getParameter()
    {
        return this.parameter;
    }

    /**
     * Paramètre correspondant au critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.PMFM_FK, puis PMFM.PARAMETER_FK
     * @param parameterIn Parameter
     */
    public void setParameter(Parameter parameterIn)
    {
        this.parameter = parameterIn;
    }

    private Unit unit;

    /**
     * Unité correspondant au critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.PMFM_FK, puis PMFM.UNIT_FK.
     * @return this.unit Unit
     */
    public Unit getUnit()
    {
        return this.unit;
    }

    /**
     * Unité correspondant au critère de classement.
     * Recopié à partir de SORTING_MEASUREMENT.PMFM_FK, puis PMFM.UNIT_FK.
     * @param unitIn Unit
     */
    public void setUnit(Unit unitIn)
    {
        this.unit = unitIn;
    }

    /**
     * Returns <code>true</code> if the argument is an DenormalisedBatchSortingValue instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DenormalisedBatchSortingValue))
        {
            return false;
        }
        final DenormalisedBatchSortingValue that = (DenormalisedBatchSortingValue)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link DenormalisedBatchSortingValue}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DenormalisedBatchSortingValue}.
         * @return new DenormalisedBatchSortingValueImpl()
         */
        public static DenormalisedBatchSortingValue newInstance()
        {
            return new DenormalisedBatchSortingValueImpl();
        }

        /**
         * Constructs a new instance of {@link DenormalisedBatchSortingValue}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param rankOrder Integer
         * @param isInherited Boolean
         * @param pmfm Pmfm
         * @param denormalizedBatch DenormalizedBatch
         * @param parameter Parameter
         * @param unit Unit
         * @return newInstance
         */
        public static DenormalisedBatchSortingValue newInstance(Integer rankOrder, Boolean isInherited, Pmfm pmfm, DenormalizedBatch denormalizedBatch, Parameter parameter, Unit unit)
        {
            final DenormalisedBatchSortingValue entity = new DenormalisedBatchSortingValueImpl();
            entity.setRankOrder(rankOrder);
            entity.setIsInherited(isInherited);
            entity.setPmfm(pmfm);
            entity.setDenormalizedBatch(denormalizedBatch);
            entity.setParameter(parameter);
            entity.setUnit(unit);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DenormalisedBatchSortingValue}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param rankOrder Integer
         * @param isInherited Boolean
         * @param numericalValue Float
         * @param pmfm Pmfm
         * @param qualitativeValue QualitativeValue
         * @param denormalizedBatch DenormalizedBatch
         * @param parameter Parameter
         * @param unit Unit
         * @return newInstance DenormalisedBatchSortingValue
         */
        public static DenormalisedBatchSortingValue newInstance(Integer rankOrder, Boolean isInherited, Float numericalValue, Pmfm pmfm, QualitativeValue qualitativeValue, DenormalizedBatch denormalizedBatch, Parameter parameter, Unit unit)
        {
            final DenormalisedBatchSortingValue entity = new DenormalisedBatchSortingValueImpl();
            entity.setRankOrder(rankOrder);
            entity.setIsInherited(isInherited);
            entity.setNumericalValue(numericalValue);
            entity.setPmfm(pmfm);
            entity.setQualitativeValue(qualitativeValue);
            entity.setDenormalizedBatch(denormalizedBatch);
            entity.setParameter(parameter);
            entity.setUnit(unit);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DenormalisedBatchSortingValue o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRankOrder().compareTo(o.getRankOrder()));
            }
            if (this.isIsInherited() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsInherited().compareTo(o.isIsInherited()));
            }
            if (this.getNumericalValue() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getNumericalValue().compareTo(o.getNumericalValue()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DenormalisedBatchSortingValue.java merge-point
}