// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.fishingArea;

import fr.ifremer.adagio.core.dao.data.produce.Produce;
import fr.ifremer.adagio.core.dao.data.sample.Sample;
import fr.ifremer.adagio.core.dao.data.survey.sale.Sale;
import fr.ifremer.adagio.core.dao.data.vessel.feature.use.GearUseFeatures;
import fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures;
import fr.ifremer.adagio.core.dao.referential.DepthGradient;
import fr.ifremer.adagio.core.dao.referential.DistanceToCoastGradient;
import fr.ifremer.adagio.core.dao.referential.NearbySpecificArea;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Zone de peche ou d'activité effective d'un navire.
 * </p>
 * <p>
 * </p>
 * <p>
 * Contient une entrée pour chaque zone de peche d'un navire.
 * </p>
 * <p>
 * </p>
 * <p>
 * ATTENTION : ne pas réutiliser une zone de peche effective dèjà
 * existante, à cause des liens de composition (et des contraintes &quot;delete
 * cascade&quot;) depuis les autres tables.
 * </p>
 * <p>
 * Votre enregistrement pourrait etre supprimée par quelqu'un d'autre !
 * </p>
 * <p>
 * </p>
 * <p>
 * </p>
 * <p>
 * <u>Cas particulier des campagnes scientifiques (F.Coppin) : </u>Dans le
 * cas des campagnes scientifiques, ce concept correspond à une &quot;station&quot;. La
 * notion exacte de Fishing Area est définie suivant le protocole spatiale
 * mise en place. En effet, la notion la plus fine d'aire de travail est la
 * localité (stockée  <i>FishingArea2RegulationLocation</i>).
 * L'ordre de réalisation des prélèvements pouvant changer d'une année sur
 * l'autre, la localité permet de disposer d'un code unique pour une zone
 * de prélèvement donnée. Cette localité peut s'inscrire ou non selon le
 * protocole dans une strate (stcokée dans <i>FishingArea2RegulationLocation)</i>
 * définie dans le cadre du programme lié à la série (ce paramétrage est
 * stocké dans les <i>Program</i> et <i>Strategy</i>). Il s'agit alors
 * d'un 2ème niveau géographique pouvant contenir une ou plusieurs
 * localités.
 * </p>
 * <p>
 * Toutes les situations peuvent être envisagées :
 * </p>
 * <ul>
 * <li>
 * Localités + strates
 * </li>
 * <li>
 * Localités sans strate
 * </li>
 * <li>
 * Strates sans localité
 * </li>
 * <li>
 * ni localité ni strate
 * </li>
 * </ul>
 * <p>
 * En plus de ces options la notion de strate bathymétrique peut exister.
 * </p>
 * <p>
 * Dans tous les cas de figure ces divers éléments géographiques doivent
 * s'inscrivent dans la notion officielle de rectangle ou sous rectangle
 * statistique (stcoké dans <i>FishingArea.location</i>).
 * </p>
 * <p>
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class FishingArea
    implements Serializable, Comparable<FishingArea>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -3744603833038946960L;

    // Generate 3 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Date qualificationDate;

    /**
     * @since 3.5.0
     * @return this.qualificationDate Date
     */
    public Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    /**
     * @since 3.5.0
     * @param qualificationDateIn Date
     */
    public void setQualificationDate(Date qualificationDateIn)
    {
        this.qualificationDate = qualificationDateIn;
    }

    private String qualificationComments;

    /**
     * @since 3.5.0
     * @return this.qualificationComments String
     */
    public String getQualificationComments()
    {
        return this.qualificationComments;
    }

    /**
     * @since 3.5.0
     * @param qualificationCommentsIn String
     */
    public void setQualificationComments(String qualificationCommentsIn)
    {
        this.qualificationComments = qualificationCommentsIn;
    }

    // Generate 12 associations
    private Collection<FishingArea2ManagedLocation> fishingArea2ManagedLocations = new HashSet<FishingArea2ManagedLocation>();

    /**
     * 
     * @return this.fishingArea2ManagedLocations Collection<FishingArea2ManagedLocation>
     */
    public Collection<FishingArea2ManagedLocation> getFishingArea2ManagedLocations()
    {
        return this.fishingArea2ManagedLocations;
    }

    /**
     * 
     * @param fishingArea2ManagedLocationsIn Collection<FishingArea2ManagedLocation>
     */
    public void setFishingArea2ManagedLocations(Collection<FishingArea2ManagedLocation> fishingArea2ManagedLocationsIn)
    {
        this.fishingArea2ManagedLocations = fishingArea2ManagedLocationsIn;
    }

    /**
     * 
     * @param elementToAdd FishingArea2ManagedLocation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addFishingArea2ManagedLocations(FishingArea2ManagedLocation elementToAdd)
    {
        return this.fishingArea2ManagedLocations.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove FishingArea2ManagedLocation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeFishingArea2ManagedLocations(FishingArea2ManagedLocation elementToRemove)
    {
        return this.fishingArea2ManagedLocations.remove(elementToRemove);
    }

    private Collection<FishingArea2RegulationLocation> regulationLocations = new HashSet<FishingArea2RegulationLocation>();

    /**
     * Zones réglementaires particulières (ex : ZEE, zone d'effort, etc.)
     * @return this.regulationLocations Collection<FishingArea2RegulationLocation>
     */
    public Collection<FishingArea2RegulationLocation> getRegulationLocations()
    {
        return this.regulationLocations;
    }

    /**
     * Zones réglementaires particulières (ex : ZEE, zone d'effort, etc.)
     * @param regulationLocationsIn Collection<FishingArea2RegulationLocation>
     */
    public void setRegulationLocations(Collection<FishingArea2RegulationLocation> regulationLocationsIn)
    {
        this.regulationLocations = regulationLocationsIn;
    }

    /**
     * Zones réglementaires particulières (ex : ZEE, zone d'effort, etc.)
     * @param elementToAdd FishingArea2RegulationLocation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addRegulationLocations(FishingArea2RegulationLocation elementToAdd)
    {
        return this.regulationLocations.add(elementToAdd);
    }

    /**
     * Zones réglementaires particulières (ex : ZEE, zone d'effort, etc.)
     * @param elementToRemove FishingArea2RegulationLocation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeRegulationLocations(FishingArea2RegulationLocation elementToRemove)
    {
        return this.regulationLocations.remove(elementToRemove);
    }

    private Produce produce;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Un produit est identifi&#233; par une esp&#232;ce commerciale, un &#233;tat, une
     * qualit&#233;, pr&#233;sentation et cat&#233;gorie commerciale.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u>Si le produit est un &quot;produit vendu&quot; :</u>
     * </p>
     * <p>
     * On pourra allors utiliser SortingMeasurement pour stocker des donn&#233;es
     * &#233;conomiques, comme par exemple :
     * </p>
     * <p>
     * - Le prix du produit. Il peut y avoir plusieurds prix (plusieurs PSFMs),
     * par exemple : prix au kilo, et prix total en euros.
     * </p>
     * <p>
     * - Valorisation de la commercialisation : Label rouge, Eco Label, marque
     * collective control&#233;e par un organisme tier. (cf SACROIS)
     * </p>
     * <p>
     * - Destination commerciale : consommation humaine, consommation animale,
     * etc .
     * </p>
     * </body>
     * </html>
     * @return this.produce Produce
     */
    public Produce getProduce()
    {
        return this.produce;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Un produit est identifi&#233; par une esp&#232;ce commerciale, un &#233;tat, une
     * qualit&#233;, pr&#233;sentation et cat&#233;gorie commerciale.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u>Si le produit est un &quot;produit vendu&quot; :</u>
     * </p>
     * <p>
     * On pourra allors utiliser SortingMeasurement pour stocker des donn&#233;es
     * &#233;conomiques, comme par exemple :
     * </p>
     * <p>
     * - Le prix du produit. Il peut y avoir plusieurds prix (plusieurs PSFMs),
     * par exemple : prix au kilo, et prix total en euros.
     * </p>
     * <p>
     * - Valorisation de la commercialisation : Label rouge, Eco Label, marque
     * collective control&#233;e par un organisme tier. (cf SACROIS)
     * </p>
     * <p>
     * - Destination commerciale : consommation humaine, consommation animale,
     * etc .
     * </p>
     * </body>
     * </html>
     * @param produceIn Produce
     */
    public void setProduce(Produce produceIn)
    {
        this.produce = produceIn;
    }

    private GearUseFeatures gearUseFeatures;

    /**
     * Paramètre de mise en oeuvre de l'engin durant une opération.
     * Exemple de paramètre de mise en oeuvre:
     * • nombre de boués,
     * • type de panneau,
     * • présence d'un racasseur,
     * • nombre de casier.
     * mais aussi :
     * • profondeur moyenne de l'engin,
     * • vitesse de traine moyenne
     * • ouverture du chalut
     * @return this.gearUseFeatures GearUseFeatures
     */
    public GearUseFeatures getGearUseFeatures()
    {
        return this.gearUseFeatures;
    }

    /**
     * Paramètre de mise en oeuvre de l'engin durant une opération.
     * Exemple de paramètre de mise en oeuvre:
     * • nombre de boués,
     * • type de panneau,
     * • présence d'un racasseur,
     * • nombre de casier.
     * mais aussi :
     * • profondeur moyenne de l'engin,
     * • vitesse de traine moyenne
     * • ouverture du chalut
     * @param gearUseFeaturesIn GearUseFeatures
     */
    public void setGearUseFeatures(GearUseFeatures gearUseFeaturesIn)
    {
        this.gearUseFeatures = gearUseFeaturesIn;
    }

    private VesselUseFeatures vesselUseFeatures;

    /**
     * Paramètres de mise en oeuvre du navire. Il peut s'agir de données d'observation comme de
     * données de
     * déclaration, mais liée à comment est utilisé le navire et dans quelles conditions.
     * Par exemple, pour les donénes d'observation :
     * • profondeur de mer au début de l'opération, en mètre,
     * • profondeur de mer à la fin de l'opération, en mètre,
     * • déroulement de l'opération (normal, anormal, etc.)
     * • état de la mer lors durant l'opération : échelle de 0 à 9 (4=agitée, etc)
     * • trait rectiligne (oui/non)
     * • cout en gazoil,
     * • nombre d'engin perdu,
     * • cout des pertes,
     * • etc.
     * Par exemple, pour les données de déclaration :
     * • temps de pêche,
     * • temps de route (qui peut aussi etre calculé à l'exploitation),
     * • nombre d'opérations,
     * • etc.
     * @return this.vesselUseFeatures VesselUseFeatures
     */
    public VesselUseFeatures getVesselUseFeatures()
    {
        return this.vesselUseFeatures;
    }

    /**
     * Paramètres de mise en oeuvre du navire. Il peut s'agir de données d'observation comme de
     * données de
     * déclaration, mais liée à comment est utilisé le navire et dans quelles conditions.
     * Par exemple, pour les donénes d'observation :
     * • profondeur de mer au début de l'opération, en mètre,
     * • profondeur de mer à la fin de l'opération, en mètre,
     * • déroulement de l'opération (normal, anormal, etc.)
     * • état de la mer lors durant l'opération : échelle de 0 à 9 (4=agitée, etc)
     * • trait rectiligne (oui/non)
     * • cout en gazoil,
     * • nombre d'engin perdu,
     * • cout des pertes,
     * • etc.
     * Par exemple, pour les données de déclaration :
     * • temps de pêche,
     * • temps de route (qui peut aussi etre calculé à l'exploitation),
     * • nombre d'opérations,
     * • etc.
     * @param vesselUseFeaturesIn VesselUseFeatures
     */
    public void setVesselUseFeatures(VesselUseFeatures vesselUseFeaturesIn)
    {
        this.vesselUseFeatures = vesselUseFeaturesIn;
    }

    private NearbySpecificArea nearbySpecificArea;

    /**
     * Type de zone de proximité particulière.
     * Par exemple :
     * - DCP (Dispositif de Concentration de Poison)
     * - Filière aquacole
     * - ...
     * (liste non exhaustive)
     * Nombre de lignes : 10
     * @return this.nearbySpecificArea NearbySpecificArea
     */
    public NearbySpecificArea getNearbySpecificArea()
    {
        return this.nearbySpecificArea;
    }

    /**
     * Type de zone de proximité particulière.
     * Par exemple :
     * - DCP (Dispositif de Concentration de Poison)
     * - Filière aquacole
     * - ...
     * (liste non exhaustive)
     * Nombre de lignes : 10
     * @param nearbySpecificAreaIn NearbySpecificArea
     */
    public void setNearbySpecificArea(NearbySpecificArea nearbySpecificAreaIn)
    {
        this.nearbySpecificArea = nearbySpecificAreaIn;
    }

    private DepthGradient depthGradient;

    /**
     * Type de gradient de profondeur de la zone de pêche.
     * @return this.depthGradient DepthGradient
     */
    public DepthGradient getDepthGradient()
    {
        return this.depthGradient;
    }

    /**
     * Type de gradient de profondeur de la zone de pêche.
     * @param depthGradientIn DepthGradient
     */
    public void setDepthGradient(DepthGradient depthGradientIn)
    {
        this.depthGradient = depthGradientIn;
    }

    private DistanceToCoastGradient distanceToCoastGradient;

    /**
     * Gradient de distance à la cote.
     * passage en optionel nécessaire pour SACROIS.
     * @return this.distanceToCoastGradient DistanceToCoastGradient
     */
    public DistanceToCoastGradient getDistanceToCoastGradient()
    {
        return this.distanceToCoastGradient;
    }

    /**
     * Gradient de distance à la cote.
     * passage en optionel nécessaire pour SACROIS.
     * @param distanceToCoastGradientIn DistanceToCoastGradient
     */
    public void setDistanceToCoastGradient(DistanceToCoastGradient distanceToCoastGradientIn)
    {
        this.distanceToCoastGradient = distanceToCoastGradientIn;
    }

    private Location location;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.location Location
     */
    public Location getLocation()
    {
        return this.location;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param locationIn Location
     */
    public void setLocation(Location locationIn)
    {
        this.location = locationIn;
    }

    private Sale sale;

    /**
     * Lien vers la vente rattachée.
     * Nécessaire pour Allegro ObsVente (v3.1), qui nécessite qu'une vente soit liée à des zones en
     * mer. Ceci pour le calcul des RTP dans l'échantillonnage biologique. Ces zones en mer sont
     * récupérées à partir de la ligne du plan d'echantillonnage, depuis WAO.
     * @return this.sale Sale
     */
    public Sale getSale()
    {
        return this.sale;
    }

    /**
     * Lien vers la vente rattachée.
     * Nécessaire pour Allegro ObsVente (v3.1), qui nécessite qu'une vente soit liée à des zones en
     * mer. Ceci pour le calcul des RTP dans l'échantillonnage biologique. Ces zones en mer sont
     * récupérées à partir de la ligne du plan d'echantillonnage, depuis WAO.
     * @param saleIn Sale
     */
    public void setSale(Sale saleIn)
    {
        this.sale = saleIn;
    }

    private QualityFlag qualityFlag;

    /**
     * @since 3.5.0
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * @since 3.5.0
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private Sample sample;

    /**
     * Un prélèvement représente un (et un seul) support, prélevé au cours d'une opération de peche,
     * d'un
     * échantillonnage au débarquement ou d'une vente. Il s'agit de la partie qui est recueillie
     * pour
     * analyse ou dénombrement.
     * Un prélèvement est rattaché à une opération de peche ou un groupe d'opérations, un
     * débarquement ou à
     * une vente. Il peut être en plus rattaché à un des lots échantillonnés (le lot de provenance).
     * Dans le cas des marées observées en mer, un prlèvement correspond à un individu, dont le
     * support
     * est, par exemple :
     * - crustacé (crevette...)
     * - poisson (merlu, sardine...)
     * - gastéropode (bigorneau, littorine...)
     * - echinoderme (oursin...)
     * - etc.
     * Le nombre d'individu, généralement égal à 1, permet de constituer des prélèvement de
     * plusieurs
     * individu (dès lors qu'il sont ne meme anture). Chaque résultat de mesure (SampleMeasurement)
     * pourra
     * identifié l'individu concerné par la mesure, par une numéro din'dividu.
     * Un mnémonique, représentant généralement l'étiquette collée sur le sachet contenant le
     * prélèvement,
     * permet d"identifier le prélèvement de manière simple, notamment en laboratoire pour la saisie
     * des
     * lectures d'age, etc..
     * Par exemple de prélèvement :
     * - un poisson, d'une espèce donnée, sur lequel est prélevé un otholithe, et/ou des écailes
     * afin de
     * réaliser une lecture d'age.
     * - un cétacé, issu d'un lot, sur lesquels doit être effectué des analyses d'age, de taille,
     * - etc.
     * @return this.sample Sample
     */
    public Sample getSample()
    {
        return this.sample;
    }

    /**
     * Un prélèvement représente un (et un seul) support, prélevé au cours d'une opération de peche,
     * d'un
     * échantillonnage au débarquement ou d'une vente. Il s'agit de la partie qui est recueillie
     * pour
     * analyse ou dénombrement.
     * Un prélèvement est rattaché à une opération de peche ou un groupe d'opérations, un
     * débarquement ou à
     * une vente. Il peut être en plus rattaché à un des lots échantillonnés (le lot de provenance).
     * Dans le cas des marées observées en mer, un prlèvement correspond à un individu, dont le
     * support
     * est, par exemple :
     * - crustacé (crevette...)
     * - poisson (merlu, sardine...)
     * - gastéropode (bigorneau, littorine...)
     * - echinoderme (oursin...)
     * - etc.
     * Le nombre d'individu, généralement égal à 1, permet de constituer des prélèvement de
     * plusieurs
     * individu (dès lors qu'il sont ne meme anture). Chaque résultat de mesure (SampleMeasurement)
     * pourra
     * identifié l'individu concerné par la mesure, par une numéro din'dividu.
     * Un mnémonique, représentant généralement l'étiquette collée sur le sachet contenant le
     * prélèvement,
     * permet d"identifier le prélèvement de manière simple, notamment en laboratoire pour la saisie
     * des
     * lectures d'age, etc..
     * Par exemple de prélèvement :
     * - un poisson, d'une espèce donnée, sur lequel est prélevé un otholithe, et/ou des écailes
     * afin de
     * réaliser une lecture d'age.
     * - un cétacé, issu d'un lot, sur lesquels doit être effectué des analyses d'age, de taille,
     * - etc.
     * @param sampleIn Sample
     */
    public void setSample(Sample sampleIn)
    {
        this.sample = sampleIn;
    }

    /**
     * Returns <code>true</code> if the argument is an FishingArea instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof FishingArea))
        {
            return false;
        }
        final FishingArea that = (FishingArea)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link FishingArea}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link FishingArea}.
         * @return new FishingAreaImpl()
         */
        public static FishingArea newInstance()
        {
            return new FishingAreaImpl();
        }

        /**
         * Constructs a new instance of {@link FishingArea}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param distanceToCoastGradient DistanceToCoastGradient
         * @param location Location
         * @param qualityFlag QualityFlag
         * @return newInstance
         */
        public static FishingArea newInstance(DistanceToCoastGradient distanceToCoastGradient, Location location, QualityFlag qualityFlag)
        {
            final FishingArea entity = new FishingAreaImpl();
            entity.setDistanceToCoastGradient(distanceToCoastGradient);
            entity.setLocation(location);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link FishingArea}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param fishingArea2ManagedLocations Collection<FishingArea2ManagedLocation>
         * @param regulationLocations Collection<FishingArea2RegulationLocation>
         * @param produce Produce
         * @param gearUseFeatures GearUseFeatures
         * @param vesselUseFeatures VesselUseFeatures
         * @param nearbySpecificArea NearbySpecificArea
         * @param depthGradient DepthGradient
         * @param distanceToCoastGradient DistanceToCoastGradient
         * @param location Location
         * @param sale Sale
         * @param qualityFlag QualityFlag
         * @param sample Sample
         * @return newInstance FishingArea
         */
        public static FishingArea newInstance(Date qualificationDate, String qualificationComments, Collection<FishingArea2ManagedLocation> fishingArea2ManagedLocations, Collection<FishingArea2RegulationLocation> regulationLocations, Produce produce, GearUseFeatures gearUseFeatures, VesselUseFeatures vesselUseFeatures, NearbySpecificArea nearbySpecificArea, DepthGradient depthGradient, DistanceToCoastGradient distanceToCoastGradient, Location location, Sale sale, QualityFlag qualityFlag, Sample sample)
        {
            final FishingArea entity = new FishingAreaImpl();
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setFishingArea2ManagedLocations(fishingArea2ManagedLocations);
            entity.setRegulationLocations(regulationLocations);
            entity.setProduce(produce);
            entity.setGearUseFeatures(gearUseFeatures);
            entity.setVesselUseFeatures(vesselUseFeatures);
            entity.setNearbySpecificArea(nearbySpecificArea);
            entity.setDepthGradient(depthGradient);
            entity.setDistanceToCoastGradient(distanceToCoastGradient);
            entity.setLocation(location);
            entity.setSale(sale);
            entity.setQualityFlag(qualityFlag);
            entity.setSample(sample);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(FishingArea o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getQualificationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualificationDate().compareTo(o.getQualificationDate()));
            }
            if (this.getQualificationComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualificationComments().compareTo(o.getQualificationComments()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// FishingArea.java merge-point
}