// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.fishingArea;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.DistanceToCoastGradient;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Zone de peche ou d'activité effective d'un navire.
 * </p>
 * <p>
 * </p>
 * <p>
 * Contient une entrée pour chaque zone de peche d'un navire.
 * </p>
 * <p>
 * </p>
 * <p>
 * ATTENTION : ne pas réutiliser une zone de peche effective dèjà
 * existante, à cause des liens de composition (et des contraintes &quot;delete
 * cascade&quot;) depuis les autres tables.
 * </p>
 * <p>
 * Votre enregistrement pourrait etre supprimée par quelqu'un d'autre !
 * </p>
 * <p>
 * </p>
 * <p>
 * </p>
 * <p>
 * <u>Cas particulier des campagnes scientifiques (F.Coppin) : </u>Dans le
 * cas des campagnes scientifiques, ce concept correspond à une &quot;station&quot;. La
 * notion exacte de Fishing Area est définie suivant le protocole spatiale
 * mise en place. En effet, la notion la plus fine d'aire de travail est la
 * localité (stockée  <i>FishingArea2RegulationLocation</i>).
 * L'ordre de réalisation des prélèvements pouvant changer d'une année sur
 * l'autre, la localité permet de disposer d'un code unique pour une zone
 * de prélèvement donnée. Cette localité peut s'inscrire ou non selon le
 * protocole dans une strate (stcokée dans <i>FishingArea2RegulationLocation)</i>
 * définie dans le cadre du programme lié à la série (ce paramétrage est
 * stocké dans les <i>Program</i> et <i>Strategy</i>). Il s'agit alors
 * d'un 2ème niveau géographique pouvant contenir une ou plusieurs
 * localités.
 * </p>
 * <p>
 * Toutes les situations peuvent être envisagées :
 * </p>
 * <ul>
 * <li>
 * Localités + strates
 * </li>
 * <li>
 * Localités sans strate
 * </li>
 * <li>
 * Strates sans localité
 * </li>
 * <li>
 * ni localité ni strate
 * </li>
 * </ul>
 * <p>
 * En plus de ces options la notion de strate bathymétrique peut exister.
 * </p>
 * <p>
 * Dans tous les cas de figure ces divers éléments géographiques doivent
 * s'inscrivent dans la notion officielle de rectangle ou sous rectangle
 * statistique (stcoké dans <i>FishingArea.location</i>).
 * </p>
 * <p>
 * </p>
 * </body>
 * </html>
 * @see FishingArea
 */
public interface FishingAreaDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link FishingArea}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of FishingArea from the persistent store.
     * @param id
     * @return FishingArea
     */
    public FishingArea get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of FishingArea from the persistent store.
     * @param id
     * @return FishingArea
     */
    public FishingArea load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link FishingArea}.
     *
     * @return the loaded entities.
     */
    public Collection<FishingArea> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of FishingArea and adds it to the persistent store.
     * @param fishingArea
     * @return FishingArea
     */
    public FishingArea create(FishingArea fishingArea);

    /**
     * <p>
     * Does the same thing as {@link #create(FishingArea)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param fishingArea
     * @return Object
     */
    public Object create(int transform, FishingArea fishingArea);

    /**
     * Creates a new instance of FishingArea and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of FishingArea
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<FishingArea> create(Collection<FishingArea> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(FishingArea)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<FishingArea> entities);

    /**
     * <p>
     * Creates a new <code>FishingArea</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param qualificationDate @since 3.5.0
     * @param qualificationComments @since 3.5.0
     * @return FishingArea
     */
    public FishingArea create(
        Date qualificationDate,
        String qualificationComments);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param qualificationDate @since 3.5.0
     * @param qualificationComments @since 3.5.0
     * @return FishingArea
     */
    public Object create(
        int transform,
        Date qualificationDate,
        String qualificationComments);

    /**
     * <p>
     * Creates a new <code>FishingArea</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param distanceToCoastGradient
     * @param location
     * @param qualityFlag
     * @return FishingArea
     */
    public FishingArea create(
        DistanceToCoastGradient distanceToCoastGradient,
        Location location,
        QualityFlag qualityFlag);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param distanceToCoastGradient
     * @param location
     * @param qualityFlag
     * @return Object
     */
    public Object create(
        int transform,
        DistanceToCoastGradient distanceToCoastGradient,
        Location location,
        QualityFlag qualityFlag);

    /**
     * Updates the <code>fishingArea</code> instance in the persistent store.
     * @param fishingArea
     */
    public void update(FishingArea fishingArea);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<FishingArea> entities);

    /**
     * Removes the instance of FishingArea from the persistent store.
     * @param fishingArea
     */
    public void remove(FishingArea fishingArea);

    /**
     * Removes the instance of FishingArea having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<FishingArea> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<FishingArea> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.fishingArea.FishingAreaDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.fishingArea.FishingAreaDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final FishingArea entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,FishingArea)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.fishingArea.FishingAreaDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,FishingArea)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}