// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.history;

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.administration.user.Person;
import fr.ifremer.adagio.core.dao.referential.ObjectType;
import java.io.Serializable;
import java.math.BigInteger;
import java.sql.Timestamp;

/**
 * Permet de tracer les suppressions d’entités (marée, vente, etc), notamment afin que ces
 * suppressions soient importées dans les bases locales d'Allegro.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DeletedItemHistory
    implements Serializable, Comparable<DeletedItemHistory>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1179505466496968370L;

    // Generate 6 attributes
    private BigInteger id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id BigInteger
     */
    public BigInteger getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn BigInteger
     */
    public void setId(BigInteger idIn)
    {
        this.id = idIn;
    }

    private String vesselCode;

    /**
     * (=VESSEL_FK) Si la suppression concerne un navire, on trace le code du navire, afin
     * d'optimiser les synchronisations des utilisateurs qui ne sont pas concernés par ce navire.
     * @return this.vesselCode String
     */
    public String getVesselCode()
    {
        return this.vesselCode;
    }

    /**
     * (=VESSEL_FK) Si la suppression concerne un navire, on trace le code du navire, afin
     * d'optimiser les synchronisations des utilisateurs qui ne sont pas concernés par ce navire.
     * @param vesselCodeIn String
     */
    public void setVesselCode(String vesselCodeIn)
    {
        this.vesselCode = vesselCodeIn;
    }

    private Long objectId;

    /**
     * Identifiant de l'entité supprimée, correspondant généralement à la colonne ID de la table
     * concernée.
     * Soit objectId soit objectCode doivent être obligatoirement renseigné.
     * @return this.objectId Long
     */
    public Long getObjectId()
    {
        return this.objectId;
    }

    /**
     * Identifiant de l'entité supprimée, correspondant généralement à la colonne ID de la table
     * concernée.
     * Soit objectId soit objectCode doivent être obligatoirement renseigné.
     * @param objectIdIn Long
     */
    public void setObjectId(Long objectIdIn)
    {
        this.objectId = objectIdIn;
    }

    private String objectCode;

    /**
     * Identifiant de l'entité supprimée, correspondant généralement à la colonne CODE de la table
     * concernée.
     * Soit objectId soit objectCode doivent être obligatoirement renseigné.
     * @return this.objectCode String
     */
    public String getObjectCode()
    {
        return this.objectCode;
    }

    /**
     * Identifiant de l'entité supprimée, correspondant généralement à la colonne CODE de la table
     * concernée.
     * Soit objectId soit objectCode doivent être obligatoirement renseigné.
     * @param objectCodeIn String
     */
    public void setObjectCode(String objectCodeIn)
    {
        this.objectCode = objectCodeIn;
    }

    private String comments;

    /**
     * Commentaire sur la suppression (optionnel).
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * Commentaire sur la suppression (optionnel).
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 5 associations
    private Program program;

    /**
     * Programme auquel la donnée supprimée était rattachée.
     * Ce champ (optionnel) permet de filtrer les lignes de DeletedItemHistory dans de l'importation
     * des suppressions dans les base de données locales d'Allegro.
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Programme auquel la donnée supprimée était rattachée.
     * Ce champ (optionnel) permet de filtrer les lignes de DeletedItemHistory dans de l'importation
     * des suppressions dans les base de données locales d'Allegro.
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    private Department recorderDepartment;

    /**
     * Le service  qui a fait la suppression
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Le service  qui a fait la suppression
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    private Person recorderPerson;

    /**
     * L'utilisateur qui a fait la suppression
     * @return this.recorderPerson Person
     */
    public Person getRecorderPerson()
    {
        return this.recorderPerson;
    }

    /**
     * L'utilisateur qui a fait la suppression
     * @param recorderPersonIn Person
     */
    public void setRecorderPerson(Person recorderPersonIn)
    {
        this.recorderPerson = recorderPersonIn;
    }

    private ObjectType objectType;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Type d'entité supprimée.
     * </p>
     * <p>
     * Généralement, on utilise le nom de la table principale de l'entité.
     * <br>
     * <br>Exemple :
     * <br>- FISHING_TRIP
     * <br>- SALE
     * <br>- PRODUCE
     * </p>
     * <p>
     * - etc.
     * </p>
     * </body>
     * </html>
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Type d'entité supprimée.
     * </p>
     * <p>
     * Généralement, on utilise le nom de la table principale de l'entité.
     * <br>
     * <br>Exemple :
     * <br>- FISHING_TRIP
     * <br>- SALE
     * <br>- PRODUCE
     * </p>
     * <p>
     * - etc.
     * </p>
     * </body>
     * </html>
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    private ProcessingHistory processingHistory;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Historique des traitements, qu’il s’agisse de flux (comme historiquement
     * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
     * </p>
     * <p>
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * Permet donc de conserver l'historique des traitements qui se sont
     * exécutés sur le système, notamment ceux qui ont impactés la base de
     * données brutes (Adagio).
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * L’exécution des traitements en erreur peuvent également être tracée.
     * </p>
     * </body>
     * </html>
     * @return this.processingHistory ProcessingHistory
     */
    public ProcessingHistory getProcessingHistory()
    {
        return this.processingHistory;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Historique des traitements, qu’il s’agisse de flux (comme historiquement
     * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
     * </p>
     * <p>
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * Permet donc de conserver l'historique des traitements qui se sont
     * exécutés sur le système, notamment ceux qui ont impactés la base de
     * données brutes (Adagio).
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * L’exécution des traitements en erreur peuvent également être tracée.
     * </p>
     * </body>
     * </html>
     * @param processingHistoryIn ProcessingHistory
     */
    public void setProcessingHistory(ProcessingHistory processingHistoryIn)
    {
        this.processingHistory = processingHistoryIn;
    }

    /**
     * Returns <code>true</code> if the argument is an DeletedItemHistory instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DeletedItemHistory))
        {
            return false;
        }
        final DeletedItemHistory that = (DeletedItemHistory)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link DeletedItemHistory}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DeletedItemHistory}.
         * @return new DeletedItemHistoryImpl()
         */
        public static DeletedItemHistory newInstance()
        {
            return new DeletedItemHistoryImpl();
        }

        /**
         * Constructs a new instance of {@link DeletedItemHistory}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param updateDate Timestamp
         * @param objectType ObjectType
         * @return newInstance
         */
        public static DeletedItemHistory newInstance(Timestamp updateDate, ObjectType objectType)
        {
            final DeletedItemHistory entity = new DeletedItemHistoryImpl();
            entity.setUpdateDate(updateDate);
            entity.setObjectType(objectType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DeletedItemHistory}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param vesselCode String
         * @param objectId Long
         * @param objectCode String
         * @param comments String
         * @param updateDate Timestamp
         * @param program Program
         * @param recorderDepartment Department
         * @param recorderPerson Person
         * @param objectType ObjectType
         * @param processingHistory ProcessingHistory
         * @return newInstance DeletedItemHistory
         */
        public static DeletedItemHistory newInstance(String vesselCode, Long objectId, String objectCode, String comments, Timestamp updateDate, Program program, Department recorderDepartment, Person recorderPerson, ObjectType objectType, ProcessingHistory processingHistory)
        {
            final DeletedItemHistory entity = new DeletedItemHistoryImpl();
            entity.setVesselCode(vesselCode);
            entity.setObjectId(objectId);
            entity.setObjectCode(objectCode);
            entity.setComments(comments);
            entity.setUpdateDate(updateDate);
            entity.setProgram(program);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setRecorderPerson(recorderPerson);
            entity.setObjectType(objectType);
            entity.setProcessingHistory(processingHistory);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DeletedItemHistory o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getVesselCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getVesselCode().compareTo(o.getVesselCode()));
            }
            if (this.getObjectId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectId().compareTo(o.getObjectId()));
            }
            if (this.getObjectCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectCode().compareTo(o.getObjectCode()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DeletedItemHistory.java merge-point
}