// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.history;

import fr.ifremer.adagio.core.dao.referential.ProcessingStatus;
import fr.ifremer.adagio.core.dao.referential.ProcessingType;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Historique des traitements, qu’il s’agisse de flux (comme historiquement
 * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
 * </p>
 * <p>
 * </p>
 * <p style="font-family:Times New
 * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
 * Permet donc de conserver l'historique des traitements qui se sont
 * exécutés sur le système, notamment ceux qui ont impactés la base de
 * données brutes (Adagio).
 * </p>
 * <p style="font-family:Times New
 * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
 * </p>
 * <p style="font-family:Times New
 * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
 * L’exécution des traitements en erreur peuvent également être tracée.
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ProcessingHistory
    implements Serializable, Comparable<ProcessingHistory>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8694900000735826282L;

    // Generate 10 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String name;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * Nom du traitement, unique pour un type de traitement donné.
     * Par exemple, pour un traitement d'importation le nom du flux est le nom du
     * fichier reçu par mail. Ce fichier peut lui même référencer plusieurs
     * fichiers qui composent le flux (Exemple : flux IDROLE).
     * </body>
     * </html>
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * Nom du traitement, unique pour un type de traitement donné.
     * Par exemple, pour un traitement d'importation le nom du flux est le nom du
     * fichier reçu par mail. Ce fichier peut lui même référencer plusieurs
     * fichiers qui composent le flux (Exemple : flux IDROLE).
     * </body>
     * </html>
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private Date processingDate;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Date d'execution du traitement.
     * </p>
     * <p>
     * g&#233;n&#233;ralement, la date de fin du traitement, renseign&#233; via <i>sysdate.</i>
     * </p>
     * </body>
     * </html>
     * @return this.processingDate Date
     */
    public Date getProcessingDate()
    {
        return this.processingDate;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Date d'execution du traitement.
     * </p>
     * <p>
     * g&#233;n&#233;ralement, la date de fin du traitement, renseign&#233; via <i>sysdate.</i>
     * </p>
     * </body>
     * </html>
     * @param processingDateIn Date
     */
    public void setProcessingDate(Date processingDateIn)
    {
        this.processingDate = processingDateIn;
    }

    private String dataTransfertType;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * S'il s'agit d'un traitement manipulant des données (importation ou
     * exportation) : Type de transfert des données.
     * valeurs possibles : MAIL, FTP
     * </body>
     * </html>
     * @return this.dataTransfertType String
     */
    public String getDataTransfertType()
    {
        return this.dataTransfertType;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * S'il s'agit d'un traitement manipulant des données (importation ou
     * exportation) : Type de transfert des données.
     * valeurs possibles : MAIL, FTP
     * </body>
     * </html>
     * @param dataTransfertTypeIn String
     */
    public void setDataTransfertType(String dataTransfertTypeIn)
    {
        this.dataTransfertType = dataTransfertTypeIn;
    }

    private Date dataTransfertDate;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * S'il s'agit d'un traitement manipulant des données (importation ou
     * exportation) : Date du transfert des données vers de destinataire (pour
     * les flux en EXPORT) ou vers la base (pour les flux en IMPORT).
     * </body>
     * </html>
     * @return this.dataTransfertDate Date
     */
    public Date getDataTransfertDate()
    {
        return this.dataTransfertDate;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * S'il s'agit d'un traitement manipulant des données (importation ou
     * exportation) : Date du transfert des données vers de destinataire (pour
     * les flux en EXPORT) ou vers la base (pour les flux en IMPORT).
     * </body>
     * </html>
     * @param dataTransfertDateIn Date
     */
    public void setDataTransfertDate(Date dataTransfertDateIn)
    {
        this.dataTransfertDate = dataTransfertDateIn;
    }

    private String dataTransfertAddress;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * S'il s'agit d'un traitement manipulant des donn&#233;es (importation ou
     * exportation) : Information permettant de retrouver l'origine de la donn&#233;e.
     * <br><br>Par exemple : l'email de l'&#233;metteur, l'adresse FTP du fichier, etc.
     * </body>
     * </html>
     * @return this.dataTransfertAddress String
     */
    public String getDataTransfertAddress()
    {
        return this.dataTransfertAddress;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * S'il s'agit d'un traitement manipulant des donn&#233;es (importation ou
     * exportation) : Information permettant de retrouver l'origine de la donn&#233;e.
     * <br><br>Par exemple : l'email de l'&#233;metteur, l'adresse FTP du fichier, etc.
     * </body>
     * </html>
     * @param dataTransfertAddressIn String
     */
    public void setDataTransfertAddress(String dataTransfertAddressIn)
    {
        this.dataTransfertAddress = dataTransfertAddressIn;
    }

    private String configuration;

    /**
     * Configuration du traitement, par exemple les paramètres utilisés dans la ligne de commande.
     * @return this.configuration String
     */
    public String getConfiguration()
    {
        return this.configuration;
    }

    /**
     * Configuration du traitement, par exemple les paramètres utilisés dans la ligne de commande.
     * @param configurationIn String
     */
    public void setConfiguration(String configurationIn)
    {
        this.configuration = configurationIn;
    }

    private String xmlConfiguration;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * La configuration, sous forme XML (utilis&#233; par les traitements CQ
     * automatique)
     * </body>
     * </html>
     * @return this.xmlConfiguration String
     */
    public String getXmlConfiguration()
    {
        return this.xmlConfiguration;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * La configuration, sous forme XML (utilis&#233; par les traitements CQ
     * automatique)
     * </body>
     * </html>
     * @param xmlConfigurationIn String
     */
    public void setXmlConfiguration(String xmlConfigurationIn)
    {
        this.xmlConfiguration = xmlConfigurationIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private String xmlReport;

    /**
     * Use to store execution reports
     * @return this.xmlReport String
     */
    public String getXmlReport()
    {
        return this.xmlReport;
    }

    /**
     * Use to store execution reports
     * @param xmlReportIn String
     */
    public void setXmlReport(String xmlReportIn)
    {
        this.xmlReport = xmlReportIn;
    }

    // Generate 8 associations
    private Collection<InsertedItemHistory> insertedItemHistories = new HashSet<InsertedItemHistory>();

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer également les insertions, notamment pour retrouver le
     * traitement de chargement associé (<i>ProcessingHistory</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les positions VMS, on trace le flux d'origine de la
     * donnée, grâce à cette classe.
     * </p>
     * </body>
     * </html>
     * @return this.insertedItemHistories Collection<InsertedItemHistory>
     */
    public Collection<InsertedItemHistory> getInsertedItemHistories()
    {
        return this.insertedItemHistories;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer également les insertions, notamment pour retrouver le
     * traitement de chargement associé (<i>ProcessingHistory</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les positions VMS, on trace le flux d'origine de la
     * donnée, grâce à cette classe.
     * </p>
     * </body>
     * </html>
     * @param insertedItemHistoriesIn Collection<InsertedItemHistory>
     */
    public void setInsertedItemHistories(Collection<InsertedItemHistory> insertedItemHistoriesIn)
    {
        this.insertedItemHistories = insertedItemHistoriesIn;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer également les insertions, notamment pour retrouver le
     * traitement de chargement associé (<i>ProcessingHistory</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les positions VMS, on trace le flux d'origine de la
     * donnée, grâce à cette classe.
     * </p>
     * </body>
     * </html>
     * @param elementToAdd InsertedItemHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addInsertedItemHistories(InsertedItemHistory elementToAdd)
    {
        return this.insertedItemHistories.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer également les insertions, notamment pour retrouver le
     * traitement de chargement associé (<i>ProcessingHistory</i>).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : pour les positions VMS, on trace le flux d'origine de la
     * donnée, grâce à cette classe.
     * </p>
     * </body>
     * </html>
     * @param elementToRemove InsertedItemHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeInsertedItemHistories(InsertedItemHistory elementToRemove)
    {
        return this.insertedItemHistories.remove(elementToRemove);
    }

    private ProcessingType processingType;

    /**
     * Le type de traitement.
     * Pour une traitement d'exportation ou d'exportation, on peut par exemple avoir : SIH_IISTPE,
     * SIH_IIPORE, SIH_IINPOP, ...
     * @return this.processingType ProcessingType
     */
    public ProcessingType getProcessingType()
    {
        return this.processingType;
    }

    /**
     * Le type de traitement.
     * Pour une traitement d'exportation ou d'exportation, on peut par exemple avoir : SIH_IISTPE,
     * SIH_IIPORE, SIH_IINPOP, ...
     * @param processingTypeIn ProcessingType
     */
    public void setProcessingType(ProcessingType processingTypeIn)
    {
        this.processingType = processingTypeIn;
    }

    private ProcessingStatus processingStatus;

    /**
     * L'etat du traitement. Cela permet de tracer également les execution de traitement qui sont en
     * échec.
     * @return this.processingStatus ProcessingStatus
     */
    public ProcessingStatus getProcessingStatus()
    {
        return this.processingStatus;
    }

    /**
     * L'etat du traitement. Cela permet de tracer également les execution de traitement qui sont en
     * échec.
     * @param processingStatusIn ProcessingStatus
     */
    public void setProcessingStatus(ProcessingStatus processingStatusIn)
    {
        this.processingStatus = processingStatusIn;
    }

    private Collection<UpdatedItemHistory> updatedItemHistories = new HashSet<UpdatedItemHistory>();

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer les modifications intervenues dans sur une entité (une
     * marée, une vente, etc).
     * </p>
     * <p>
     * Les anciennes valeurs de l'entité y sont tracées. Pour la plupart, il
     * s'agit d'une valeur numérique, ou des liens vers les référentiels les
     * plus utilisés.
     * </p>
     * <p>
     * </p>
     * <p>
     * <b>Les modifications portant sur les dates ou champs alphanumériques ne
     * sont pas tracés. </b>Généralement, des modifications de ce type
     * correspond à une nouvelle donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un commentaire doit etre associé à chaque ligne, indiquant la l'objet de
     * l'opération de modification effectuée.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u><b>ATTENTION</b></u> : <i>recorderDepartment</i> et <i>recorderPerson</i>
     * ne sont pas les anciennes valeurs des champs de la donnée qui a été
     * modifiée, car ces champs ne devraient jamais être modifiée pour une
     * donnée (c’est le service/la personne ayant crée la donnée).
     * </p>
     * <p>
     * <b>Les champs <i>recorderDepartment</i> et <i>recorderPerson</i> de
     * ItemHistory sont remplis avec le service/la personne qui a fait la
     * modification.</b>
     * </p>
     * </body>
     * </html>
     * @return this.updatedItemHistories Collection<UpdatedItemHistory>
     */
    public Collection<UpdatedItemHistory> getUpdatedItemHistories()
    {
        return this.updatedItemHistories;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer les modifications intervenues dans sur une entité (une
     * marée, une vente, etc).
     * </p>
     * <p>
     * Les anciennes valeurs de l'entité y sont tracées. Pour la plupart, il
     * s'agit d'une valeur numérique, ou des liens vers les référentiels les
     * plus utilisés.
     * </p>
     * <p>
     * </p>
     * <p>
     * <b>Les modifications portant sur les dates ou champs alphanumériques ne
     * sont pas tracés. </b>Généralement, des modifications de ce type
     * correspond à une nouvelle donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un commentaire doit etre associé à chaque ligne, indiquant la l'objet de
     * l'opération de modification effectuée.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u><b>ATTENTION</b></u> : <i>recorderDepartment</i> et <i>recorderPerson</i>
     * ne sont pas les anciennes valeurs des champs de la donnée qui a été
     * modifiée, car ces champs ne devraient jamais être modifiée pour une
     * donnée (c’est le service/la personne ayant crée la donnée).
     * </p>
     * <p>
     * <b>Les champs <i>recorderDepartment</i> et <i>recorderPerson</i> de
     * ItemHistory sont remplis avec le service/la personne qui a fait la
     * modification.</b>
     * </p>
     * </body>
     * </html>
     * @param updatedItemHistoriesIn Collection<UpdatedItemHistory>
     */
    public void setUpdatedItemHistories(Collection<UpdatedItemHistory> updatedItemHistoriesIn)
    {
        this.updatedItemHistories = updatedItemHistoriesIn;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer les modifications intervenues dans sur une entité (une
     * marée, une vente, etc).
     * </p>
     * <p>
     * Les anciennes valeurs de l'entité y sont tracées. Pour la plupart, il
     * s'agit d'une valeur numérique, ou des liens vers les référentiels les
     * plus utilisés.
     * </p>
     * <p>
     * </p>
     * <p>
     * <b>Les modifications portant sur les dates ou champs alphanumériques ne
     * sont pas tracés. </b>Généralement, des modifications de ce type
     * correspond à une nouvelle donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un commentaire doit etre associé à chaque ligne, indiquant la l'objet de
     * l'opération de modification effectuée.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u><b>ATTENTION</b></u> : <i>recorderDepartment</i> et <i>recorderPerson</i>
     * ne sont pas les anciennes valeurs des champs de la donnée qui a été
     * modifiée, car ces champs ne devraient jamais être modifiée pour une
     * donnée (c’est le service/la personne ayant crée la donnée).
     * </p>
     * <p>
     * <b>Les champs <i>recorderDepartment</i> et <i>recorderPerson</i> de
     * ItemHistory sont remplis avec le service/la personne qui a fait la
     * modification.</b>
     * </p>
     * </body>
     * </html>
     * @param elementToAdd UpdatedItemHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addUpdatedItemHistories(UpdatedItemHistory elementToAdd)
    {
        return this.updatedItemHistories.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de tracer les modifications intervenues dans sur une entité (une
     * marée, une vente, etc).
     * </p>
     * <p>
     * Les anciennes valeurs de l'entité y sont tracées. Pour la plupart, il
     * s'agit d'une valeur numérique, ou des liens vers les référentiels les
     * plus utilisés.
     * </p>
     * <p>
     * </p>
     * <p>
     * <b>Les modifications portant sur les dates ou champs alphanumériques ne
     * sont pas tracés. </b>Généralement, des modifications de ce type
     * correspond à une nouvelle donnée.
     * </p>
     * <p>
     * </p>
     * <p>
     * Un commentaire doit etre associé à chaque ligne, indiquant la l'objet de
     * l'opération de modification effectuée.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u><b>ATTENTION</b></u> : <i>recorderDepartment</i> et <i>recorderPerson</i>
     * ne sont pas les anciennes valeurs des champs de la donnée qui a été
     * modifiée, car ces champs ne devraient jamais être modifiée pour une
     * donnée (c’est le service/la personne ayant crée la donnée).
     * </p>
     * <p>
     * <b>Les champs <i>recorderDepartment</i> et <i>recorderPerson</i> de
     * ItemHistory sont remplis avec le service/la personne qui a fait la
     * modification.</b>
     * </p>
     * </body>
     * </html>
     * @param elementToRemove UpdatedItemHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeUpdatedItemHistories(UpdatedItemHistory elementToRemove)
    {
        return this.updatedItemHistories.remove(elementToRemove);
    }

    private Collection<DeletedItemHistory> deletedItemHistories = new HashSet<DeletedItemHistory>();

    /**
     * Permet de tracer les suppressions d’entités (marée, vente, etc), notamment afin que ces
     * suppressions
     * soient importées dans les bases locales d'Allegro.
     * @return this.deletedItemHistories Collection<DeletedItemHistory>
     */
    public Collection<DeletedItemHistory> getDeletedItemHistories()
    {
        return this.deletedItemHistories;
    }

    /**
     * Permet de tracer les suppressions d’entités (marée, vente, etc), notamment afin que ces
     * suppressions
     * soient importées dans les bases locales d'Allegro.
     * @param deletedItemHistoriesIn Collection<DeletedItemHistory>
     */
    public void setDeletedItemHistories(Collection<DeletedItemHistory> deletedItemHistoriesIn)
    {
        this.deletedItemHistories = deletedItemHistoriesIn;
    }

    /**
     * Permet de tracer les suppressions d’entités (marée, vente, etc), notamment afin que ces
     * suppressions
     * soient importées dans les bases locales d'Allegro.
     * @param elementToAdd DeletedItemHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addDeletedItemHistories(DeletedItemHistory elementToAdd)
    {
        return this.deletedItemHistories.add(elementToAdd);
    }

    /**
     * Permet de tracer les suppressions d’entités (marée, vente, etc), notamment afin que ces
     * suppressions
     * soient importées dans les bases locales d'Allegro.
     * @param elementToRemove DeletedItemHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeDeletedItemHistories(DeletedItemHistory elementToRemove)
    {
        return this.deletedItemHistories.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an ProcessingHistory instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ProcessingHistory))
        {
            return false;
        }
        final ProcessingHistory that = (ProcessingHistory)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ProcessingHistory}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ProcessingHistory}.
         * @return new ProcessingHistoryImpl()
         */
        public static ProcessingHistory newInstance()
        {
            return new ProcessingHistoryImpl();
        }

        /**
         * Constructs a new instance of {@link ProcessingHistory}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param name String
         * @param processingDate Date
         * @param updateDate Timestamp
         * @param processingType ProcessingType
         * @param processingStatus ProcessingStatus
         * @return newInstance
         */
        public static ProcessingHistory newInstance(String name, Date processingDate, Timestamp updateDate, ProcessingType processingType, ProcessingStatus processingStatus)
        {
            final ProcessingHistory entity = new ProcessingHistoryImpl();
            entity.setName(name);
            entity.setProcessingDate(processingDate);
            entity.setUpdateDate(updateDate);
            entity.setProcessingType(processingType);
            entity.setProcessingStatus(processingStatus);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ProcessingHistory}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param name String
         * @param processingDate Date
         * @param dataTransfertType String
         * @param dataTransfertDate Date
         * @param dataTransfertAddress String
         * @param configuration String
         * @param xmlConfiguration String
         * @param updateDate Timestamp
         * @param xmlReport String
         * @param insertedItemHistories Collection<InsertedItemHistory>
         * @param processingType ProcessingType
         * @param processingStatus ProcessingStatus
         * @param updatedItemHistories Collection<UpdatedItemHistory>
         * @param deletedItemHistories Collection<DeletedItemHistory>
         * @return newInstance ProcessingHistory
         */
        public static ProcessingHistory newInstance(String name, Date processingDate, String dataTransfertType, Date dataTransfertDate, String dataTransfertAddress, String configuration, String xmlConfiguration, Timestamp updateDate, String xmlReport, Collection<InsertedItemHistory> insertedItemHistories, ProcessingType processingType, ProcessingStatus processingStatus, Collection<UpdatedItemHistory> updatedItemHistories, Collection<DeletedItemHistory> deletedItemHistories)
        {
            final ProcessingHistory entity = new ProcessingHistoryImpl();
            entity.setName(name);
            entity.setProcessingDate(processingDate);
            entity.setDataTransfertType(dataTransfertType);
            entity.setDataTransfertDate(dataTransfertDate);
            entity.setDataTransfertAddress(dataTransfertAddress);
            entity.setConfiguration(configuration);
            entity.setXmlConfiguration(xmlConfiguration);
            entity.setUpdateDate(updateDate);
            entity.setXmlReport(xmlReport);
            entity.setInsertedItemHistories(insertedItemHistories);
            entity.setProcessingType(processingType);
            entity.setProcessingStatus(processingStatus);
            entity.setUpdatedItemHistories(updatedItemHistories);
            entity.setDeletedItemHistories(deletedItemHistories);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ProcessingHistory o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getProcessingDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getProcessingDate().compareTo(o.getProcessingDate()));
            }
            if (this.getDataTransfertType() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDataTransfertType().compareTo(o.getDataTransfertType()));
            }
            if (this.getDataTransfertDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDataTransfertDate().compareTo(o.getDataTransfertDate()));
            }
            if (this.getDataTransfertAddress() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDataTransfertAddress().compareTo(o.getDataTransfertAddress()));
            }
            if (this.getConfiguration() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getConfiguration().compareTo(o.getConfiguration()));
            }
            if (this.getXmlConfiguration() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getXmlConfiguration().compareTo(o.getXmlConfiguration()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getXmlReport() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getXmlReport().compareTo(o.getXmlReport()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ProcessingHistory.java merge-point
}