// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.history;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.ProcessingStatus;
import fr.ifremer.adagio.core.dao.referential.ProcessingType;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Historique des traitements, qu’il s’agisse de flux (comme historiquement
 * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
 * </p>
 * <p>
 * </p>
 * <p style="font-family:Times New
 * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
 * Permet donc de conserver l'historique des traitements qui se sont
 * exécutés sur le système, notamment ceux qui ont impactés la base de
 * données brutes (Adagio).
 * </p>
 * <p style="font-family:Times New
 * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
 * </p>
 * <p style="font-family:Times New
 * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
 * L’exécution des traitements en erreur peuvent également être tracée.
 * </p>
 * </body>
 * </html>
 * @see ProcessingHistory
 */
public interface ProcessingHistoryDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link ProcessingHistory}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of ProcessingHistory from the persistent store.
     * @param id
     * @return ProcessingHistory
     */
    public ProcessingHistory get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of ProcessingHistory from the persistent store.
     * @param id
     * @return ProcessingHistory
     */
    public ProcessingHistory load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link ProcessingHistory}.
     *
     * @return the loaded entities.
     */
    public Collection<ProcessingHistory> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of ProcessingHistory and adds it to the persistent store.
     * @param processingHistory
     * @return ProcessingHistory
     */
    public ProcessingHistory create(ProcessingHistory processingHistory);

    /**
     * <p>
     * Does the same thing as {@link #create(ProcessingHistory)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param processingHistory
     * @return Object
     */
    public Object create(int transform, ProcessingHistory processingHistory);

    /**
     * Creates a new instance of ProcessingHistory and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of ProcessingHistory
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<ProcessingHistory> create(Collection<ProcessingHistory> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(ProcessingHistory)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<ProcessingHistory> entities);

    /**
     * <p>
     * Creates a new <code>ProcessingHistory</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param name <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
Nom du traitement, unique pour un type de traitement donné.
Par exemple, pour un traitement d'importation le nom du flux est le nom du
fichier reçu par mail. Ce fichier peut lui même référencer plusieurs
fichiers qui composent le flux (Exemple : flux IDROLE).
</body>
</html>
     * @param processingDate <html>
<head>
</head>
<body>
<p>
Date d'execution du traitement.
</p>
<p>
g&#233;n&#233;ralement, la date de fin du traitement, renseign&#233; via <i>sysdate.</i>
</p>
</body>
</html>
     * @param dataTransfertType <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
S'il s'agit d'un traitement manipulant des données (importation ou
exportation) : Type de transfert des données.
valeurs possibles : MAIL, FTP
</body>
</html>
     * @param dataTransfertDate <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
S'il s'agit d'un traitement manipulant des données (importation ou
exportation) : Date du transfert des données vers de destinataire (pour
les flux en EXPORT) ou vers la base (pour les flux en IMPORT).
</body>
</html>
     * @param dataTransfertAddress <html>
<head>
</head>
<body>
S'il s'agit d'un traitement manipulant des donn&#233;es (importation ou
exportation) : Information permettant de retrouver l'origine de la donn&#233;e.
<br><br>Par exemple : l'email de l'&#233;metteur, l'adresse FTP du fichier, etc.
</body>
</html>
     * @param configuration Configuration du traitement, par exemple les paramètres utilisés dans la ligne de commande.
     * @param xmlConfiguration <html>
<head>
</head>
<body>
La configuration, sous forme XML (utilis&#233; par les traitements CQ
automatique)
</body>
</html>
     * @param updateDate 
     * @param xmlReport Use to store execution reports
     * @return ProcessingHistory
     */
    public ProcessingHistory create(
        String name,
        Date processingDate,
        String dataTransfertType,
        Date dataTransfertDate,
        String dataTransfertAddress,
        String configuration,
        String xmlConfiguration,
        Timestamp updateDate,
        String xmlReport);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, String, Date, String, String, String, Timestamp, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param name <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
Nom du traitement, unique pour un type de traitement donné.
Par exemple, pour un traitement d'importation le nom du flux est le nom du
fichier reçu par mail. Ce fichier peut lui même référencer plusieurs
fichiers qui composent le flux (Exemple : flux IDROLE).
</body>
</html>
     * @param processingDate <html>
<head>
</head>
<body>
<p>
Date d'execution du traitement.
</p>
<p>
g&#233;n&#233;ralement, la date de fin du traitement, renseign&#233; via <i>sysdate.</i>
</p>
</body>
</html>
     * @param dataTransfertType <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
S'il s'agit d'un traitement manipulant des données (importation ou
exportation) : Type de transfert des données.
valeurs possibles : MAIL, FTP
</body>
</html>
     * @param dataTransfertDate <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
S'il s'agit d'un traitement manipulant des données (importation ou
exportation) : Date du transfert des données vers de destinataire (pour
les flux en EXPORT) ou vers la base (pour les flux en IMPORT).
</body>
</html>
     * @param dataTransfertAddress <html>
<head>
</head>
<body>
S'il s'agit d'un traitement manipulant des donn&#233;es (importation ou
exportation) : Information permettant de retrouver l'origine de la donn&#233;e.
<br><br>Par exemple : l'email de l'&#233;metteur, l'adresse FTP du fichier, etc.
</body>
</html>
     * @param configuration Configuration du traitement, par exemple les paramètres utilisés dans la ligne de commande.
     * @param xmlConfiguration <html>
<head>
</head>
<body>
La configuration, sous forme XML (utilis&#233; par les traitements CQ
automatique)
</body>
</html>
     * @param updateDate 
     * @param xmlReport Use to store execution reports
     * @return ProcessingHistory
     */
    public Object create(
        int transform,
        String name,
        Date processingDate,
        String dataTransfertType,
        Date dataTransfertDate,
        String dataTransfertAddress,
        String configuration,
        String xmlConfiguration,
        Timestamp updateDate,
        String xmlReport);

    /**
     * <p>
     * Creates a new <code>ProcessingHistory</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param name
     * @param processingDate
     * @param processingStatus
     * @param processingType
     * @param updateDate
     * @return ProcessingHistory
     */
    public ProcessingHistory create(
        String name,
        Date processingDate,
        ProcessingStatus processingStatus,
        ProcessingType processingType,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param name
     * @param processingDate
     * @param processingStatus
     * @param processingType
     * @param updateDate
     * @return Object
     */
    public Object create(
        int transform,
        String name,
        Date processingDate,
        ProcessingStatus processingStatus,
        ProcessingType processingType,
        Timestamp updateDate);

    /**
     * Updates the <code>processingHistory</code> instance in the persistent store.
     * @param processingHistory
     */
    public void update(ProcessingHistory processingHistory);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<ProcessingHistory> entities);

    /**
     * Removes the instance of ProcessingHistory from the persistent store.
     * @param processingHistory
     */
    public void remove(ProcessingHistory processingHistory);

    /**
     * Removes the instance of ProcessingHistory having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<ProcessingHistory> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<ProcessingHistory> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.history.ProcessingHistoryDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.history.ProcessingHistoryDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final ProcessingHistory entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,ProcessingHistory)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.history.ProcessingHistoryDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,ProcessingHistory)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}