// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.link;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.LinkedItemType;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Rapprochement d'une entité d'un type donné à une autre, qui peut etre ou
 * non du meme type.
 * </p>
 * <p>
 * </p>
 * <p>
 * Cette classe permet de gérer des objets ayant un identifiant numérique (<i>objectId</i>)
 * ou un code alphanumérique (<i>objectCode - exemple : Vessel</i>).
 * L'utilisiation du code ou de l'identifiant est exclusive.
 * </p>
 * <p>
 * </p>
 * <p>
 * Un rapprochement peut avoir une période de validité (Optionnel).
 * </p>
 * <p>
 * </p>
 * <p>
 * Exemple d'utilisation : A partir des données VMS, on récupère des
 * informations de navire (Pavillon, nom, dates, etc.) stockées sous la
 * forme d'un navire (Vessel + VesselRegistrationPeriod, etc); après
 * chargement des données VMS, un outil de rapprochement permet de
 * retrouver (ou pas) le navire du fichier flotte national correspondant.
 * La correspondance trouvée est stockée dans <i>LinkedItem</i>.
 * A l'exportation des données VMS depuis Adagio, cela permet de restituer
 * les informations sur le navire telle que présentes dans le flux VMS
 * d'origine.
 * </p>
 * </body>
 * </html>
 * @see LinkedItem
 */
public interface LinkedItemDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link LinkedItem}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of LinkedItem from the persistent store.
     * @param id
     * @return LinkedItem
     */
    public LinkedItem get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of LinkedItem from the persistent store.
     * @param id
     * @return LinkedItem
     */
    public LinkedItem load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link LinkedItem}.
     *
     * @return the loaded entities.
     */
    public Collection<LinkedItem> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of LinkedItem and adds it to the persistent store.
     * @param linkedItem
     * @return LinkedItem
     */
    public LinkedItem create(LinkedItem linkedItem);

    /**
     * <p>
     * Does the same thing as {@link #create(LinkedItem)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param linkedItem
     * @return Object
     */
    public Object create(int transform, LinkedItem linkedItem);

    /**
     * Creates a new instance of LinkedItem and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of LinkedItem
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<LinkedItem> create(Collection<LinkedItem> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(LinkedItem)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<LinkedItem> entities);

    /**
     * <p>
     * Creates a new <code>LinkedItem</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param fromObjectId <html>
<head>
</head>
<body>
<p>
Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
</p>
<p>
Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
<i>LinkedItemType.fromObjectType</i>.
</p>
</body>
</html>
     * @param fromObjectCode 
     * @param toObjectId <html>
<head>
</head>
<body>
<p>
Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
</p>
<p>
Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
<i>LinkedItemType.toObjectType</i>.
</p>
</body>
</html>
     * @param toObjectCode 
     * @param startDate Date de début de validité du rapprochement (optionnel).
     * @param endDate Date de fin de validité du rapprochement (optionnel).
Doit être vide, si startDate est vide.
     * @param updateDate Date de dernière modification (Mise à jour automatiquement par le système).
     * @return LinkedItem
     */
    public LinkedItem create(
        Integer fromObjectId,
        String fromObjectCode,
        Integer toObjectId,
        String toObjectCode,
        Date startDate,
        Date endDate,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer, String, Integer, String, Date, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param fromObjectId <html>
<head>
</head>
<body>
<p>
Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
</p>
<p>
Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
<i>LinkedItemType.fromObjectType</i>.
</p>
</body>
</html>
     * @param fromObjectCode 
     * @param toObjectId <html>
<head>
</head>
<body>
<p>
Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
</p>
<p>
Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
<i>LinkedItemType.toObjectType</i>.
</p>
</body>
</html>
     * @param toObjectCode 
     * @param startDate Date de début de validité du rapprochement (optionnel).
     * @param endDate Date de fin de validité du rapprochement (optionnel).
Doit être vide, si startDate est vide.
     * @param updateDate Date de dernière modification (Mise à jour automatiquement par le système).
     * @return LinkedItem
     */
    public Object create(
        int transform,
        Integer fromObjectId,
        String fromObjectCode,
        Integer toObjectId,
        String toObjectCode,
        Date startDate,
        Date endDate,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>LinkedItem</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param linkedItemType
     * @param qualityFlag
     * @param updateDate
     * @return LinkedItem
     */
    public LinkedItem create(
        LinkedItemType linkedItemType,
        QualityFlag qualityFlag,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param linkedItemType
     * @param qualityFlag
     * @param updateDate
     * @return Object
     */
    public Object create(
        int transform,
        LinkedItemType linkedItemType,
        QualityFlag qualityFlag,
        Timestamp updateDate);

    /**
     * Updates the <code>linkedItem</code> instance in the persistent store.
     * @param linkedItem
     */
    public void update(LinkedItem linkedItem);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<LinkedItem> entities);

    /**
     * Removes the instance of LinkedItem from the persistent store.
     * @param linkedItem
     */
    public void remove(LinkedItem linkedItem);

    /**
     * Removes the instance of LinkedItem having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<LinkedItem> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<LinkedItem> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.link.LinkedItemDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.link.LinkedItemDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final LinkedItem entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,LinkedItem)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.link.LinkedItemDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,LinkedItem)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}