// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.measure;

import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.data.vessel.feature.use.GearUseFeatures;
import fr.ifremer.adagio.core.dao.referential.AnalysisInstrument;
import fr.ifremer.adagio.core.dao.referential.NumericalPrecision;
import fr.ifremer.adagio.core.dao.referential.PrecisionType;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel;
import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import java.util.Date;

/**
 * 
 */
// HibernateEntity.vsl annotations merge-point
public abstract class GearUseMeasurement
    extends MeasurementImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 4462466354869087920L;

    // Generate 0 attributes
    // Generate 1 associations
    private GearUseFeatures gearUseFeatures;

    /**
     * Paramètre de mise en oeuvre de l'engin durant une opération.
     * Exemple de paramètre de mise en oeuvre:
     * • nombre de boués,
     * • type de panneau,
     * • présence d'un racasseur,
     * • nombre de casier.
     * mais aussi :
     * • profondeur moyenne de l'engin,
     * • vitesse de traine moyenne
     * • ouverture du chalut
     * @return this.gearUseFeatures GearUseFeatures
     */
    public GearUseFeatures getGearUseFeatures()
    {
        return this.gearUseFeatures;
    }

    /**
     * Paramètre de mise en oeuvre de l'engin durant une opération.
     * Exemple de paramètre de mise en oeuvre:
     * • nombre de boués,
     * • type de panneau,
     * • présence d'un racasseur,
     * • nombre de casier.
     * mais aussi :
     * • profondeur moyenne de l'engin,
     * • vitesse de traine moyenne
     * • ouverture du chalut
     * @param gearUseFeaturesIn GearUseFeatures
     */
    public void setGearUseFeatures(GearUseFeatures gearUseFeaturesIn)
    {
        this.gearUseFeatures = gearUseFeaturesIn;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link GearUseMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link GearUseMeasurement}.
         * @return new GearUseMeasurementImpl()
         */
        public static GearUseMeasurement newInstance()
        {
            return new GearUseMeasurementImpl();
        }

        /**
         * Constructs a new instance of {@link GearUseMeasurement}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param qualityFlag QualityFlag
         * @param pmfm Pmfm
         * @param gearUseFeatures GearUseFeatures
         * @return newInstance
         */
        public static GearUseMeasurement newInstance(QualityFlag qualityFlag, Pmfm pmfm, GearUseFeatures gearUseFeatures)
        {
            final GearUseMeasurement entity = new GearUseMeasurementImpl();
            entity.setQualityFlag(qualityFlag);
            entity.setPmfm(pmfm);
            entity.setGearUseFeatures(gearUseFeatures);
            return entity;
        }

        /**
         * Constructs a new instance of {@link GearUseMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param numericalValue Float
         * @param alphanumericalValue String
         * @param digitCount Integer
         * @param precisionValue Float
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param aggregationLevel AggregationLevel
         * @param qualitativeValue QualitativeValue
         * @param qualityFlag QualityFlag
         * @param precisionType PrecisionType
         * @param analysisInstrument AnalysisInstrument
         * @param pmfm Pmfm
         * @param department Department
         * @param numericalPrecision NumericalPrecision
         * @param gearUseFeatures GearUseFeatures
         * @return newInstance GearUseMeasurement
         */
        public static GearUseMeasurement newInstance(Float numericalValue, String alphanumericalValue, Integer digitCount, Float precisionValue, Date controlDate, Date validationDate, Date qualificationDate, String qualificationComments, AggregationLevel aggregationLevel, QualitativeValue qualitativeValue, QualityFlag qualityFlag, PrecisionType precisionType, AnalysisInstrument analysisInstrument, Pmfm pmfm, Department department, NumericalPrecision numericalPrecision, GearUseFeatures gearUseFeatures)
        {
            final GearUseMeasurement entity = new GearUseMeasurementImpl();
            entity.setNumericalValue(numericalValue);
            entity.setAlphanumericalValue(alphanumericalValue);
            entity.setDigitCount(digitCount);
            entity.setPrecisionValue(precisionValue);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setAggregationLevel(aggregationLevel);
            entity.setQualitativeValue(qualitativeValue);
            entity.setQualityFlag(qualityFlag);
            entity.setPrecisionType(precisionType);
            entity.setAnalysisInstrument(analysisInstrument);
            entity.setPmfm(pmfm);
            entity.setDepartment(department);
            entity.setNumericalPrecision(numericalPrecision);
            entity.setGearUseFeatures(gearUseFeatures);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(GearUseMeasurement o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// GearUseMeasurement.java merge-point
}