// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.measure;

import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.data.sale.ExpectedSale;
import fr.ifremer.adagio.core.dao.data.survey.sale.Sale;
import fr.ifremer.adagio.core.dao.referential.AnalysisInstrument;
import fr.ifremer.adagio.core.dao.referential.NumericalPrecision;
import fr.ifremer.adagio.core.dao.referential.PrecisionType;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel;
import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import java.util.Date;

/**
 * Caractéristiques sur la vente (données economiques, ou caractéristiques de l'observation, etc.).
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SaleMeasurement
    extends MeasurementImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -8531875261997866308L;

    // Generate 0 attributes
    // Generate 2 associations
    private Sale sale;

    /**
     * Vente liée à un navire, effectuée en un lieu et une date données. Une vente regroupe
     * plusieurs
     * produits vendus (Produce).
     * Attention : une vente est ponctuelle dans le temps. Si l'on souhaite recencer une vente qui
     * s'étale
     * sur plusieurs jours,
     * @return this.sale Sale
     */
    public Sale getSale()
    {
        return this.sale;
    }

    /**
     * Vente liée à un navire, effectuée en un lieu et une date données. Une vente regroupe
     * plusieurs
     * produits vendus (Produce).
     * Attention : une vente est ponctuelle dans le temps. Si l'on souhaite recencer une vente qui
     * s'étale
     * sur plusieurs jours,
     * @param saleIn Sale
     */
    public void setSale(Sale saleIn)
    {
        this.sale = saleIn;
    }

    private ExpectedSale expectedSale;

    /**
     * Mode de vente escompté (d’une marée observée ou d'un débarquement observé).
     * @return this.expectedSale ExpectedSale
     */
    public ExpectedSale getExpectedSale()
    {
        return this.expectedSale;
    }

    /**
     * Mode de vente escompté (d’une marée observée ou d'un débarquement observé).
     * @param expectedSaleIn ExpectedSale
     */
    public void setExpectedSale(ExpectedSale expectedSaleIn)
    {
        this.expectedSale = expectedSaleIn;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link SaleMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SaleMeasurement}.
         * @return new SaleMeasurementImpl()
         */
        public static SaleMeasurement newInstance()
        {
            return new SaleMeasurementImpl();
        }

        /**
         * Constructs a new instance of {@link SaleMeasurement}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param qualityFlag QualityFlag
         * @param pmfm Pmfm
         * @return newInstance
         */
        public static SaleMeasurement newInstance(QualityFlag qualityFlag, Pmfm pmfm)
        {
            final SaleMeasurement entity = new SaleMeasurementImpl();
            entity.setQualityFlag(qualityFlag);
            entity.setPmfm(pmfm);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SaleMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param numericalValue Float
         * @param alphanumericalValue String
         * @param digitCount Integer
         * @param precisionValue Float
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param aggregationLevel AggregationLevel
         * @param qualitativeValue QualitativeValue
         * @param qualityFlag QualityFlag
         * @param precisionType PrecisionType
         * @param analysisInstrument AnalysisInstrument
         * @param pmfm Pmfm
         * @param department Department
         * @param numericalPrecision NumericalPrecision
         * @param sale Sale
         * @param expectedSale ExpectedSale
         * @return newInstance SaleMeasurement
         */
        public static SaleMeasurement newInstance(Float numericalValue, String alphanumericalValue, Integer digitCount, Float precisionValue, Date controlDate, Date validationDate, Date qualificationDate, String qualificationComments, AggregationLevel aggregationLevel, QualitativeValue qualitativeValue, QualityFlag qualityFlag, PrecisionType precisionType, AnalysisInstrument analysisInstrument, Pmfm pmfm, Department department, NumericalPrecision numericalPrecision, Sale sale, ExpectedSale expectedSale)
        {
            final SaleMeasurement entity = new SaleMeasurementImpl();
            entity.setNumericalValue(numericalValue);
            entity.setAlphanumericalValue(alphanumericalValue);
            entity.setDigitCount(digitCount);
            entity.setPrecisionValue(precisionValue);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setAggregationLevel(aggregationLevel);
            entity.setQualitativeValue(qualitativeValue);
            entity.setQualityFlag(qualityFlag);
            entity.setPrecisionType(precisionType);
            entity.setAnalysisInstrument(analysisInstrument);
            entity.setPmfm(pmfm);
            entity.setDepartment(department);
            entity.setNumericalPrecision(numericalPrecision);
            entity.setSale(sale);
            entity.setExpectedSale(expectedSale);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SaleMeasurement o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SaleMeasurement.java merge-point
}