// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.measure;

import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.data.samplingScheme.SamplingStrata;
import fr.ifremer.adagio.core.dao.referential.AnalysisInstrument;
import fr.ifremer.adagio.core.dao.referential.NumericalPrecision;
import fr.ifremer.adagio.core.dao.referential.PrecisionType;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel;
import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import java.util.Date;

/**
 * Caratéristiques de la straté d'échantillonnage, en terme de valeurs sur PSFM.
 * @since v3.2.0
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SamplingStrataMeasurement
    extends MeasurementImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -3806196333414576799L;

    // Generate 0 attributes
    // Generate 1 associations
    private SamplingStrata samplingStrata;

    /**
     * Représente une ligne du plan d'échantillonnage.
     * @since v3.2.0
     * @return this.samplingStrata SamplingStrata
     */
    public SamplingStrata getSamplingStrata()
    {
        return this.samplingStrata;
    }

    /**
     * Représente une ligne du plan d'échantillonnage.
     * @since v3.2.0
     * @param samplingStrataIn SamplingStrata
     */
    public void setSamplingStrata(SamplingStrata samplingStrataIn)
    {
        this.samplingStrata = samplingStrataIn;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link SamplingStrataMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SamplingStrataMeasurement}.
         * @return new SamplingStrataMeasurementImpl()
         */
        public static SamplingStrataMeasurement newInstance()
        {
            return new SamplingStrataMeasurementImpl();
        }

        /**
         * Constructs a new instance of {@link SamplingStrataMeasurement}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param qualityFlag QualityFlag
         * @param pmfm Pmfm
         * @param samplingStrata SamplingStrata
         * @return newInstance
         */
        public static SamplingStrataMeasurement newInstance(QualityFlag qualityFlag, Pmfm pmfm, SamplingStrata samplingStrata)
        {
            final SamplingStrataMeasurement entity = new SamplingStrataMeasurementImpl();
            entity.setQualityFlag(qualityFlag);
            entity.setPmfm(pmfm);
            entity.setSamplingStrata(samplingStrata);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SamplingStrataMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param numericalValue Float
         * @param alphanumericalValue String
         * @param digitCount Integer
         * @param precisionValue Float
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param aggregationLevel AggregationLevel
         * @param qualitativeValue QualitativeValue
         * @param qualityFlag QualityFlag
         * @param precisionType PrecisionType
         * @param analysisInstrument AnalysisInstrument
         * @param pmfm Pmfm
         * @param department Department
         * @param numericalPrecision NumericalPrecision
         * @param samplingStrata SamplingStrata
         * @return newInstance SamplingStrataMeasurement
         */
        public static SamplingStrataMeasurement newInstance(Float numericalValue, String alphanumericalValue, Integer digitCount, Float precisionValue, Date controlDate, Date validationDate, Date qualificationDate, String qualificationComments, AggregationLevel aggregationLevel, QualitativeValue qualitativeValue, QualityFlag qualityFlag, PrecisionType precisionType, AnalysisInstrument analysisInstrument, Pmfm pmfm, Department department, NumericalPrecision numericalPrecision, SamplingStrata samplingStrata)
        {
            final SamplingStrataMeasurement entity = new SamplingStrataMeasurementImpl();
            entity.setNumericalValue(numericalValue);
            entity.setAlphanumericalValue(alphanumericalValue);
            entity.setDigitCount(digitCount);
            entity.setPrecisionValue(precisionValue);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setAggregationLevel(aggregationLevel);
            entity.setQualitativeValue(qualitativeValue);
            entity.setQualityFlag(qualityFlag);
            entity.setPrecisionType(precisionType);
            entity.setAnalysisInstrument(analysisInstrument);
            entity.setPmfm(pmfm);
            entity.setDepartment(department);
            entity.setNumericalPrecision(numericalPrecision);
            entity.setSamplingStrata(samplingStrata);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SamplingStrataMeasurement o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SamplingStrataMeasurement.java merge-point
}