// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.sale;

import fr.ifremer.adagio.core.dao.data.measure.SaleMeasurement;
import fr.ifremer.adagio.core.dao.data.produce.Produce;
import fr.ifremer.adagio.core.dao.data.survey.fishingTrip.ObservedFishingTrip;
import fr.ifremer.adagio.core.dao.data.survey.landing.ObservedLanding;
import fr.ifremer.adagio.core.dao.referential.SaleType;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.util.Collection;
import java.util.HashSet;

/**
 * Mode de vente escompté (d’une marée observée ou d'un débarquement observé).
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ExpectedSale
    implements Serializable, Comparable<ExpectedSale>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -8147956668148626076L;

    // Generate 1 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    // Generate 6 associations
    private Location saleLocation;

    /**
     * Lieu escompté de la vente.
     * @return this.saleLocation Location
     */
    public Location getSaleLocation()
    {
        return this.saleLocation;
    }

    /**
     * Lieu escompté de la vente.
     * @param saleLocationIn Location
     */
    public void setSaleLocation(Location saleLocationIn)
    {
        this.saleLocation = saleLocationIn;
    }

    private SaleType saleType;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Type de vente.
     * </p>
     * <p>
     * &#160;
     * </p>
     * <p>
     * Attention, mélange plusieurs aspects (comme le type de transaction, etc.).
     * </p>
     * <p>
     * Utiliser plutôt TakeOverType, puis détailler les autres composantes directement dans Produce
     * ou
     * ProduceSortingMeasurement
     * </p>
     * <p>
     * &#160;
     * </p>
     * <p>
     * @deprecated Use instead TakeOverType
     * </p>
     * </body>
     * </html>
     * @return this.saleType SaleType
     */
    public SaleType getSaleType()
    {
        return this.saleType;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Type de vente.
     * </p>
     * <p>
     * &#160;
     * </p>
     * <p>
     * Attention, mélange plusieurs aspects (comme le type de transaction, etc.).
     * </p>
     * <p>
     * Utiliser plutôt TakeOverType, puis détailler les autres composantes directement dans Produce
     * ou
     * ProduceSortingMeasurement
     * </p>
     * <p>
     * &#160;
     * </p>
     * <p>
     * @deprecated Use instead TakeOverType
     * </p>
     * </body>
     * </html>
     * @param saleTypeIn SaleType
     */
    public void setSaleType(SaleType saleTypeIn)
    {
        this.saleType = saleTypeIn;
    }

    private Collection<SaleMeasurement> saleMeasurements = new HashSet<SaleMeasurement>();

    /**
     * Caractéristiques sur la vente (données economiques, ou caractéristiques de l'observation,
     * etc.).
     * @return this.saleMeasurements Collection<SaleMeasurement>
     */
    public Collection<SaleMeasurement> getSaleMeasurements()
    {
        return this.saleMeasurements;
    }

    /**
     * Caractéristiques sur la vente (données economiques, ou caractéristiques de l'observation,
     * etc.).
     * @param saleMeasurementsIn Collection<SaleMeasurement>
     */
    public void setSaleMeasurements(Collection<SaleMeasurement> saleMeasurementsIn)
    {
        this.saleMeasurements = saleMeasurementsIn;
    }

    /**
     * Caractéristiques sur la vente (données economiques, ou caractéristiques de l'observation,
     * etc.).
     * @param elementToAdd SaleMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSaleMeasurements(SaleMeasurement elementToAdd)
    {
        return this.saleMeasurements.add(elementToAdd);
    }

    /**
     * Caractéristiques sur la vente (données economiques, ou caractéristiques de l'observation,
     * etc.).
     * @param elementToRemove SaleMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSaleMeasurements(SaleMeasurement elementToRemove)
    {
        return this.saleMeasurements.remove(elementToRemove);
    }

    private Collection<Produce> produces = new HashSet<Produce>();

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Un produit est identifi&#233; par une esp&#232;ce commerciale, un &#233;tat, une
     * qualit&#233;, pr&#233;sentation et cat&#233;gorie commerciale.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u>Si le produit est un &quot;produit vendu&quot; :</u>
     * </p>
     * <p>
     * On pourra allors utiliser SortingMeasurement pour stocker des donn&#233;es
     * &#233;conomiques, comme par exemple :
     * </p>
     * <p>
     * - Le prix du produit. Il peut y avoir plusieurds prix (plusieurs PSFMs),
     * par exemple : prix au kilo, et prix total en euros.
     * </p>
     * <p>
     * - Valorisation de la commercialisation : Label rouge, Eco Label, marque
     * collective control&#233;e par un organisme tier. (cf SACROIS)
     * </p>
     * <p>
     * - Destination commerciale : consommation humaine, consommation animale,
     * etc .
     * </p>
     * </body>
     * </html>
     * @return this.produces Collection<Produce>
     */
    public Collection<Produce> getProduces()
    {
        return this.produces;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Un produit est identifi&#233; par une esp&#232;ce commerciale, un &#233;tat, une
     * qualit&#233;, pr&#233;sentation et cat&#233;gorie commerciale.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u>Si le produit est un &quot;produit vendu&quot; :</u>
     * </p>
     * <p>
     * On pourra allors utiliser SortingMeasurement pour stocker des donn&#233;es
     * &#233;conomiques, comme par exemple :
     * </p>
     * <p>
     * - Le prix du produit. Il peut y avoir plusieurds prix (plusieurs PSFMs),
     * par exemple : prix au kilo, et prix total en euros.
     * </p>
     * <p>
     * - Valorisation de la commercialisation : Label rouge, Eco Label, marque
     * collective control&#233;e par un organisme tier. (cf SACROIS)
     * </p>
     * <p>
     * - Destination commerciale : consommation humaine, consommation animale,
     * etc .
     * </p>
     * </body>
     * </html>
     * @param producesIn Collection<Produce>
     */
    public void setProduces(Collection<Produce> producesIn)
    {
        this.produces = producesIn;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Un produit est identifi&#233; par une esp&#232;ce commerciale, un &#233;tat, une
     * qualit&#233;, pr&#233;sentation et cat&#233;gorie commerciale.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u>Si le produit est un &quot;produit vendu&quot; :</u>
     * </p>
     * <p>
     * On pourra allors utiliser SortingMeasurement pour stocker des donn&#233;es
     * &#233;conomiques, comme par exemple :
     * </p>
     * <p>
     * - Le prix du produit. Il peut y avoir plusieurds prix (plusieurs PSFMs),
     * par exemple : prix au kilo, et prix total en euros.
     * </p>
     * <p>
     * - Valorisation de la commercialisation : Label rouge, Eco Label, marque
     * collective control&#233;e par un organisme tier. (cf SACROIS)
     * </p>
     * <p>
     * - Destination commerciale : consommation humaine, consommation animale,
     * etc .
     * </p>
     * </body>
     * </html>
     * @param elementToAdd Produce
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addProduces(Produce elementToAdd)
    {
        return this.produces.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Un produit est identifi&#233; par une esp&#232;ce commerciale, un &#233;tat, une
     * qualit&#233;, pr&#233;sentation et cat&#233;gorie commerciale.
     * </p>
     * <p>
     * </p>
     * <p>
     * <u>Si le produit est un &quot;produit vendu&quot; :</u>
     * </p>
     * <p>
     * On pourra allors utiliser SortingMeasurement pour stocker des donn&#233;es
     * &#233;conomiques, comme par exemple :
     * </p>
     * <p>
     * - Le prix du produit. Il peut y avoir plusieurds prix (plusieurs PSFMs),
     * par exemple : prix au kilo, et prix total en euros.
     * </p>
     * <p>
     * - Valorisation de la commercialisation : Label rouge, Eco Label, marque
     * collective control&#233;e par un organisme tier. (cf SACROIS)
     * </p>
     * <p>
     * - Destination commerciale : consommation humaine, consommation animale,
     * etc .
     * </p>
     * </body>
     * </html>
     * @param elementToRemove Produce
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeProduces(Produce elementToRemove)
    {
        return this.produces.remove(elementToRemove);
    }

    private ObservedLanding observedLanding;

    /**
     * 
     * @return this.observedLanding ObservedLanding
     */
    public ObservedLanding getObservedLanding()
    {
        return this.observedLanding;
    }

    /**
     * 
     * @param observedLandingIn ObservedLanding
     */
    public void setObservedLanding(ObservedLanding observedLandingIn)
    {
        this.observedLanding = observedLandingIn;
    }

    private ObservedFishingTrip observedFishingTrip;

    /**
     * Marée observée au cours de laquelle ont été recueillies les données de ventes escomptées.
     * @return this.observedFishingTrip ObservedFishingTrip
     */
    public ObservedFishingTrip getObservedFishingTrip()
    {
        return this.observedFishingTrip;
    }

    /**
     * Marée observée au cours de laquelle ont été recueillies les données de ventes escomptées.
     * @param observedFishingTripIn ObservedFishingTrip
     */
    public void setObservedFishingTrip(ObservedFishingTrip observedFishingTripIn)
    {
        this.observedFishingTrip = observedFishingTripIn;
    }

    /**
     * Returns <code>true</code> if the argument is an ExpectedSale instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ExpectedSale))
        {
            return false;
        }
        final ExpectedSale that = (ExpectedSale)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ExpectedSale}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ExpectedSale}.
         * @return new ExpectedSaleImpl()
         */
        public static ExpectedSale newInstance()
        {
            return new ExpectedSaleImpl();
        }

        /**
         * Constructs a new instance of {@link ExpectedSale}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param saleLocation Location
         * @param saleType SaleType
         * @return newInstance
         */
        public static ExpectedSale newInstance(Location saleLocation, SaleType saleType)
        {
            final ExpectedSale entity = new ExpectedSaleImpl();
            entity.setSaleLocation(saleLocation);
            entity.setSaleType(saleType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ExpectedSale}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param saleLocation Location
         * @param saleType SaleType
         * @param saleMeasurements Collection<SaleMeasurement>
         * @param produces Collection<Produce>
         * @param observedLanding ObservedLanding
         * @param observedFishingTrip ObservedFishingTrip
         * @return newInstance ExpectedSale
         */
        public static ExpectedSale newInstance(Location saleLocation, SaleType saleType, Collection<SaleMeasurement> saleMeasurements, Collection<Produce> produces, ObservedLanding observedLanding, ObservedFishingTrip observedFishingTrip)
        {
            final ExpectedSale entity = new ExpectedSaleImpl();
            entity.setSaleLocation(saleLocation);
            entity.setSaleType(saleType);
            entity.setSaleMeasurements(saleMeasurements);
            entity.setProduces(produces);
            entity.setObservedLanding(observedLanding);
            entity.setObservedFishingTrip(observedFishingTrip);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ExpectedSale o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ExpectedSale.java merge-point
}