// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.samplingScheme;

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Plan d'échantillonnage, pour un programme de collecte donné.
 * @since v3.2.0
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SamplingScheme
    implements Serializable, Comparable<SamplingScheme>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1308922911992633284L;

    // Generate 7 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * 
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * 
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private String name;

    /**
     * Libellé du plan d'échantillonnage.
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * Libellé du plan d'échantillonnage.
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String description;

    /**
     * Description du plan d'échantillonnage.
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * Description du plan d'échantillonnage.
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Date creationDate;

    /**
     * Date de création du plan en base de données.
     * @return this.creationDate Date
     */
    public Date getCreationDate()
    {
        return this.creationDate;
    }

    /**
     * Date de création du plan en base de données.
     * @param creationDateIn Date
     */
    public void setCreationDate(Date creationDateIn)
    {
        this.creationDate = creationDateIn;
    }

    private String comments;

    /**
     * Commentaires sur la strate.
     * Dans WAO : PLAN_COMMENT
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * Commentaires sur la strate.
     * Dans WAO : PLAN_COMMENT
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 2 associations
    private Collection<SamplingStrata> samplingStratas = new HashSet<SamplingStrata>();

    /**
     * Représente une ligne du plan d'échantillonnage.
     * @since v3.2.0
     * @return this.samplingStratas Collection<SamplingStrata>
     */
    public Collection<SamplingStrata> getSamplingStratas()
    {
        return this.samplingStratas;
    }

    /**
     * Représente une ligne du plan d'échantillonnage.
     * @since v3.2.0
     * @param samplingStratasIn Collection<SamplingStrata>
     */
    public void setSamplingStratas(Collection<SamplingStrata> samplingStratasIn)
    {
        this.samplingStratas = samplingStratasIn;
    }

    /**
     * Représente une ligne du plan d'échantillonnage.
     * @since v3.2.0
     * @param elementToAdd SamplingStrata
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingStratas(SamplingStrata elementToAdd)
    {
        return this.samplingStratas.add(elementToAdd);
    }

    /**
     * Représente une ligne du plan d'échantillonnage.
     * @since v3.2.0
     * @param elementToRemove SamplingStrata
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingStratas(SamplingStrata elementToRemove)
    {
        return this.samplingStratas.remove(elementToRemove);
    }

    private Program program;

    /**
     * Programme de collecte duquel dépend le plan d'échantillonnage
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Programme de collecte duquel dépend le plan d'échantillonnage
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    /**
     * Returns <code>true</code> if the argument is an SamplingScheme instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof SamplingScheme))
        {
            return false;
        }
        final SamplingScheme that = (SamplingScheme)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link SamplingScheme}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SamplingScheme}.
         * @return new SamplingSchemeImpl()
         */
        public static SamplingScheme newInstance()
        {
            return new SamplingSchemeImpl();
        }

        /**
         * Constructs a new instance of {@link SamplingScheme}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param name String
         * @param creationDate Date
         * @param updateDate Timestamp
         * @param program Program
         * @return newInstance
         */
        public static SamplingScheme newInstance(String label, String name, Date creationDate, Timestamp updateDate, Program program)
        {
            final SamplingScheme entity = new SamplingSchemeImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setCreationDate(creationDate);
            entity.setUpdateDate(updateDate);
            entity.setProgram(program);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SamplingScheme}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param description String
         * @param creationDate Date
         * @param comments String
         * @param updateDate Timestamp
         * @param samplingStratas Collection<SamplingStrata>
         * @param program Program
         * @return newInstance SamplingScheme
         */
        public static SamplingScheme newInstance(String label, String name, String description, Date creationDate, String comments, Timestamp updateDate, Collection<SamplingStrata> samplingStratas, Program program)
        {
            final SamplingScheme entity = new SamplingSchemeImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setDescription(description);
            entity.setCreationDate(creationDate);
            entity.setComments(comments);
            entity.setUpdateDate(updateDate);
            entity.setSamplingStratas(samplingStratas);
            entity.setProgram(program);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SamplingScheme o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getCreationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getCreationDate().compareTo(o.getCreationDate()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SamplingScheme.java merge-point
}