// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.samplingScheme;

import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.administration.user.Person;
import fr.ifremer.adagio.core.dao.data.measure.SamplingStrataMeasurement;
import fr.ifremer.adagio.core.dao.referential.Status;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Représente une ligne du plan d'échantillonnage.
 * @since v3.2.0
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SamplingStrata
    implements Serializable, Comparable<SamplingStrata>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -600598895829055537L;

    // Generate 7 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * Mnémonique de la ligne du plan.
     * Ce mnémonique doit être unique en base (clef naturelle) pour tout les plans d'échantillonnage
     * de la base de données, car il s'agit d'un code fréquemment utilisé pour identifier une ligne
     * de plan.
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * Mnémonique de la ligne du plan.
     * Ce mnémonique doit être unique en base (clef naturelle) pour tout les plans d'échantillonnage
     * de la base de données, car il s'agit d'un code fréquemment utilisé pour identifier une ligne
     * de plan.
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private Date startDate;

    /**
     * 
     * @return this.startDate Date
     */
    public Date getStartDate()
    {
        return this.startDate;
    }

    /**
     * 
     * @param startDateIn Date
     */
    public void setStartDate(Date startDateIn)
    {
        this.startDate = startDateIn;
    }

    private Date endDate;

    /**
     * 
     * @return this.endDate Date
     */
    public Date getEndDate()
    {
        return this.endDate;
    }

    /**
     * 
     * @param endDateIn Date
     */
    public void setEndDate(Date endDateIn)
    {
        this.endDate = endDateIn;
    }

    private String description;

    /**
     * Nom de la strate.
     * Dans WAO : METIER_LIBELLE
     * "Chalutage hauturier à démerseaux à grand fond"
     * TODO : à renommer en "name" ?
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * Nom de la strate.
     * Dans WAO : METIER_LIBELLE
     * "Chalutage hauturier à démerseaux à grand fond"
     * TODO : à renommer en "name" ?
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private String comments;

    /**
     * Commentaires sur la strate.
     * Dans WAO : PLAN_COMMENT
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * Commentaires sur la strate.
     * Dans WAO : PLAN_COMMENT
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 13 associations
    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Location observationLocation;

    /**
     * Lieux ou se déroulera l'observation.
     * cela peut etre un quartier (cas des enquete d'activité), ou des site de débarquement (cas des
     * observations aux débarquements).
     * @return this.observationLocation Location
     */
    public Location getObservationLocation()
    {
        return this.observationLocation;
    }

    /**
     * Lieux ou se déroulera l'observation.
     * cela peut etre un quartier (cas des enquete d'activité), ou des site de débarquement (cas des
     * observations aux débarquements).
     * @param observationLocationIn Location
     */
    public void setObservationLocation(Location observationLocationIn)
    {
        this.observationLocation = observationLocationIn;
    }

    private Collection<SamplingStrataMeasurement> samplingStrataMeasurements = new HashSet<SamplingStrataMeasurement>();

    /**
     * Caratéristiques de la straté d'échantillonnage, en terme de valeurs sur PSFM.
     * @since v3.2.0
     * @return this.samplingStrataMeasurements Collection<SamplingStrataMeasurement>
     */
    public Collection<SamplingStrataMeasurement> getSamplingStrataMeasurements()
    {
        return this.samplingStrataMeasurements;
    }

    /**
     * Caratéristiques de la straté d'échantillonnage, en terme de valeurs sur PSFM.
     * @since v3.2.0
     * @param samplingStrataMeasurementsIn Collection<SamplingStrataMeasurement>
     */
    public void setSamplingStrataMeasurements(Collection<SamplingStrataMeasurement> samplingStrataMeasurementsIn)
    {
        this.samplingStrataMeasurements = samplingStrataMeasurementsIn;
    }

    /**
     * Caratéristiques de la straté d'échantillonnage, en terme de valeurs sur PSFM.
     * @since v3.2.0
     * @param elementToAdd SamplingStrataMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingStrataMeasurements(SamplingStrataMeasurement elementToAdd)
    {
        return this.samplingStrataMeasurements.add(elementToAdd);
    }

    /**
     * Caratéristiques de la straté d'échantillonnage, en terme de valeurs sur PSFM.
     * @since v3.2.0
     * @param elementToRemove SamplingStrataMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingStrataMeasurements(SamplingStrataMeasurement elementToRemove)
    {
        return this.samplingStrataMeasurements.remove(elementToRemove);
    }

    private Department department;

    /**
     * Service ou société chargée de réaliser la ligne du plan.
     * Permet d'avoir des droits d'accès sur le plan.
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Service ou société chargée de réaliser la ligne du plan.
     * Permet d'avoir des droits d'accès sur le plan.
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private Collection<SamplingStrata2Grouping> samplingStrata2Groupings = new HashSet<SamplingStrata2Grouping>();

    /**
     * Caractéristiques de la strate d'échantillonnage, en terme de regroupement d'entités.
     * @since v3.2.0
     * @return this.samplingStrata2Groupings Collection<SamplingStrata2Grouping>
     */
    public Collection<SamplingStrata2Grouping> getSamplingStrata2Groupings()
    {
        return this.samplingStrata2Groupings;
    }

    /**
     * Caractéristiques de la strate d'échantillonnage, en terme de regroupement d'entités.
     * @since v3.2.0
     * @param samplingStrata2GroupingsIn Collection<SamplingStrata2Grouping>
     */
    public void setSamplingStrata2Groupings(Collection<SamplingStrata2Grouping> samplingStrata2GroupingsIn)
    {
        this.samplingStrata2Groupings = samplingStrata2GroupingsIn;
    }

    /**
     * Caractéristiques de la strate d'échantillonnage, en terme de regroupement d'entités.
     * @since v3.2.0
     * @param elementToAdd SamplingStrata2Grouping
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingStrata2Groupings(SamplingStrata2Grouping elementToAdd)
    {
        return this.samplingStrata2Groupings.add(elementToAdd);
    }

    /**
     * Caractéristiques de la strate d'échantillonnage, en terme de regroupement d'entités.
     * @since v3.2.0
     * @param elementToRemove SamplingStrata2Grouping
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingStrata2Groupings(SamplingStrata2Grouping elementToRemove)
    {
        return this.samplingStrata2Groupings.remove(elementToRemove);
    }

    private SamplingScheme samplingScheme;

    /**
     * Plan d'échantillonnage, pour un programme de collecte donné.
     * @since v3.2.0
     * @return this.samplingScheme SamplingScheme
     */
    public SamplingScheme getSamplingScheme()
    {
        return this.samplingScheme;
    }

    /**
     * Plan d'échantillonnage, pour un programme de collecte donné.
     * @since v3.2.0
     * @param samplingSchemeIn SamplingScheme
     */
    public void setSamplingScheme(SamplingScheme samplingSchemeIn)
    {
        this.samplingScheme = samplingSchemeIn;
    }

    private Collection<SamplingStrata2Fishery> samplingStrata2Fisheries = new HashSet<SamplingStrata2Fishery>();

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de lier une strate d'échantillonnage à la pêcherie ou au stock.
     * </p>
     * <p>
     * </p>
     * <p>
     * Demande initiale de E.Bodere du 18/07/2012 :
     * </p>
     * <p>
     * Ajout de la table SamplingStrata2Fishery. Pour la reprise des données
     * Arpège, Joël veut que l’on recréé des plans avec comme strate le stock
     * arpège (espèce commerciale * grand secteur Arpège). Cette solution
     * permettrait d’avoir un lien vers des pêcheries ultérieurement
     * </p>
     * </body>
     * </html>
     * @return this.samplingStrata2Fisheries Collection<SamplingStrata2Fishery>
     */
    public Collection<SamplingStrata2Fishery> getSamplingStrata2Fisheries()
    {
        return this.samplingStrata2Fisheries;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de lier une strate d'échantillonnage à la pêcherie ou au stock.
     * </p>
     * <p>
     * </p>
     * <p>
     * Demande initiale de E.Bodere du 18/07/2012 :
     * </p>
     * <p>
     * Ajout de la table SamplingStrata2Fishery. Pour la reprise des données
     * Arpège, Joël veut que l’on recréé des plans avec comme strate le stock
     * arpège (espèce commerciale * grand secteur Arpège). Cette solution
     * permettrait d’avoir un lien vers des pêcheries ultérieurement
     * </p>
     * </body>
     * </html>
     * @param samplingStrata2FisheriesIn Collection<SamplingStrata2Fishery>
     */
    public void setSamplingStrata2Fisheries(Collection<SamplingStrata2Fishery> samplingStrata2FisheriesIn)
    {
        this.samplingStrata2Fisheries = samplingStrata2FisheriesIn;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de lier une strate d'échantillonnage à la pêcherie ou au stock.
     * </p>
     * <p>
     * </p>
     * <p>
     * Demande initiale de E.Bodere du 18/07/2012 :
     * </p>
     * <p>
     * Ajout de la table SamplingStrata2Fishery. Pour la reprise des données
     * Arpège, Joël veut que l’on recréé des plans avec comme strate le stock
     * arpège (espèce commerciale * grand secteur Arpège). Cette solution
     * permettrait d’avoir un lien vers des pêcheries ultérieurement
     * </p>
     * </body>
     * </html>
     * @param elementToAdd SamplingStrata2Fishery
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingStrata2Fisheries(SamplingStrata2Fishery elementToAdd)
    {
        return this.samplingStrata2Fisheries.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet de lier une strate d'échantillonnage à la pêcherie ou au stock.
     * </p>
     * <p>
     * </p>
     * <p>
     * Demande initiale de E.Bodere du 18/07/2012 :
     * </p>
     * <p>
     * Ajout de la table SamplingStrata2Fishery. Pour la reprise des données
     * Arpège, Joël veut que l’on recréé des plans avec comme strate le stock
     * arpège (espèce commerciale * grand secteur Arpège). Cette solution
     * permettrait d’avoir un lien vers des pêcheries ultérieurement
     * </p>
     * </body>
     * </html>
     * @param elementToRemove SamplingStrata2Fishery
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingStrata2Fisheries(SamplingStrata2Fishery elementToRemove)
    {
        return this.samplingStrata2Fisheries.remove(elementToRemove);
    }

    private Person person;

    /**
     * Personne chargée de réaliser la ligne du plan.
     * Permet d'avoir des droits d'accès sur le plan.
     * @return this.person Person
     */
    public Person getPerson()
    {
        return this.person;
    }

    /**
     * Personne chargée de réaliser la ligne du plan.
     * Permet d'avoir des droits d'accès sur le plan.
     * @param personIn Person
     */
    public void setPerson(Person personIn)
    {
        this.person = personIn;
    }

    private Collection<SamplingStrata2Vessel> samplingStrata2Vessels = new HashSet<SamplingStrata2Vessel>();

    /**
     * Liste des navires elligibles pour la ligne du plan.
     * @since v3.2.0
     * @return this.samplingStrata2Vessels Collection<SamplingStrata2Vessel>
     */
    public Collection<SamplingStrata2Vessel> getSamplingStrata2Vessels()
    {
        return this.samplingStrata2Vessels;
    }

    /**
     * Liste des navires elligibles pour la ligne du plan.
     * @since v3.2.0
     * @param samplingStrata2VesselsIn Collection<SamplingStrata2Vessel>
     */
    public void setSamplingStrata2Vessels(Collection<SamplingStrata2Vessel> samplingStrata2VesselsIn)
    {
        this.samplingStrata2Vessels = samplingStrata2VesselsIn;
    }

    /**
     * Liste des navires elligibles pour la ligne du plan.
     * @since v3.2.0
     * @param elementToAdd SamplingStrata2Vessel
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSamplingStrata2Vessels(SamplingStrata2Vessel elementToAdd)
    {
        return this.samplingStrata2Vessels.add(elementToAdd);
    }

    /**
     * Liste des navires elligibles pour la ligne du plan.
     * @since v3.2.0
     * @param elementToRemove SamplingStrata2Vessel
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSamplingStrata2Vessels(SamplingStrata2Vessel elementToRemove)
    {
        return this.samplingStrata2Vessels.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an SamplingStrata instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof SamplingStrata))
        {
            return false;
        }
        final SamplingStrata that = (SamplingStrata)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link SamplingStrata}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SamplingStrata}.
         * @return new SamplingStrataImpl()
         */
        public static SamplingStrata newInstance()
        {
            return new SamplingStrataImpl();
        }

        /**
         * Constructs a new instance of {@link SamplingStrata}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param updateDate Timestamp
         * @param status Status
         * @param samplingScheme SamplingScheme
         * @return newInstance
         */
        public static SamplingStrata newInstance(String label, Timestamp updateDate, Status status, SamplingScheme samplingScheme)
        {
            final SamplingStrata entity = new SamplingStrataImpl();
            entity.setLabel(label);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setSamplingScheme(samplingScheme);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SamplingStrata}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param startDate Date
         * @param endDate Date
         * @param description String
         * @param comments String
         * @param updateDate Timestamp
         * @param status Status
         * @param observationLocation Location
         * @param samplingStrataMeasurements Collection<SamplingStrataMeasurement>
         * @param department Department
         * @param samplingStrata2Groupings Collection<SamplingStrata2Grouping>
         * @param samplingScheme SamplingScheme
         * @param samplingStrata2Fisheries Collection<SamplingStrata2Fishery>
         * @param person Person
         * @param samplingStrata2Vessels Collection<SamplingStrata2Vessel>
         * @return newInstance SamplingStrata
         */
        public static SamplingStrata newInstance(String label, Date startDate, Date endDate, String description, String comments, Timestamp updateDate, Status status, Location observationLocation, Collection<SamplingStrataMeasurement> samplingStrataMeasurements, Department department, Collection<SamplingStrata2Grouping> samplingStrata2Groupings, SamplingScheme samplingScheme, Collection<SamplingStrata2Fishery> samplingStrata2Fisheries, Person person, Collection<SamplingStrata2Vessel> samplingStrata2Vessels)
        {
            final SamplingStrata entity = new SamplingStrataImpl();
            entity.setLabel(label);
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setDescription(description);
            entity.setComments(comments);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setObservationLocation(observationLocation);
            entity.setSamplingStrataMeasurements(samplingStrataMeasurements);
            entity.setDepartment(department);
            entity.setSamplingStrata2Groupings(samplingStrata2Groupings);
            entity.setSamplingScheme(samplingScheme);
            entity.setSamplingStrata2Fisheries(samplingStrata2Fisheries);
            entity.setPerson(person);
            entity.setSamplingStrata2Vessels(samplingStrata2Vessels);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SamplingStrata o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getStartDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStartDate().compareTo(o.getStartDate()));
            }
            if (this.getEndDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDate().compareTo(o.getEndDate()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SamplingStrata.java merge-point
}