// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.samplingScheme.denormalized;

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.administration.user.Person;
import fr.ifremer.adagio.core.dao.referential.Status;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Denormalisation des ligne du plan d'échantillonnage. Pour utilisation dans Allegro (table
 * synchronisée).
 * Calculé à partir de SamplingStrata, SamplingScheme, Grouping, etc.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DenormalizedSamplingStrata
    implements Serializable, Comparable<DenormalizedSamplingStrata>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 2066427443801432744L;

    // Generate 18 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * WAO : PLAN_CODE
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * WAO : PLAN_CODE
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private Date startDate;

    /**
     * Date de début de validité de la ligne du plan.
     * Pour savoir si la ligne affectable à une marée ou une vente (suivant la date de début).
     * WAO : PROGRAMME_DEBUT
     * @return this.startDate Date
     */
    public Date getStartDate()
    {
        return this.startDate;
    }

    /**
     * Date de début de validité de la ligne du plan.
     * Pour savoir si la ligne affectable à une marée ou une vente (suivant la date de début).
     * WAO : PROGRAMME_DEBUT
     * @param startDateIn Date
     */
    public void setStartDate(Date startDateIn)
    {
        this.startDate = startDateIn;
    }

    private Date endDate;

    /**
     * WAO : PROGRAMME_FIN
     * @return this.endDate Date
     */
    public Date getEndDate()
    {
        return this.endDate;
    }

    /**
     * WAO : PROGRAMME_FIN
     * @param endDateIn Date
     */
    public void setEndDate(Date endDateIn)
    {
        this.endDate = endDateIn;
    }

    private String description;

    /**
     * Calculé à partir de SamplingStrata.description.
     * WAO : METIER_LIBELLE
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * Calculé à partir de SamplingStrata.description.
     * WAO : METIER_LIBELLE
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private String comments;

    /**
     * Calculé à partir de SamplingStrata.comments.
     * WAO : PLAN_COMMENT
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * Calculé à partir de SamplingStrata.comments.
     * WAO : PLAN_COMMENT
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private String observationLocationComments;

    /**
     * Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM.
     * @return this.observationLocationComments String
     */
    public String getObservationLocationComments()
    {
        return this.observationLocationComments;
    }

    /**
     * Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM.
     * @param observationLocationCommentsIn String
     */
    public void setObservationLocationComments(String observationLocationCommentsIn)
    {
        this.observationLocationComments = observationLocationCommentsIn;
    }

    private String samplingStrategy;

    /**
     * Stratégie d'échantillonnage.
     * Dans WAO : PLAN_STRATEGIE
     * Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM
     * "SAMPLING_STRATEGY.
     * @return this.samplingStrategy String
     */
    public String getSamplingStrategy()
    {
        return this.samplingStrategy;
    }

    /**
     * Stratégie d'échantillonnage.
     * Dans WAO : PLAN_STRATEGIE
     * Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM
     * "SAMPLING_STRATEGY.
     * @param samplingStrategyIn String
     */
    public void setSamplingStrategy(String samplingStrategyIn)
    {
        this.samplingStrategy = samplingStrategyIn;
    }

    private String taxonGroupName;

    /**
     * Nom du groupement d'espèces.
     * Dans WAO : METIER_ESPECES
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @return this.taxonGroupName String
     */
    public String getTaxonGroupName()
    {
        return this.taxonGroupName;
    }

    /**
     * Nom du groupement d'espèces.
     * Dans WAO : METIER_ESPECES
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @param taxonGroupNameIn String
     */
    public void setTaxonGroupName(String taxonGroupNameIn)
    {
        this.taxonGroupName = taxonGroupNameIn;
    }

    private String samplingSchemeLabel;

    /**
     * Mnémonique du programme de rattachement du plan.
     * Dans WAO : PROGRAMME_CODE
     * @return this.samplingSchemeLabel String
     */
    public String getSamplingSchemeLabel()
    {
        return this.samplingSchemeLabel;
    }

    /**
     * Mnémonique du programme de rattachement du plan.
     * Dans WAO : PROGRAMME_CODE
     * @param samplingSchemeLabelIn String
     */
    public void setSamplingSchemeLabel(String samplingSchemeLabelIn)
    {
        this.samplingSchemeLabel = samplingSchemeLabelIn;
    }

    private String samplingSchemeName;

    /**
     * Libellé du programme de rattachement du plan.
     * Dans WAO : PROGRAMME_CODE (identique à samplingSchemeName)
     * @return this.samplingSchemeName String
     */
    public String getSamplingSchemeName()
    {
        return this.samplingSchemeName;
    }

    /**
     * Libellé du programme de rattachement du plan.
     * Dans WAO : PROGRAMME_CODE (identique à samplingSchemeName)
     * @param samplingSchemeNameIn String
     */
    public void setSamplingSchemeName(String samplingSchemeNameIn)
    {
        this.samplingSchemeName = samplingSchemeNameIn;
    }

    private String samplingSchemeDescription;

    /**
     * Description du programme de rattachement du plan.
     * @return this.samplingSchemeDescription String
     */
    public String getSamplingSchemeDescription()
    {
        return this.samplingSchemeDescription;
    }

    /**
     * Description du programme de rattachement du plan.
     * @param samplingSchemeDescriptionIn String
     */
    public void setSamplingSchemeDescription(String samplingSchemeDescriptionIn)
    {
        this.samplingSchemeDescription = samplingSchemeDescriptionIn;
    }

    private String gearMeshRange;

    /**
     * Liste de gamme de maillage de l'engin
     * Dans WAO : METIER_MAILLAGE
     * Exemple :
     * - "40-49"
     * - "40-49, 50-59, 60-79, 80-99, >=100"
     * @return this.gearMeshRange String
     */
    public String getGearMeshRange()
    {
        return this.gearMeshRange;
    }

    /**
     * Liste de gamme de maillage de l'engin
     * Dans WAO : METIER_MAILLAGE
     * Exemple :
     * - "40-49"
     * - "40-49, 50-59, 60-79, 80-99, >=100"
     * @param gearMeshRangeIn String
     */
    public void setGearMeshRange(String gearMeshRangeIn)
    {
        this.gearMeshRange = gearMeshRangeIn;
    }

    private String vesselLengthRange;

    /**
     * Classe de longueur de navire
     * Dans WAO : METIER_TAILLE
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @return this.vesselLengthRange String
     */
    public String getVesselLengthRange()
    {
        return this.vesselLengthRange;
    }

    /**
     * Classe de longueur de navire
     * Dans WAO : METIER_TAILLE
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @param vesselLengthRangeIn String
     */
    public void setVesselLengthRange(String vesselLengthRangeIn)
    {
        this.vesselLengthRange = vesselLengthRangeIn;
    }

    private String metier;

    /**
     * Liste de métier DCF 5.
     * Dans WAO : METIER_CODE_DCF5
     * Exemple : "GNS_DEF et GTR_DEF"
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @return this.metier String
     */
    public String getMetier()
    {
        return this.metier;
    }

    /**
     * Liste de métier DCF 5.
     * Dans WAO : METIER_CODE_DCF5
     * Exemple : "GNS_DEF et GTR_DEF"
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @param metierIn String
     */
    public void setMetier(String metierIn)
    {
        this.metier = metierIn;
    }

    private String areaName;

    /**
     * Unité géographique de l'échantillonnage
     * Dans WAO : PECHE_ZONE
     * Exemple : "Golfe de Gascogne"
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @return this.areaName String
     */
    public String getAreaName()
    {
        return this.areaName;
    }

    /**
     * Unité géographique de l'échantillonnage
     * Dans WAO : PECHE_ZONE
     * Exemple : "Golfe de Gascogne"
     * Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @param areaNameIn String
     */
    public void setAreaName(String areaNameIn)
    {
        this.areaName = areaNameIn;
    }

    private String subAreaLocationIds;

    /**
     * Zone en mer rattaché à l'unité géographique d'échantillonnage.
     * Dans WAO : PECHE_DIVISION
     * Calculé à partir de SamplingStrata2Grouping->Grouping->GroupingItem.
     * @return this.subAreaLocationIds String
     */
    public String getSubAreaLocationIds()
    {
        return this.subAreaLocationIds;
    }

    /**
     * Zone en mer rattaché à l'unité géographique d'échantillonnage.
     * Dans WAO : PECHE_DIVISION
     * Calculé à partir de SamplingStrata2Grouping->Grouping->GroupingItem.
     * @param subAreaLocationIdsIn String
     */
    public void setSubAreaLocationIds(String subAreaLocationIdsIn)
    {
        this.subAreaLocationIds = subAreaLocationIdsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 5 associations
    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Location observationLocation;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.observationLocation Location
     */
    public Location getObservationLocation()
    {
        return this.observationLocation;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param observationLocationIn Location
     */
    public void setObservationLocation(Location observationLocationIn)
    {
        this.observationLocation = observationLocationIn;
    }

    private Person person;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Personne liées aux données : utilisateur du système, ou observateurs,
     * responsable de données, etc.
     * </p>
     * <p>
     * </p>
     * <p>
     * Les personnes liées aux activités professionnelles de pêche sont plutôt
     * gérer dans <i>VesselPerson</i>.
     * </p>
     * <p>
     * </p>
     * <p>
     * Nombre de lignes : 100
     * </p>
     * </body>
     * </html>
     * @return this.person Person
     */
    public Person getPerson()
    {
        return this.person;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Personne liées aux données : utilisateur du système, ou observateurs,
     * responsable de données, etc.
     * </p>
     * <p>
     * </p>
     * <p>
     * Les personnes liées aux activités professionnelles de pêche sont plutôt
     * gérer dans <i>VesselPerson</i>.
     * </p>
     * <p>
     * </p>
     * <p>
     * Nombre de lignes : 100
     * </p>
     * </body>
     * </html>
     * @param personIn Person
     */
    public void setPerson(Person personIn)
    {
        this.person = personIn;
    }

    private Department department;

    /**
     * Service d'appartenance d'une personne.
     * Il peut s'agir des départements et service de l'Ifremer, ou bien des entreprises, services
     * extérieurs (sous-traitants, etc.).
     * REMARQUE : nous en aurons besoin en v2, pour l'administration des personnes (rechercher une
     * personne, gérer les sous-traitants, etc.), mais aussi pour identifier le service effectuant
     * l’analyse d’un résultat de mesure.
     * Nombre de lignes : 60
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Service d'appartenance d'une personne.
     * Il peut s'agir des départements et service de l'Ifremer, ou bien des entreprises, services
     * extérieurs (sous-traitants, etc.).
     * REMARQUE : nous en aurons besoin en v2, pour l'administration des personnes (rechercher une
     * personne, gérer les sous-traitants, etc.), mais aussi pour identifier le service effectuant
     * l’analyse d’un résultat de mesure.
     * Nombre de lignes : 60
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private Program program;

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    /**
     * Returns <code>true</code> if the argument is an DenormalizedSamplingStrata instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DenormalizedSamplingStrata))
        {
            return false;
        }
        final DenormalizedSamplingStrata that = (DenormalizedSamplingStrata)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link DenormalizedSamplingStrata}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DenormalizedSamplingStrata}.
         * @return new DenormalizedSamplingStrataImpl()
         */
        public static DenormalizedSamplingStrata newInstance()
        {
            return new DenormalizedSamplingStrataImpl();
        }

        /**
         * Constructs a new instance of {@link DenormalizedSamplingStrata}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param samplingSchemeLabel String
         * @param samplingSchemeName String
         * @param updateDate Timestamp
         * @param status Status
         * @param program Program
         * @return newInstance
         */
        public static DenormalizedSamplingStrata newInstance(String label, String samplingSchemeLabel, String samplingSchemeName, Timestamp updateDate, Status status, Program program)
        {
            final DenormalizedSamplingStrata entity = new DenormalizedSamplingStrataImpl();
            entity.setLabel(label);
            entity.setSamplingSchemeLabel(samplingSchemeLabel);
            entity.setSamplingSchemeName(samplingSchemeName);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setProgram(program);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DenormalizedSamplingStrata}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param startDate Date
         * @param endDate Date
         * @param description String
         * @param comments String
         * @param observationLocationComments String
         * @param samplingStrategy String
         * @param taxonGroupName String
         * @param samplingSchemeLabel String
         * @param samplingSchemeName String
         * @param samplingSchemeDescription String
         * @param gearMeshRange String
         * @param vesselLengthRange String
         * @param metier String
         * @param areaName String
         * @param subAreaLocationIds String
         * @param updateDate Timestamp
         * @param status Status
         * @param observationLocation Location
         * @param person Person
         * @param department Department
         * @param program Program
         * @return newInstance DenormalizedSamplingStrata
         */
        public static DenormalizedSamplingStrata newInstance(String label, Date startDate, Date endDate, String description, String comments, String observationLocationComments, String samplingStrategy, String taxonGroupName, String samplingSchemeLabel, String samplingSchemeName, String samplingSchemeDescription, String gearMeshRange, String vesselLengthRange, String metier, String areaName, String subAreaLocationIds, Timestamp updateDate, Status status, Location observationLocation, Person person, Department department, Program program)
        {
            final DenormalizedSamplingStrata entity = new DenormalizedSamplingStrataImpl();
            entity.setLabel(label);
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setDescription(description);
            entity.setComments(comments);
            entity.setObservationLocationComments(observationLocationComments);
            entity.setSamplingStrategy(samplingStrategy);
            entity.setTaxonGroupName(taxonGroupName);
            entity.setSamplingSchemeLabel(samplingSchemeLabel);
            entity.setSamplingSchemeName(samplingSchemeName);
            entity.setSamplingSchemeDescription(samplingSchemeDescription);
            entity.setGearMeshRange(gearMeshRange);
            entity.setVesselLengthRange(vesselLengthRange);
            entity.setMetier(metier);
            entity.setAreaName(areaName);
            entity.setSubAreaLocationIds(subAreaLocationIds);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setObservationLocation(observationLocation);
            entity.setPerson(person);
            entity.setDepartment(department);
            entity.setProgram(program);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DenormalizedSamplingStrata o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getStartDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStartDate().compareTo(o.getStartDate()));
            }
            if (this.getEndDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDate().compareTo(o.getEndDate()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getObservationLocationComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObservationLocationComments().compareTo(o.getObservationLocationComments()));
            }
            if (this.getSamplingStrategy() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingStrategy().compareTo(o.getSamplingStrategy()));
            }
            if (this.getTaxonGroupName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonGroupName().compareTo(o.getTaxonGroupName()));
            }
            if (this.getSamplingSchemeLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingSchemeLabel().compareTo(o.getSamplingSchemeLabel()));
            }
            if (this.getSamplingSchemeName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingSchemeName().compareTo(o.getSamplingSchemeName()));
            }
            if (this.getSamplingSchemeDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingSchemeDescription().compareTo(o.getSamplingSchemeDescription()));
            }
            if (this.getGearMeshRange() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getGearMeshRange().compareTo(o.getGearMeshRange()));
            }
            if (this.getVesselLengthRange() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getVesselLengthRange().compareTo(o.getVesselLengthRange()));
            }
            if (this.getMetier() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMetier().compareTo(o.getMetier()));
            }
            if (this.getAreaName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAreaName().compareTo(o.getAreaName()));
            }
            if (this.getSubAreaLocationIds() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSubAreaLocationIds().compareTo(o.getSubAreaLocationIds()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DenormalizedSamplingStrata.java merge-point
}