// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.samplingScheme.denormalized;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.referential.Status;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Denormalisation des ligne du plan d'échantillonnage. Pour utilisation dans Allegro (table
 * synchronisée).
 * Calculé à partir de SamplingStrata, SamplingScheme, Grouping, etc.
 * @see DenormalizedSamplingStrata
 */
public interface DenormalizedSamplingStrataDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link DenormalizedSamplingStrata}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of DenormalizedSamplingStrata from the persistent store.
     * @param id
     * @return DenormalizedSamplingStrata
     */
    public DenormalizedSamplingStrata get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of DenormalizedSamplingStrata from the persistent store.
     * @param id
     * @return DenormalizedSamplingStrata
     */
    public DenormalizedSamplingStrata load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link DenormalizedSamplingStrata}.
     *
     * @return the loaded entities.
     */
    public Collection<DenormalizedSamplingStrata> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of DenormalizedSamplingStrata and adds it to the persistent store.
     * @param denormalizedSamplingStrata
     * @return DenormalizedSamplingStrata
     */
    public DenormalizedSamplingStrata create(DenormalizedSamplingStrata denormalizedSamplingStrata);

    /**
     * <p>
     * Does the same thing as {@link #create(DenormalizedSamplingStrata)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param denormalizedSamplingStrata
     * @return Object
     */
    public Object create(int transform, DenormalizedSamplingStrata denormalizedSamplingStrata);

    /**
     * Creates a new instance of DenormalizedSamplingStrata and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of DenormalizedSamplingStrata
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<DenormalizedSamplingStrata> create(Collection<DenormalizedSamplingStrata> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(DenormalizedSamplingStrata)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<DenormalizedSamplingStrata> entities);

    /**
     * <p>
     * Creates a new <code>DenormalizedSamplingStrata</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param label WAO : PLAN_CODE
     * @param startDate Date de début de validité de la ligne du plan.
Pour savoir si la ligne affectable à une marée ou une vente (suivant la date de début).
WAO : PROGRAMME_DEBUT
     * @param endDate WAO : PROGRAMME_FIN
     * @param description Calculé à partir de SamplingStrata.description.
WAO : METIER_LIBELLE
     * @param comments Calculé à partir de SamplingStrata.comments.
WAO : PLAN_COMMENT
     * @param observationLocationComments Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM.
     * @param samplingStrategy Stratégie d'échantillonnage.
Dans WAO : PLAN_STRATEGIE
Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM
"SAMPLING_STRATEGY.
     * @param taxonGroupName Nom du groupement d'espèces.
Dans WAO : METIER_ESPECES
Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @param samplingSchemeLabel Mnémonique du programme de rattachement du plan.
Dans WAO : PROGRAMME_CODE
     * @param samplingSchemeName Libellé du programme de rattachement du plan.
Dans WAO : PROGRAMME_CODE (identique à samplingSchemeName)
     * @param samplingSchemeDescription Description du programme de rattachement du plan.
     * @param gearMeshRange Liste de gamme de maillage de l'engin
Dans WAO : METIER_MAILLAGE
Exemple :
- "40-49"
- "40-49, 50-59, 60-79, 80-99, >=100"
     * @param vesselLengthRange Classe de longueur de navire
Dans WAO : METIER_TAILLE
Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @param metier Liste de métier DCF 5.
Dans WAO : METIER_CODE_DCF5
Exemple : "GNS_DEF et GTR_DEF"
Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @param areaName Unité géographique de l'échantillonnage
Dans WAO : PECHE_ZONE
Exemple : "Golfe de Gascogne"
Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @param subAreaLocationIds Zone en mer rattaché à l'unité géographique d'échantillonnage.
Dans WAO : PECHE_DIVISION
Calculé à partir de SamplingStrata2Grouping->Grouping->GroupingItem.
     * @param updateDate 
     * @return DenormalizedSamplingStrata
     */
    public DenormalizedSamplingStrata create(
        String label,
        Date startDate,
        Date endDate,
        String description,
        String comments,
        String observationLocationComments,
        String samplingStrategy,
        String taxonGroupName,
        String samplingSchemeLabel,
        String samplingSchemeName,
        String samplingSchemeDescription,
        String gearMeshRange,
        String vesselLengthRange,
        String metier,
        String areaName,
        String subAreaLocationIds,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, Date, String, String, String, String, String, String, String, String, String, String, String, String, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param label WAO : PLAN_CODE
     * @param startDate Date de début de validité de la ligne du plan.
Pour savoir si la ligne affectable à une marée ou une vente (suivant la date de début).
WAO : PROGRAMME_DEBUT
     * @param endDate WAO : PROGRAMME_FIN
     * @param description Calculé à partir de SamplingStrata.description.
WAO : METIER_LIBELLE
     * @param comments Calculé à partir de SamplingStrata.comments.
WAO : PLAN_COMMENT
     * @param observationLocationComments Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM.
     * @param samplingStrategy Stratégie d'échantillonnage.
Dans WAO : PLAN_STRATEGIE
Calculé à partir de SAMPLING_STRATA_MEASUREMENT, via une valeur alphanumérique sur un PSFM
"SAMPLING_STRATEGY.
     * @param taxonGroupName Nom du groupement d'espèces.
Dans WAO : METIER_ESPECES
Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @param samplingSchemeLabel Mnémonique du programme de rattachement du plan.
Dans WAO : PROGRAMME_CODE
     * @param samplingSchemeName Libellé du programme de rattachement du plan.
Dans WAO : PROGRAMME_CODE (identique à samplingSchemeName)
     * @param samplingSchemeDescription Description du programme de rattachement du plan.
     * @param gearMeshRange Liste de gamme de maillage de l'engin
Dans WAO : METIER_MAILLAGE
Exemple :
- "40-49"
- "40-49, 50-59, 60-79, 80-99, >=100"
     * @param vesselLengthRange Classe de longueur de navire
Dans WAO : METIER_TAILLE
Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @param metier Liste de métier DCF 5.
Dans WAO : METIER_CODE_DCF5
Exemple : "GNS_DEF et GTR_DEF"
Calculé à partir de SamplingStrata2Grouping, et Grouping.label.
     * @param areaName Unité géographique de l'échantillonnage
Dans WAO : PECHE_ZONE
Exemple : "Golfe de Gascogne"
Calculé à partir de SamplingStrata2Grouping, et Grouping.name.
     * @param subAreaLocationIds Zone en mer rattaché à l'unité géographique d'échantillonnage.
Dans WAO : PECHE_DIVISION
Calculé à partir de SamplingStrata2Grouping->Grouping->GroupingItem.
     * @param updateDate 
     * @return DenormalizedSamplingStrata
     */
    public Object create(
        int transform,
        String label,
        Date startDate,
        Date endDate,
        String description,
        String comments,
        String observationLocationComments,
        String samplingStrategy,
        String taxonGroupName,
        String samplingSchemeLabel,
        String samplingSchemeName,
        String samplingSchemeDescription,
        String gearMeshRange,
        String vesselLengthRange,
        String metier,
        String areaName,
        String subAreaLocationIds,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>DenormalizedSamplingStrata</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param label
     * @param program
     * @param samplingSchemeLabel
     * @param samplingSchemeName
     * @param status
     * @param updateDate
     * @return DenormalizedSamplingStrata
     */
    public DenormalizedSamplingStrata create(
        String label,
        Program program,
        String samplingSchemeLabel,
        String samplingSchemeName,
        Status status,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param label
     * @param program
     * @param samplingSchemeLabel
     * @param samplingSchemeName
     * @param status
     * @param updateDate
     * @return Object
     */
    public Object create(
        int transform,
        String label,
        Program program,
        String samplingSchemeLabel,
        String samplingSchemeName,
        Status status,
        Timestamp updateDate);

    /**
     * Updates the <code>denormalizedSamplingStrata</code> instance in the persistent store.
     * @param denormalizedSamplingStrata
     */
    public void update(DenormalizedSamplingStrata denormalizedSamplingStrata);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<DenormalizedSamplingStrata> entities);

    /**
     * Removes the instance of DenormalizedSamplingStrata from the persistent store.
     * @param denormalizedSamplingStrata
     */
    public void remove(DenormalizedSamplingStrata denormalizedSamplingStrata);

    /**
     * Removes the instance of DenormalizedSamplingStrata having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<DenormalizedSamplingStrata> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<DenormalizedSamplingStrata> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.samplingScheme.denormalized.DenormalizedSamplingStrataDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.samplingScheme.denormalized.DenormalizedSamplingStrataDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final DenormalizedSamplingStrata entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,DenormalizedSamplingStrata)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.samplingScheme.denormalized.DenormalizedSamplingStrataDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,DenormalizedSamplingStrata)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}