// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.survey.declaration;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Référence du document déclaratif. Utile pour les données issu du log book électronique (flux
 * SACAPT.)
 * @see DeclaredDocumentReference
 */
public interface DeclaredDocumentReferenceDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link DeclaredDocumentReference}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of DeclaredDocumentReference from the persistent store.
     * @param id
     * @return DeclaredDocumentReference
     */
    public DeclaredDocumentReference get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of DeclaredDocumentReference from the persistent store.
     * @param id
     * @return DeclaredDocumentReference
     */
    public DeclaredDocumentReference load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link DeclaredDocumentReference}.
     *
     * @return the loaded entities.
     */
    public Collection<DeclaredDocumentReference> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of DeclaredDocumentReference and adds it to the persistent store.
     * @param declaredDocumentReference
     * @return DeclaredDocumentReference
     */
    public DeclaredDocumentReference create(DeclaredDocumentReference declaredDocumentReference);

    /**
     * <p>
     * Does the same thing as {@link #create(DeclaredDocumentReference)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param declaredDocumentReference
     * @return Object
     */
    public Object create(int transform, DeclaredDocumentReference declaredDocumentReference);

    /**
     * Creates a new instance of DeclaredDocumentReference and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of DeclaredDocumentReference
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<DeclaredDocumentReference> create(Collection<DeclaredDocumentReference> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(DeclaredDocumentReference)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<DeclaredDocumentReference> entities);

    /**
     * <p>
     * Creates a new <code>DeclaredDocumentReference</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param synchronizationStatus Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement visible dans
la base locale.
     * @param reference Numéro de la fiche de peche.
issu du flux SACAPT.
Cela sert à regrouper les marées par fiche de peche.
     * @param fileName Nom du fichier ayant servi à importer les données déclarées dans la base.
ex : Nom du fichier d'origine de la vente = BL_070212_1215.ric
     * @param documentDate 
     * @param otherDocumentReference Autre référence sur le document déclaratif.
Utilisé dans SACROIS/RIC2 : Ce code permet de transmettre dans le fichier RIC2 l’information
renseignée sur la note de vente dans la case « Document joint à la note de vente (le cas échéant) »
:
T2M/Déclaration de débarquement, document de transport, déclaration de prise en
charge. Ce code permet de préciser, lorsqu’aucun document n’est joint à la note de vente, si ce
défaut de document joint est ou non une anomalie du point de vue de la
réglementation.
Exemple :
- 0 : aucun document joint à la note de vente – sans objet
- 1 : aucun document joint à la note de vente – anomalie réglementaire
- 2 : T2M / déclaration de débarquement
- 3 : Document de transport
- 4 : Déclaration de prise en charge
     * @param firstSheetNumber Numéro du premier feuillet de la déclaration. Utilisé dans SACROIS/SIPA.
Il peut s'agir d'un code alphanumérique (référence du feuillet).
     * @param lastSheetNumber Numéro du dernier feuillet de la déclaration. Utilisé dans SACROIS/SIPA.
Il peut s'agir d'un code alphanumérique (référence du feuillet).
     * @param sheetCount Nombre de feuillets dans la déclaration. Utilisé dans SACROIS/SIPA
     * @param comments Commentaire.
     * @param creationDate Date de création de l'enquete dans le système central.
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param updateDate 
     * @return DeclaredDocumentReference
     */
    public DeclaredDocumentReference create(
        
        String reference,
        String fileName,
        Date documentDate,
        String otherDocumentReference,
        String firstSheetNumber,
        String lastSheetNumber,
        Short sheetCount,
        String comments,
        Date creationDate,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, Date, String, String, String, Short, String, Date, Date, Date, Date, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param synchronizationStatus Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement visible dans
la base locale.
     * @param reference Numéro de la fiche de peche.
issu du flux SACAPT.
Cela sert à regrouper les marées par fiche de peche.
     * @param fileName Nom du fichier ayant servi à importer les données déclarées dans la base.
ex : Nom du fichier d'origine de la vente = BL_070212_1215.ric
     * @param documentDate 
     * @param otherDocumentReference Autre référence sur le document déclaratif.
Utilisé dans SACROIS/RIC2 : Ce code permet de transmettre dans le fichier RIC2 l’information
renseignée sur la note de vente dans la case « Document joint à la note de vente (le cas échéant) »
:
T2M/Déclaration de débarquement, document de transport, déclaration de prise en
charge. Ce code permet de préciser, lorsqu’aucun document n’est joint à la note de vente, si ce
défaut de document joint est ou non une anomalie du point de vue de la
réglementation.
Exemple :
- 0 : aucun document joint à la note de vente – sans objet
- 1 : aucun document joint à la note de vente – anomalie réglementaire
- 2 : T2M / déclaration de débarquement
- 3 : Document de transport
- 4 : Déclaration de prise en charge
     * @param firstSheetNumber Numéro du premier feuillet de la déclaration. Utilisé dans SACROIS/SIPA.
Il peut s'agir d'un code alphanumérique (référence du feuillet).
     * @param lastSheetNumber Numéro du dernier feuillet de la déclaration. Utilisé dans SACROIS/SIPA.
Il peut s'agir d'un code alphanumérique (référence du feuillet).
     * @param sheetCount Nombre de feuillets dans la déclaration. Utilisé dans SACROIS/SIPA
     * @param comments Commentaire.
     * @param creationDate Date de création de l'enquete dans le système central.
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param updateDate 
     * @return DeclaredDocumentReference
     */
    public Object create(
        int transform,
        
        String reference,
        String fileName,
        Date documentDate,
        String otherDocumentReference,
        String firstSheetNumber,
        String lastSheetNumber,
        Short sheetCount,
        String comments,
        Date creationDate,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>DeclaredDocumentReference</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param creationDate
     * @param documentDate
     * @param program
     * @param qualityFlag
     * @param recorderDepartment
     * @param synchronizationStatus
     * @param updateDate
     * @param vessel
     * @return DeclaredDocumentReference
     */
    public DeclaredDocumentReference create(
        Date creationDate,
        Date documentDate,
        Program program,
        QualityFlag qualityFlag,
        Department recorderDepartment,
        
        Timestamp updateDate,
        Vessel vessel);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param creationDate
     * @param documentDate
     * @param program
     * @param qualityFlag
     * @param recorderDepartment
     * @param synchronizationStatus
     * @param updateDate
     * @param vessel
     * @return Object
     */
    public Object create(
        int transform,
        Date creationDate,
        Date documentDate,
        Program program,
        QualityFlag qualityFlag,
        Department recorderDepartment,
        
        Timestamp updateDate,
        Vessel vessel);

    /**
     * Updates the <code>declaredDocumentReference</code> instance in the persistent store.
     * @param declaredDocumentReference
     */
    public void update(DeclaredDocumentReference declaredDocumentReference);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<DeclaredDocumentReference> entities);

    /**
     * Removes the instance of DeclaredDocumentReference from the persistent store.
     * @param declaredDocumentReference
     */
    public void remove(DeclaredDocumentReference declaredDocumentReference);

    /**
     * Removes the instance of DeclaredDocumentReference having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<DeclaredDocumentReference> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<DeclaredDocumentReference> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReferenceDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReferenceDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final DeclaredDocumentReference entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,DeclaredDocumentReference)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReferenceDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,DeclaredDocumentReference)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}