// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.survey.takeOver;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.seller.Seller;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Prise en charge, d'une marée ou d'un débarquement, par un organisme (Seller) chargé de mettre en
 * vente les produits débarqués.
 * @see TakeOver
 */
public interface TakeOverDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link TakeOver}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of TakeOver from the persistent store.
     * @param id
     * @return TakeOver
     */
    public TakeOver get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of TakeOver from the persistent store.
     * @param id
     * @return TakeOver
     */
    public TakeOver load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link TakeOver}.
     *
     * @return the loaded entities.
     */
    public Collection<TakeOver> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of TakeOver and adds it to the persistent store.
     * @param takeOver
     * @return TakeOver
     */
    public TakeOver create(TakeOver takeOver);

    /**
     * <p>
     * Does the same thing as {@link #create(TakeOver)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param takeOver
     * @return Object
     */
    public Object create(int transform, TakeOver takeOver);

    /**
     * Creates a new instance of TakeOver and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of TakeOver
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<TakeOver> create(Collection<TakeOver> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(TakeOver)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<TakeOver> entities);

    /**
     * <p>
     * Creates a new <code>TakeOver</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param synchronizationStatus Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement visible dans
la base locale Allegro.
     * @param takeOverDateTime 
     * @param creationDate 
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param updateDate 
     * @param comments 
     * @return TakeOver
     */
    public TakeOver create(
        
        Date takeOverDateTime,
        Date creationDate,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Timestamp updateDate,
        String comments);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, Date, Date, Date, Date, String, Timestamp, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param synchronizationStatus Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement visible dans
la base locale Allegro.
     * @param takeOverDateTime 
     * @param creationDate 
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param updateDate 
     * @param comments 
     * @return TakeOver
     */
    public Object create(
        int transform,
        
        Date takeOverDateTime,
        Date creationDate,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Timestamp updateDate,
        String comments);

    /**
     * <p>
     * Creates a new <code>TakeOver</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param creationDate
     * @param program
     * @param qualityFlag
     * @param recorderDepartment
     * @param seller
     * @param synchronizationStatus
     * @param takeOverDateTime
     * @param takeOverLocation
     * @param updateDate
     * @param vessel
     * @return TakeOver
     */
    public TakeOver create(
        Date creationDate,
        Program program,
        QualityFlag qualityFlag,
        Department recorderDepartment,
        Seller seller,
        
        Date takeOverDateTime,
        Location takeOverLocation,
        Timestamp updateDate,
        Vessel vessel);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Date, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param creationDate
     * @param program
     * @param qualityFlag
     * @param recorderDepartment
     * @param seller
     * @param synchronizationStatus
     * @param takeOverDateTime
     * @param takeOverLocation
     * @param updateDate
     * @param vessel
     * @return Object
     */
    public Object create(
        int transform,
        Date creationDate,
        Program program,
        QualityFlag qualityFlag,
        Department recorderDepartment,
        Seller seller,
        
        Date takeOverDateTime,
        Location takeOverLocation,
        Timestamp updateDate,
        Vessel vessel);

    /**
     * Updates the <code>takeOver</code> instance in the persistent store.
     * @param takeOver
     */
    public void update(TakeOver takeOver);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<TakeOver> entities);

    /**
     * Removes the instance of TakeOver from the persistent store.
     * @param takeOver
     */
    public void remove(TakeOver takeOver);

    /**
     * Removes the instance of TakeOver having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<TakeOver> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<TakeOver> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.survey.takeOver.TakeOverDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.survey.takeOver.TakeOverDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final TakeOver entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,TakeOver)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.survey.takeOver.TakeOverDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,TakeOver)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}