// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel;

import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.util.Date;

/**
 * Définit le lieu d'immatriculation d'un navire statistique et la période associée.
 * Nombre de lignes : 72700
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VesselRegistrationPeriod
    implements Serializable, Comparable<VesselRegistrationPeriod>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1400358090358950484L;

    private VesselRegistrationPeriodPK vesselRegistrationPeriodPk;

    /**
     * Get the composite primary key identifier class
     * @return vesselRegistrationPeriodPk
     */
    public VesselRegistrationPeriodPK getVesselRegistrationPeriodPk()
    {
        return this.vesselRegistrationPeriodPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param vesselRegistrationPeriodPkIn
     */
    public void setVesselRegistrationPeriodPk(VesselRegistrationPeriodPK vesselRegistrationPeriodPkIn) {
        this.vesselRegistrationPeriodPk = vesselRegistrationPeriodPkIn;
    }

    // Generate 5 attributes
    /**
     * 
     * @return this.startDateTime Date
     */
    public Date getStartDateTime()
    {
        return this.getVesselRegistrationPeriodPk().getStartDateTime();
    }

    /**
     * 
     * @param startDateTimeIn Date
     */
    public void setStartDateTime(Date startDateTimeIn)
    {
        this.getVesselRegistrationPeriodPk().setStartDateTime(startDateTimeIn);
    }

    private Date endDateTime;

    /**
     * 
     * @return this.endDateTime Date
     */
    public Date getEndDateTime()
    {
        return this.endDateTime;
    }

    /**
     * 
     * @param endDateTimeIn Date
     */
    public void setEndDateTime(Date endDateTimeIn)
    {
        this.endDateTime = endDateTimeIn;
    }

    private String registrationCode;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Code d'immatriculation du navire, dans le lieu dans lequel il est
     * enregistré.
     * </p>
     * <p>
     * Il s'agit dans la plupart des cas de l'immatriculation <b>nationale</b>
     * du navire, qui peut varier en cas de changement de pays.
     * </p>
     * </body>
     * </html>
     * @return this.registrationCode String
     */
    public String getRegistrationCode()
    {
        return this.registrationCode;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Code d'immatriculation du navire, dans le lieu dans lequel il est
     * enregistré.
     * </p>
     * <p>
     * Il s'agit dans la plupart des cas de l'immatriculation <b>nationale</b>
     * du navire, qui peut varier en cas de changement de pays.
     * </p>
     * </body>
     * </html>
     * @param registrationCodeIn String
     */
    public void setRegistrationCode(String registrationCodeIn)
    {
        this.registrationCode = registrationCodeIn;
    }

    private String internationalRegistrationCode;

    /**
     * Code d'immatriculation international.
     * Rempli à partir de l'information la plus stable : IMO code si disponible, ou CFR code
     * ("Community Fishing-Fleet Register").
     * @return this.internationalRegistrationCode String
     */
    public String getInternationalRegistrationCode()
    {
        return this.internationalRegistrationCode;
    }

    /**
     * Code d'immatriculation international.
     * Rempli à partir de l'information la plus stable : IMO code si disponible, ou CFR code
     * ("Community Fishing-Fleet Register").
     * @param internationalRegistrationCodeIn String
     */
    public void setInternationalRegistrationCode(String internationalRegistrationCodeIn)
    {
        this.internationalRegistrationCode = internationalRegistrationCodeIn;
    }

    private Short rankOrder = Short.valueOf("1");

    /**
     * Ajout pour gérer les regsitre de navires (hors registre consolidé) ou des doublons peuvent
     * exister.
     * mantis #14112
     * @return this.rankOrder Short
     */
    public Short getRankOrder()
    {
        return this.rankOrder;
    }

    /**
     * Ajout pour gérer les regsitre de navires (hors registre consolidé) ou des doublons peuvent
     * exister.
     * mantis #14112
     * @param rankOrderIn Short
     */
    public void setRankOrder(Short rankOrderIn)
    {
        this.rankOrder = rankOrderIn;
    }

    // Generate 3 associations
    private Location registrationLocation;

    /**
     * Lieu d'immatriculation.
     * Peut etre un pays (=pavillon), un quartier d'immatriculation (QIM, pour la France), ou port
     * d'immatriculation (pour le Maroc).
     * @return this.registrationLocation Location
     */
    public Location getRegistrationLocation()
    {
        return this.registrationLocation;
    }

    /**
     * Lieu d'immatriculation.
     * Peut etre un pays (=pavillon), un quartier d'immatriculation (QIM, pour la France), ou port
     * d'immatriculation (pour le Maroc).
     * @param registrationLocationIn Location
     */
    public void setRegistrationLocation(Location registrationLocationIn)
    {
        this.registrationLocation = registrationLocationIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Flag qualité de la période.
     * Par défaut = 0 (non qualifié).
     * Utilisé par exemple pour les périodes d'immatriculation issues d'anciennes sources de données
     * ne gérant pas l'historiques des modifications.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Flag qualité de la période.
     * Par défaut = 0 (non qualifié).
     * Utilisé par exemple pour les périodes d'immatriculation issues d'anciennes sources de données
     * ne gérant pas l'historiques des modifications.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private Vessel vessel;

    /**
     * Navire, ou plus généralement un usager de la ressource.
     * Peut etre un navire de peche professionnel ou non, un navire scientifique, un pêcheur à pied,
     * un
     * groupement de navires, etc.
     * @return this.vessel Vessel
     */
    public Vessel getVessel()
    {
        return this.vessel;
    }

    /**
     * Navire, ou plus généralement un usager de la ressource.
     * Peut etre un navire de peche professionnel ou non, un navire scientifique, un pêcheur à pied,
     * un
     * groupement de navires, etc.
     * @param vesselIn Vessel
     */
    public void setVessel(Vessel vesselIn)
    {
        this.vessel = vesselIn;
    }

    /**
     * Returns <code>true</code> if the argument is an VesselRegistrationPeriod instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof VesselRegistrationPeriod))
        {
            return false;
        }
        final VesselRegistrationPeriod that = (VesselRegistrationPeriod)object;
        if (this.vesselRegistrationPeriodPk == null || that.vesselRegistrationPeriodPk == null || !this.vesselRegistrationPeriodPk.equals(that.vesselRegistrationPeriodPk))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.vesselRegistrationPeriodPk == null ? 0 : this.vesselRegistrationPeriodPk.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link VesselRegistrationPeriod}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VesselRegistrationPeriod}.
         * @return new VesselRegistrationPeriodImpl()
         */
        public static VesselRegistrationPeriod newInstance()
        {
            return new VesselRegistrationPeriodImpl();
        }

        /**
         * Constructs a new instance of {@link VesselRegistrationPeriod}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param rankOrder Short
         * @param registrationLocation Location
         * @param qualityFlag QualityFlag
         * @param vessel Vessel
         * @return newInstance
         */
        public static VesselRegistrationPeriod newInstance(Short rankOrder, Location registrationLocation, QualityFlag qualityFlag, Vessel vessel)
        {
            final VesselRegistrationPeriod entity = new VesselRegistrationPeriodImpl();
            entity.setRankOrder(rankOrder);
            entity.setRegistrationLocation(registrationLocation);
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            return entity;
        }

        /**
         * Constructs a new instance of {@link VesselRegistrationPeriod}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param endDateTime Date
         * @param registrationCode String
         * @param internationalRegistrationCode String
         * @param rankOrder Short
         * @param registrationLocation Location
         * @param qualityFlag QualityFlag
         * @param vessel Vessel
         * @return newInstance VesselRegistrationPeriod
         */
        public static VesselRegistrationPeriod newInstance(Date endDateTime, String registrationCode, String internationalRegistrationCode, Short rankOrder, Location registrationLocation, QualityFlag qualityFlag, Vessel vessel)
        {
            final VesselRegistrationPeriod entity = new VesselRegistrationPeriodImpl();
            entity.setEndDateTime(endDateTime);
            entity.setRegistrationCode(registrationCode);
            entity.setInternationalRegistrationCode(internationalRegistrationCode);
            entity.setRankOrder(rankOrder);
            entity.setRegistrationLocation(registrationLocation);
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VesselRegistrationPeriod o)
    {
        int cmp = 0;
        if (this.getVesselRegistrationPeriodPk() != null)
        {
            cmp = this.getVesselRegistrationPeriodPk().compareTo(o.getVesselRegistrationPeriodPk());
        }
        else
        {
            if (this.getEndDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDateTime().compareTo(o.getEndDateTime()));
            }
            if (this.getRegistrationCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRegistrationCode().compareTo(o.getRegistrationCode()));
            }
            if (this.getInternationalRegistrationCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getInternationalRegistrationCode().compareTo(o.getInternationalRegistrationCode()));
            }
            if (this.getRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRankOrder().compareTo(o.getRankOrder()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VesselRegistrationPeriod.java merge-point
}