// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel.feature.person;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Caractéristiques d'une personne physique en relation avec un Vessel
 * (usager), pour une période.
 * </p>
 * <p>
 * </p>
 * <p>
 * Dans tous les cas, il s'agit bien d'une personne physique, et <b>jamais
 * d'un regroupement de plusieurs personnes</b>. Ainsi, des variables comme
 * le &quot;<i>nombre d'hommes à bord</i>&quot; ne sera pas stocké ici,
 * mais plutot dans <i>VesselUseFeatures</i>/<i>VesselUseMesurement</i>.
 * </p>
 * </body>
 * </html>
 * @see VesselPersonFeatures
 */
public interface VesselPersonFeaturesDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link VesselPersonFeatures}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of VesselPersonFeatures from the persistent store.
     * @param id
     * @return VesselPersonFeatures
     */
    public VesselPersonFeatures get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of VesselPersonFeatures from the persistent store.
     * @param id
     * @return VesselPersonFeatures
     */
    public VesselPersonFeatures load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link VesselPersonFeatures}.
     *
     * @return the loaded entities.
     */
    public Collection<VesselPersonFeatures> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of VesselPersonFeatures and adds it to the persistent store.
     * @param vesselPersonFeatures
     * @return VesselPersonFeatures
     */
    public VesselPersonFeatures create(VesselPersonFeatures vesselPersonFeatures);

    /**
     * <p>
     * Does the same thing as {@link #create(VesselPersonFeatures)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param vesselPersonFeatures
     * @return Object
     */
    public Object create(int transform, VesselPersonFeatures vesselPersonFeatures);

    /**
     * Creates a new instance of VesselPersonFeatures and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of VesselPersonFeatures
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<VesselPersonFeatures> create(Collection<VesselPersonFeatures> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(VesselPersonFeatures)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<VesselPersonFeatures> entities);

    /**
     * <p>
     * Creates a new <code>VesselPersonFeatures</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param startDate 
     * @param endDate 
     * @param rankOrder Numéro d'ordre de la personne, dans le cas où il y a plusieurs personnes concernées
     * @param creationDate 
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param updateDate 
     * @return VesselPersonFeatures
     */
    public VesselPersonFeatures create(
        Date startDate,
        Date endDate,
        Short rankOrder,
        Date creationDate,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Date, Short, Date, Date, Date, Date, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param startDate 
     * @param endDate 
     * @param rankOrder Numéro d'ordre de la personne, dans le cas où il y a plusieurs personnes concernées
     * @param creationDate 
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param updateDate 
     * @return VesselPersonFeatures
     */
    public Object create(
        int transform,
        Date startDate,
        Date endDate,
        Short rankOrder,
        Date creationDate,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>VesselPersonFeatures</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param program
     * @param qualityFlag
     * @param startDate
     * @param updateDate
     * @param vessel
     * @return VesselPersonFeatures
     */
    public VesselPersonFeatures create(
        Program program,
        QualityFlag qualityFlag,
        Date startDate,
        Timestamp updateDate,
        Vessel vessel);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param program
     * @param qualityFlag
     * @param startDate
     * @param updateDate
     * @param vessel
     * @return Object
     */
    public Object create(
        int transform,
        Program program,
        QualityFlag qualityFlag,
        Date startDate,
        Timestamp updateDate,
        Vessel vessel);

    /**
     * Updates the <code>vesselPersonFeatures</code> instance in the persistent store.
     * @param vesselPersonFeatures
     */
    public void update(VesselPersonFeatures vesselPersonFeatures);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<VesselPersonFeatures> entities);

    /**
     * Removes the instance of VesselPersonFeatures from the persistent store.
     * @param vesselPersonFeatures
     */
    public void remove(VesselPersonFeatures vesselPersonFeatures);

    /**
     * Removes the instance of VesselPersonFeatures having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<VesselPersonFeatures> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<VesselPersonFeatures> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeaturesDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeaturesDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final VesselPersonFeatures entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,VesselPersonFeatures)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeaturesDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,VesselPersonFeatures)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}