// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel.position;

import com.vividsolutions.jts.geom.Point;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.data.history.ProcessingHistory;
import fr.ifremer.adagio.core.dao.data.measure.VesselPositionMeasurement;
import fr.ifremer.adagio.core.dao.data.operation.Operation;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Table de position particulière pour les positions issues de la VMS (Vessel Monitoring System),
 * afin d'en sécruiser d'avantage le contenu.
 * (Droits d'accès très restreint à quelques personnes mandatées)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VesselPositionVMS
    implements Serializable, Comparable<VesselPositionVMS>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 3873681433357732931L;

    // Generate 11 attributes
    private BigInteger id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id BigInteger
     */
    public BigInteger getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn BigInteger
     */
    public void setId(BigInteger idIn)
    {
        this.id = idIn;
    }

    private Date dateTime;

    /**
     * 
     * @return this.dateTime Date
     */
    public Date getDateTime()
    {
        return this.dateTime;
    }

    /**
     * 
     * @param dateTimeIn Date
     */
    public void setDateTime(Date dateTimeIn)
    {
        this.dateTime = dateTimeIn;
    }

    private Float latitude;

    /**
     * 
     * @return this.latitude Float
     */
    public Float getLatitude()
    {
        return this.latitude;
    }

    /**
     * 
     * @param latitudeIn Float
     */
    public void setLatitude(Float latitudeIn)
    {
        this.latitude = latitudeIn;
    }

    private Float longitude;

    /**
     * 
     * @return this.longitude Float
     */
    public Float getLongitude()
    {
        return this.longitude;
    }

    /**
     * 
     * @param longitudeIn Float
     */
    public void setLongitude(Float longitudeIn)
    {
        this.longitude = longitudeIn;
    }

    private BigDecimal vesselSpeed;

    /**
     * Vitesse du navire
     * @return this.vesselSpeed BigDecimal
     */
    public BigDecimal getVesselSpeed()
    {
        return this.vesselSpeed;
    }

    /**
     * Vitesse du navire
     * @param vesselSpeedIn BigDecimal
     */
    public void setVesselSpeed(BigDecimal vesselSpeedIn)
    {
        this.vesselSpeed = vesselSpeedIn;
    }

    private BigDecimal vesselDirection;

    /**
     * Cap du navire (0-360°)
     * @return this.vesselDirection BigDecimal
     */
    public BigDecimal getVesselDirection()
    {
        return this.vesselDirection;
    }

    /**
     * Cap du navire (0-360°)
     * @param vesselDirectionIn BigDecimal
     */
    public void setVesselDirection(BigDecimal vesselDirectionIn)
    {
        this.vesselDirection = vesselDirectionIn;
    }

    private Date controlDate;

    /**
     * 
     * @return this.controlDate Date
     */
    public Date getControlDate()
    {
        return this.controlDate;
    }

    /**
     * 
     * @param controlDateIn Date
     */
    public void setControlDate(Date controlDateIn)
    {
        this.controlDate = controlDateIn;
    }

    private Date validationDate;

    /**
     * 
     * @return this.validationDate Date
     */
    public Date getValidationDate()
    {
        return this.validationDate;
    }

    /**
     * 
     * @param validationDateIn Date
     */
    public void setValidationDate(Date validationDateIn)
    {
        this.validationDate = validationDateIn;
    }

    private Date qualificationDate;

    /**
     * 
     * @return this.qualificationDate Date
     */
    public Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    /**
     * 
     * @param qualificationDateIn Date
     */
    public void setQualificationDate(Date qualificationDateIn)
    {
        this.qualificationDate = qualificationDateIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private Point position;

    /**
     * Géomtrie ponctuelle de la position (en WGS84)
     * @return this.position Point
     */
    public Point getPosition()
    {
        return this.position;
    }

    /**
     * Géomtrie ponctuelle de la position (en WGS84)
     * @param positionIn Point
     */
    public void setPosition(Point positionIn)
    {
        this.position = positionIn;
    }

    // Generate 8 associations
    private Collection<VesselPositionMeasurement> vesselPositionMeasurements = new HashSet<VesselPositionMeasurement>();

    /**
     * 
     * @return this.vesselPositionMeasurements Collection<VesselPositionMeasurement>
     */
    public Collection<VesselPositionMeasurement> getVesselPositionMeasurements()
    {
        return this.vesselPositionMeasurements;
    }

    /**
     * 
     * @param vesselPositionMeasurementsIn Collection<VesselPositionMeasurement>
     */
    public void setVesselPositionMeasurements(Collection<VesselPositionMeasurement> vesselPositionMeasurementsIn)
    {
        this.vesselPositionMeasurements = vesselPositionMeasurementsIn;
    }

    /**
     * 
     * @param elementToAdd VesselPositionMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addVesselPositionMeasurements(VesselPositionMeasurement elementToAdd)
    {
        return this.vesselPositionMeasurements.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove VesselPositionMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeVesselPositionMeasurements(VesselPositionMeasurement elementToRemove)
    {
        return this.vesselPositionMeasurements.remove(elementToRemove);
    }

    private Department recorderDepartment;

    /**
     * Service d'appartenance d'une personne.
     * Il peut s'agir des départements et service de l'Ifremer, ou bien des entreprises, services
     * extérieurs (sous-traitants, etc.).
     * REMARQUE : nous en aurons besoin en v2, pour l'administration des personnes (rechercher une
     * personne, gérer les sous-traitants, etc.), mais aussi pour identifier le service effectuant
     * l’analyse d’un résultat de mesure.
     * Nombre de lignes : 60
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Service d'appartenance d'une personne.
     * Il peut s'agir des départements et service de l'Ifremer, ou bien des entreprises, services
     * extérieurs (sous-traitants, etc.).
     * REMARQUE : nous en aurons besoin en v2, pour l'administration des personnes (rechercher une
     * personne, gérer les sous-traitants, etc.), mais aussi pour identifier le service effectuant
     * l’analyse d’un résultat de mesure.
     * Nombre de lignes : 60
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    private QualitativeValue signalStatus;

    /**
     * Liste des valeurs qualitatives que peut prendre un paramètre.
     * Par exemple :
     * - pour le paramètre Sexe : "Mâle" et "Femelle"
     * - pour le paramètre Présentation : "Vidé", "Entier", ...
     * - pour le paramètre Catégorie : "Gros", "Moyen", ...
     * @return this.signalStatus QualitativeValue
     */
    public QualitativeValue getSignalStatus()
    {
        return this.signalStatus;
    }

    /**
     * Liste des valeurs qualitatives que peut prendre un paramètre.
     * Par exemple :
     * - pour le paramètre Sexe : "Mâle" et "Femelle"
     * - pour le paramètre Présentation : "Vidé", "Entier", ...
     * - pour le paramètre Catégorie : "Gros", "Moyen", ...
     * @param signalStatusIn QualitativeValue
     */
    public void setSignalStatus(QualitativeValue signalStatusIn)
    {
        this.signalStatus = signalStatusIn;
    }

    private Operation operation;

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @return this.operation Operation
     */
    public Operation getOperation()
    {
        return this.operation;
    }

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @param operationIn Operation
     */
    public void setOperation(Operation operationIn)
    {
        this.operation = operationIn;
    }

    private Vessel vessel;

    /**
     * Navire, ou plus généralement un usager de la ressource.
     * Peut etre un navire de peche professionnel ou non, un navire scientifique, un pêcheur à pied,
     * un
     * groupement de navires, etc.
     * @return this.vessel Vessel
     */
    public Vessel getVessel()
    {
        return this.vessel;
    }

    /**
     * Navire, ou plus généralement un usager de la ressource.
     * Peut etre un navire de peche professionnel ou non, un navire scientifique, un pêcheur à pied,
     * un
     * groupement de navires, etc.
     * @param vesselIn Vessel
     */
    public void setVessel(Vessel vesselIn)
    {
        this.vessel = vesselIn;
    }

    private ProcessingHistory processingHistory;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet d'identifier le traitement à l'origine de l'insertion de la
     * position.
     * </p>
     * <p>
     * </p>
     * <p>
     * (Besoins pour les flux VMS, trop volumineux pour pouvoir insérer dans
     * <i>INSERTED_ITEM_HISTORY</i>
     * pour chaque position)
     * </p>
     * </body>
     * </html>
     * @return this.processingHistory ProcessingHistory
     */
    public ProcessingHistory getProcessingHistory()
    {
        return this.processingHistory;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Permet d'identifier le traitement à l'origine de l'insertion de la
     * position.
     * </p>
     * <p>
     * </p>
     * <p>
     * (Besoins pour les flux VMS, trop volumineux pour pouvoir insérer dans
     * <i>INSERTED_ITEM_HISTORY</i>
     * pour chaque position)
     * </p>
     * </body>
     * </html>
     * @param processingHistoryIn ProcessingHistory
     */
    public void setProcessingHistory(ProcessingHistory processingHistoryIn)
    {
        this.processingHistory = processingHistoryIn;
    }

    private Program program;

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Niveau de qualité de la donnée.
     * "Non qualifiée" par défaut
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Niveau de qualité de la donnée.
     * "Non qualifiée" par défaut
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    /**
     * Returns <code>true</code> if the argument is an VesselPositionVMS instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof VesselPositionVMS))
        {
            return false;
        }
        final VesselPositionVMS that = (VesselPositionVMS)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link VesselPositionVMS}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VesselPositionVMS}.
         * @return new VesselPositionVMSImpl()
         */
        public static VesselPositionVMS newInstance()
        {
            return new VesselPositionVMSImpl();
        }

        /**
         * Constructs a new instance of {@link VesselPositionVMS}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param dateTime Date
         * @param latitude Float
         * @param longitude Float
         * @param updateDate Timestamp
         * @param recorderDepartment Department
         * @param vessel Vessel
         * @param program Program
         * @param qualityFlag QualityFlag
         * @return newInstance
         */
        public static VesselPositionVMS newInstance(Date dateTime, Float latitude, Float longitude, Timestamp updateDate, Department recorderDepartment, Vessel vessel, Program program, QualityFlag qualityFlag)
        {
            final VesselPositionVMS entity = new VesselPositionVMSImpl();
            entity.setDateTime(dateTime);
            entity.setLatitude(latitude);
            entity.setLongitude(longitude);
            entity.setUpdateDate(updateDate);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setVessel(vessel);
            entity.setProgram(program);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link VesselPositionVMS}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param dateTime Date
         * @param latitude Float
         * @param longitude Float
         * @param vesselSpeed BigDecimal
         * @param vesselDirection BigDecimal
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param updateDate Timestamp
         * @param position Point
         * @param vesselPositionMeasurements Collection<VesselPositionMeasurement>
         * @param recorderDepartment Department
         * @param signalStatus QualitativeValue
         * @param operation Operation
         * @param vessel Vessel
         * @param processingHistory ProcessingHistory
         * @param program Program
         * @param qualityFlag QualityFlag
         * @return newInstance VesselPositionVMS
         */
        public static VesselPositionVMS newInstance(Date dateTime, Float latitude, Float longitude, BigDecimal vesselSpeed, BigDecimal vesselDirection, Date controlDate, Date validationDate, Date qualificationDate, Timestamp updateDate, Point position, Collection<VesselPositionMeasurement> vesselPositionMeasurements, Department recorderDepartment, QualitativeValue signalStatus, Operation operation, Vessel vessel, ProcessingHistory processingHistory, Program program, QualityFlag qualityFlag)
        {
            final VesselPositionVMS entity = new VesselPositionVMSImpl();
            entity.setDateTime(dateTime);
            entity.setLatitude(latitude);
            entity.setLongitude(longitude);
            entity.setVesselSpeed(vesselSpeed);
            entity.setVesselDirection(vesselDirection);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setUpdateDate(updateDate);
            entity.setPosition(position);
            entity.setVesselPositionMeasurements(vesselPositionMeasurements);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setSignalStatus(signalStatus);
            entity.setOperation(operation);
            entity.setVessel(vessel);
            entity.setProcessingHistory(processingHistory);
            entity.setProgram(program);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VesselPositionVMS o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDateTime().compareTo(o.getDateTime()));
            }
            if (this.getLatitude() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLatitude().compareTo(o.getLatitude()));
            }
            if (this.getLongitude() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLongitude().compareTo(o.getLongitude()));
            }
            if (this.getVesselSpeed() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getVesselSpeed().compareTo(o.getVesselSpeed()));
            }
            if (this.getVesselDirection() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getVesselDirection().compareTo(o.getVesselDirection()));
            }
            if (this.getControlDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getControlDate().compareTo(o.getControlDate()));
            }
            if (this.getValidationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getValidationDate().compareTo(o.getValidationDate()));
            }
            if (this.getQualificationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualificationDate().compareTo(o.getQualificationDate()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getPosition() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPosition().compareTo(o.getPosition()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VesselPositionVMS.java merge-point
}