// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.playground;

import fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip;
import java.io.Serializable;

/**
 * Capitaine (patron) de navire pour la marée, et ordre de hiérarchie.
 * A interpreter (une fois les données connues) et remodeliser.
 * ref : flux SACAPT
 */
// HibernateEntity.vsl annotations merge-point
public abstract class PlaygroundFishingTripVesselMaster
    implements Serializable, Comparable<PlaygroundFishingTripVesselMaster>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 7009089534124415157L;

    private PlaygroundFishingTripVesselMasterPK playgroundFishingTripVesselMasterPk;

    /**
     * Get the composite primary key identifier class
     * @return playgroundFishingTripVesselMasterPk
     */
    public PlaygroundFishingTripVesselMasterPK getPlaygroundFishingTripVesselMasterPk()
    {
        return this.playgroundFishingTripVesselMasterPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param playgroundFishingTripVesselMasterPkIn
     */
    public void setPlaygroundFishingTripVesselMasterPk(PlaygroundFishingTripVesselMasterPK playgroundFishingTripVesselMasterPkIn) {
        this.playgroundFishingTripVesselMasterPk = playgroundFishingTripVesselMasterPkIn;
    }

    // Generate 1 attributes
    /**
     * Numéro d'ordre du patron de peche, dans la marée.
     * @return this.rank Integer
     */
    public Integer getRank()
    {
        return this.getPlaygroundFishingTripVesselMasterPk().getRank();
    }

    /**
     * Numéro d'ordre du patron de peche, dans la marée.
     * @param rankIn Integer
     */
    public void setRank(Integer rankIn)
    {
        this.getPlaygroundFishingTripVesselMasterPk().setRank(rankIn);
    }

    // Generate 2 associations
    private FishingTrip fishingTrip;

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @return this.fishingTrip FishingTrip
     */
    public FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @param fishingTripIn FishingTrip
     */
    public void setFishingTrip(FishingTrip fishingTripIn)
    {
        this.fishingTrip = fishingTripIn;
    }

    private PlaygroundVesselMaster playgroundVesselMaster;

    /**
     * Capitaine (patron) de navire.
     * A interpreter (une fois les données connues) et remodeliser.
     * ref : flux SACAPT
     * @return this.playgroundVesselMaster PlaygroundVesselMaster
     */
    public PlaygroundVesselMaster getPlaygroundVesselMaster()
    {
        return this.playgroundVesselMaster;
    }

    /**
     * Capitaine (patron) de navire.
     * A interpreter (une fois les données connues) et remodeliser.
     * ref : flux SACAPT
     * @param playgroundVesselMasterIn PlaygroundVesselMaster
     */
    public void setPlaygroundVesselMaster(PlaygroundVesselMaster playgroundVesselMasterIn)
    {
        this.playgroundVesselMaster = playgroundVesselMasterIn;
    }

    /**
     * Returns <code>true</code> if the argument is an PlaygroundFishingTripVesselMaster instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof PlaygroundFishingTripVesselMaster))
        {
            return false;
        }
        final PlaygroundFishingTripVesselMaster that = (PlaygroundFishingTripVesselMaster)object;
        if (this.playgroundFishingTripVesselMasterPk == null || that.playgroundFishingTripVesselMasterPk == null || !this.playgroundFishingTripVesselMasterPk.equals(that.playgroundFishingTripVesselMasterPk))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.playgroundFishingTripVesselMasterPk == null ? 0 : this.playgroundFishingTripVesselMasterPk.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link PlaygroundFishingTripVesselMaster}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link PlaygroundFishingTripVesselMaster}.
         * @return new PlaygroundFishingTripVesselMasterImpl()
         */
        public static PlaygroundFishingTripVesselMaster newInstance()
        {
            return new PlaygroundFishingTripVesselMasterImpl();
        }


        /**
         * Constructs a new instance of {@link PlaygroundFishingTripVesselMaster}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param fishingTrip FishingTrip
         * @param playgroundVesselMaster PlaygroundVesselMaster
         * @return newInstance PlaygroundFishingTripVesselMaster
         */
        public static PlaygroundFishingTripVesselMaster newInstance(FishingTrip fishingTrip, PlaygroundVesselMaster playgroundVesselMaster)
        {
            final PlaygroundFishingTripVesselMaster entity = new PlaygroundFishingTripVesselMasterImpl();
            entity.setFishingTrip(fishingTrip);
            entity.setPlaygroundVesselMaster(playgroundVesselMaster);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(PlaygroundFishingTripVesselMaster o)
    {
        int cmp = 0;
        if (this.getPlaygroundFishingTripVesselMasterPk() != null)
        {
            cmp = this.getPlaygroundFishingTripVesselMasterPk().compareTo(o.getPlaygroundFishingTripVesselMasterPk());
        }
        
        return cmp;
    }
// HibernateEntity.vsl merge-point
// PlaygroundFishingTripVesselMaster.java merge-point
}