// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Type de navire.
 * exemple :
 * - industriel,
 * - grande pêche,
 * - semi industriel,
 * - plaisance,
 * - navire scientifique,
 * - pecheur à pied
 * ...
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VesselType
    implements Serializable, Comparable<VesselType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 3053373482257079587L;

    // Generate 4 attributes
    private Integer id;

    /**
     * Identifiant unique du type de navire.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Identifiant unique du type de navire.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String name;

    /**
     * Libellé du type de navire de peche
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * Libellé du type de navire de peche
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private String comments;

    /**
     * 
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * 
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    // Generate 2 associations
    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an VesselType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof VesselType))
        {
            return false;
        }
        final VesselType that = (VesselType)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link VesselType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VesselType}.
         * @return new VesselTypeImpl()
         */
        public static VesselType newInstance()
        {
            return new VesselTypeImpl();
        }

        /**
         * Constructs a new instance of {@link VesselType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param name String
         * @param updateDate Timestamp
         * @param status Status
         * @return newInstance
         */
        public static VesselType newInstance(String name, Timestamp updateDate, Status status)
        {
            final VesselType entity = new VesselTypeImpl();
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link VesselType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param name String
         * @param updateDate Timestamp
         * @param comments String
         * @param status Status
         * @return newInstance VesselType
         */
        public static VesselType newInstance(String name, Timestamp updateDate, String comments, Status status)
        {
            final VesselType entity = new VesselTypeImpl();
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setComments(comments);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VesselType o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VesselType.java merge-point
}