// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.gear;

import fr.ifremer.adagio.core.dao.referential.Status;
import fr.ifremer.adagio.core.dao.referential.ValidityStatus;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
 * </p>
 * <p>
 * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
 * classification, via les liens d'engin parents/enfants.
 * </p>
 * <p>
 * <br>
 * </p>
 * <p>
 * Exemple, pour la classification 'Engin EU corpus' :
 * </p>
 * <p>
 * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
 * </p>
 * <p>
 * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
 * </p>
 * <p>
 * * corpus 2 (...)<br>- ...
 * </p>
 * <p>
 * <br>
 * </p>
 * <p>
 * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
 * '03.0.0')<br>
 * </p>
 * <p>
 * - 'OTB' 'chalut de fond'<br>
 * </p>
 * <p>
 * - chalut p&#233;lagique
 * </p>
 * <p>
 * - ...<br>* 'Filets'
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Gear
    implements Serializable, Comparable<Gear>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6393036862397354417L;

    // Generate 6 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * Mnémonique (ou code) de l'engin. Le mnémonique doit être unique pour une meme classification
     * d'engin.
     * Par exemple : - Pour la classification FAO/CSITEP : label='OTB'
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * Mnémonique (ou code) de l'engin. Le mnémonique doit être unique pour une meme classification
     * d'engin.
     * Par exemple : - Pour la classification FAO/CSITEP : label='OTB'
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private String name;

    /**
     * Libellé de l'engin.
     * il s'agit du libellé "officiel" de la classification.
     * note : ce libellé peut etre régionalisé via "GearLocation".
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * Libellé de l'engin.
     * il s'agit du libellé "officiel" de la classification.
     * note : ce libellé peut etre régionalisé via "GearLocation".
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private String comments;

    /**
     * 
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * 
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    // Generate 21 associations
    private Gear parentGear;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini l'engin parent, au sein de la meme classification
     * </p>
     * <p>
     * <u>note :</u> pour une association entre des classifications diff&#233;rents,
     * cf &quot;synonymGears&quot;
     * </p>
     * </body>
     * </html>
     * @return this.parentGear Gear
     */
    public Gear getParentGear()
    {
        return this.parentGear;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini l'engin parent, au sein de la meme classification
     * </p>
     * <p>
     * <u>note :</u> pour une association entre des classifications diff&#233;rents,
     * cf &quot;synonymGears&quot;
     * </p>
     * </body>
     * </html>
     * @param parentGearIn Gear
     */
    public void setParentGear(Gear parentGearIn)
    {
        this.parentGear = parentGearIn;
    }

    private ValidityStatus validityStatus;

    /**
     * Etat de validation d'une donnée du référentiel. Utile pour les responsables de référentiel.
     * Validity status of a referential data.
     * @return this.validityStatus ValidityStatus
     */
    public ValidityStatus getValidityStatus()
    {
        return this.validityStatus;
    }

    /**
     * Etat de validation d'une donnée du référentiel. Utile pour les responsables de référentiel.
     * Validity status of a referential data.
     * @param validityStatusIn ValidityStatus
     */
    public void setValidityStatus(ValidityStatus validityStatusIn)
    {
        this.validityStatus = validityStatusIn;
    }

    private Collection<Gear> childGears = new HashSet<Gear>();

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @return this.childGears Collection<Gear>
     */
    public Collection<Gear> getChildGears()
    {
        return this.childGears;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @param childGearsIn Collection<Gear>
     */
    public void setChildGears(Collection<Gear> childGearsIn)
    {
        this.childGears = childGearsIn;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @param elementToAdd Gear
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addChildGears(Gear elementToAdd)
    {
        return this.childGears.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @param elementToRemove Gear
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeChildGears(Gear elementToRemove)
    {
        return this.childGears.remove(elementToRemove);
    }

    private GearClassification gearClassification;

    /**
     * Une classification d'engin permet le regroupement d'un ensemble cohérent d'engin.
     * Exemple :
     * - Engin FAO, appellée aussi CSITEP (Classification Standard Internationale Type des Engins de
     * Pêche), ou, en anglais : International Standard Statistical Classification of Fishing Gear
     * (ISSCFG)
     * : ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
     * - Engin CNTS (DPMA SIP)
     * - Engin EU (basé sur les engins FAO, mais adapté au contexte réglementaire européen) :
     * exemple : 	- extension pour signifier 'pas d'engin' : NO
     * extension pour signifier 'engin inconnu' : NK (Not Known)
     * 'ligne avec canne (...)' : BTF (code utilisé pour des données historique)
     * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans tmpsih)
     * - Engin Métier Ifremer (basé sur la classification FAO, et etendue aux besoins
     * Ifremer/francais)
     * Pour ObsMer, la classification utilisée est : FAO
     * Pour les observations au débarquement, la classification utilisée est : FAO + CNTS (pour
     * recroiser
     * avec les déclarations)
     * @return this.gearClassification GearClassification
     */
    public GearClassification getGearClassification()
    {
        return this.gearClassification;
    }

    /**
     * Une classification d'engin permet le regroupement d'un ensemble cohérent d'engin.
     * Exemple :
     * - Engin FAO, appellée aussi CSITEP (Classification Standard Internationale Type des Engins de
     * Pêche), ou, en anglais : International Standard Statistical Classification of Fishing Gear
     * (ISSCFG)
     * : ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
     * - Engin CNTS (DPMA SIP)
     * - Engin EU (basé sur les engins FAO, mais adapté au contexte réglementaire européen) :
     * exemple : 	- extension pour signifier 'pas d'engin' : NO
     * extension pour signifier 'engin inconnu' : NK (Not Known)
     * 'ligne avec canne (...)' : BTF (code utilisé pour des données historique)
     * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans tmpsih)
     * - Engin Métier Ifremer (basé sur la classification FAO, et etendue aux besoins
     * Ifremer/francais)
     * Pour ObsMer, la classification utilisée est : FAO
     * Pour les observations au débarquement, la classification utilisée est : FAO + CNTS (pour
     * recroiser
     * avec les déclarations)
     * @param gearClassificationIn GearClassification
     */
    public void setGearClassification(GearClassification gearClassificationIn)
    {
        this.gearClassification = gearClassificationIn;
    }

    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Gear instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Gear))
        {
            return false;
        }
        final Gear that = (Gear)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Gear}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Gear}.
         * @return new GearImpl()
         */
        public static Gear newInstance()
        {
            return new GearImpl();
        }

        /**
         * Constructs a new instance of {@link Gear}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param name String
         * @param updateDate Timestamp
         * @param validityStatus ValidityStatus
         * @param gearClassification GearClassification
         * @param status Status
         * @return newInstance
         */
        public static Gear newInstance(String label, String name, Timestamp updateDate, ValidityStatus validityStatus, GearClassification gearClassification, Status status)
        {
            final Gear entity = new GearImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setValidityStatus(validityStatus);
            entity.setGearClassification(gearClassification);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Gear}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param description String
         * @param updateDate Timestamp
         * @param comments String
         * @param parentGear Gear
         * @param validityStatus ValidityStatus
         * @param childGears Collection<Gear>
         * @param gearClassification GearClassification
         * @param status Status
         * @return newInstance Gear
         */
        public static Gear newInstance(String label, String name, String description, Timestamp updateDate, String comments, Gear parentGear, ValidityStatus validityStatus, Collection<Gear> childGears, GearClassification gearClassification, Status status)
        {
            final Gear entity = new GearImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setDescription(description);
            entity.setUpdateDate(updateDate);
            entity.setComments(comments);
            entity.setParentGear(parentGear);
            entity.setValidityStatus(validityStatus);
            entity.setChildGears(childGears);
            entity.setGearClassification(gearClassification);
            entity.setStatus(status);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Gear o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Gear.java merge-point
}