// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.gear;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * &#160;
 * </p>
 * <p>
 * Défini les coresspondances d'un engin avec des engins d'autres classifications.
 * </p>
 * <p>
 * [Regle de gestion] <b>Les correspondances au sein d'une meme classification sont interdites.
 * </b><br>[Regle de gestion] <b>La correspondance vers une classification doit avoir été autorisée
 * au préalable, au niveau de &quot;GearClassificationSynonym&quot;
 * </b><br>
 * </p>
 * <p>
 * Si la coresspondance est exacte (les engins des deux classifications sont synonymes), alors
 * chaque engin doit avoir une correspondance vers l'autre.
 * </p>
 * <p>
 * Si la coresspondance n'est pas exacte (un engin A correspond à un engin B, mais l'inverse n'est
 * pas vrai), alors une seule correspondance de A vers B est définie.
 * <br>
 * </p>
 * <p>
 * <br>
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class GearAssociation
    implements Serializable, Comparable<GearAssociation>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -4168221693816581038L;

    private GearAssociationPK gearAssociationPk;

    /**
     * Get the composite primary key identifier class
     * @return gearAssociationPk
     */
    public GearAssociationPK getGearAssociationPk()
    {
        return this.gearAssociationPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param gearAssociationPkIn
     */
    public void setGearAssociationPk(GearAssociationPK gearAssociationPkIn) {
        this.gearAssociationPk = gearAssociationPkIn;
    }

    // Generate 1 attributes
    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 2 associations
    private Gear toGear;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @return this.toGear Gear
     */
    public Gear getToGear()
    {
        return this.toGear;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @param toGearIn Gear
     */
    public void setToGear(Gear toGearIn)
    {
        this.toGear = toGearIn;
    }

    private Gear fromGear;

    /**
     * un type d'engin peut avoir des synonymes.
     * Un type d'egnin A ayant pour synonyme B, ne signifie pas forcément que B est un synonyme de
     * A.
     * @return this.fromGear Gear
     */
    public Gear getFromGear()
    {
        return this.fromGear;
    }

    /**
     * un type d'engin peut avoir des synonymes.
     * Un type d'egnin A ayant pour synonyme B, ne signifie pas forcément que B est un synonyme de
     * A.
     * @param fromGearIn Gear
     */
    public void setFromGear(Gear fromGearIn)
    {
        this.fromGear = fromGearIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link GearAssociation}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link GearAssociation}.
         * @return new GearAssociationImpl()
         */
        public static GearAssociation newInstance()
        {
            return new GearAssociationImpl();
        }


        /**
         * Constructs a new instance of {@link GearAssociation}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDate Timestamp
         * @param toGear Gear
         * @param fromGear Gear
         * @return newInstance GearAssociation
         */
        public static GearAssociation newInstance(Timestamp updateDate, Gear toGear, Gear fromGear)
        {
            final GearAssociation entity = new GearAssociationImpl();
            entity.setUpdateDate(updateDate);
            entity.setToGear(toGear);
            entity.setFromGear(fromGear);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(GearAssociation o)
    {
        int cmp = 0;
        if (this.getGearAssociationPk() != null)
        {
            cmp = this.getGearAssociationPk().compareTo(o.getGearAssociationPk());
        }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// GearAssociation.java merge-point
}