// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.gear;

import fr.ifremer.adagio.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * &#160;
 * </p>
 * <p>
 * Défini les coresspondances d'un engin avec des engins d'autres classifications.
 * </p>
 * <p>
 * [Regle de gestion] <b>Les correspondances au sein d'une meme classification sont interdites.
 * </b><br>[Regle de gestion] <b>La correspondance vers une classification doit avoir été autorisée
 * au préalable, au niveau de &quot;GearClassificationSynonym&quot;
 * </b><br>
 * </p>
 * <p>
 * Si la coresspondance est exacte (les engins des deux classifications sont synonymes), alors
 * chaque engin doit avoir une correspondance vers l'autre.
 * </p>
 * <p>
 * Si la coresspondance n'est pas exacte (un engin A correspond à un engin B, mais l'inverse n'est
 * pas vrai), alors une seule correspondance de A vers B est définie.
 * <br>
 * </p>
 * <p>
 * <br>
 * </p>
 * </body>
 * </html>
 * @see GearAssociation
 */
public interface GearAssociationDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link GearAssociation}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of GearAssociation from the persistent store.
     * @param gearAssociationPk
     * @return GearAssociation
     */
    public GearAssociation get(GearAssociationPK gearAssociationPk);

    /**
     * <p>
     * Does the same thing as {@link #get(GearAssociationPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param gearAssociationPk the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, GearAssociationPK gearAssociationPk);

    /**
     * Loads an instance of GearAssociation from the persistent store.
     * @param gearAssociationPk
     * @return GearAssociation
     */
    public GearAssociation load(GearAssociationPK gearAssociationPk);

    /**
     * <p>
     * Does the same thing as {@link #load(GearAssociationPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param gearAssociationPk the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, GearAssociationPK gearAssociationPk);

    /**
     * Loads all entities of type {@link GearAssociation}.
     *
     * @return the loaded entities.
     */
    public Collection<GearAssociation> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of GearAssociation and adds it to the persistent store.
     * @param gearAssociation
     * @return GearAssociation
     */
    public GearAssociation create(GearAssociation gearAssociation);

    /**
     * <p>
     * Does the same thing as {@link #create(GearAssociation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param gearAssociation
     * @return Object
     */
    public Object create(int transform, GearAssociation gearAssociation);

    /**
     * Creates a new instance of GearAssociation and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of GearAssociation
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<GearAssociation> create(Collection<GearAssociation> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(GearAssociation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<GearAssociation> entities);

    /**
     * <p>
     * Creates a new <code>GearAssociation</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param updateDate 
     * @return GearAssociation
     */
    public GearAssociation create(
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param updateDate 
     * @return GearAssociation
     */
    public Object create(
        int transform,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>GearAssociation</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param fromGear
     * @param toGear
     * @param updateDate
     * @return GearAssociation
     */
    public GearAssociation create(
        Gear fromGear,
        Gear toGear,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param fromGear
     * @param toGear
     * @param updateDate
     * @return Object
     */
    public Object create(
        int transform,
        Gear fromGear,
        Gear toGear,
        Timestamp updateDate);

    /**
     * Updates the <code>gearAssociation</code> instance in the persistent store.
     * @param gearAssociation
     */
    public void update(GearAssociation gearAssociation);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<GearAssociation> entities);

    /**
     * Removes the instance of GearAssociation from the persistent store.
     * @param gearAssociation
     */
    public void remove(GearAssociation gearAssociation);

    /**
     * Removes the instance of GearAssociation having the given
     * <code>identifier</code> from the persistent store.
     * @param gearAssociationPk
     */
    public void remove(GearAssociationPK gearAssociationPk);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<GearAssociation> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<GearAssociation> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.gear.GearAssociationDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.gear.GearAssociationDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final GearAssociation entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,GearAssociation)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.gear.GearAssociationDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,GearAssociation)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}