// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.gear;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Défini si une classification d'engin peut avoir des coresspondances avec des engins d'une autre
 * classification..
 * <br><b>Les correspondances entre une meme classification sont interdites.</b>
 * </p>
 * <p>
 * Si des coresspondances peuvent etre exister dans les deux sens (de la classification A vers la
 * classification B, et l'inverse), alors chaque classification doit délcaré la possibilité de
 * correspondances vers l'autre classification (= deux occurences).
 * </p>
 * <p>
 * Si des coresspondances peuvent etre exister dans les deux sens (de la classification A vers la
 * classification B, et l'inverse), alors chaque classification doit délcaré la possibilité de
 * correspondances vers l'autre classification (= deux occurences).
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class GearClassificationAssociation
    implements Serializable, Comparable<GearClassificationAssociation>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1882944028420031614L;

    private GearClassificationAssociationPK gearClassificationAssociationPk;

    /**
     * Get the composite primary key identifier class
     * @return gearClassificationAssociationPk
     */
    public GearClassificationAssociationPK getGearClassificationAssociationPk()
    {
        return this.gearClassificationAssociationPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param gearClassificationAssociationPkIn
     */
    public void setGearClassificationAssociationPk(GearClassificationAssociationPK gearClassificationAssociationPkIn) {
        this.gearClassificationAssociationPk = gearClassificationAssociationPkIn;
    }

    // Generate 1 attributes
    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 2 associations
    private GearClassification toGearClassification;

    /**
     * Une classification d'engin permet le regroupement d'un ensemble cohérent d'engin.
     * Exemple :
     * - Engin FAO, appellée aussi CSITEP (Classification Standard Internationale Type des Engins de
     * Pêche), ou, en anglais : International Standard Statistical Classification of Fishing Gear
     * (ISSCFG)
     * : ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
     * - Engin CNTS (DPMA SIP)
     * - Engin EU (basé sur les engins FAO, mais adapté au contexte réglementaire européen) :
     * exemple : 	- extension pour signifier 'pas d'engin' : NO
     * extension pour signifier 'engin inconnu' : NK (Not Known)
     * 'ligne avec canne (...)' : BTF (code utilisé pour des données historique)
     * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans tmpsih)
     * - Engin Métier Ifremer (basé sur la classification FAO, et etendue aux besoins
     * Ifremer/francais)
     * Pour ObsMer, la classification utilisée est : FAO
     * Pour les observations au débarquement, la classification utilisée est : FAO + CNTS (pour
     * recroiser
     * avec les déclarations)
     * @return this.toGearClassification GearClassification
     */
    public GearClassification getToGearClassification()
    {
        return this.toGearClassification;
    }

    /**
     * Une classification d'engin permet le regroupement d'un ensemble cohérent d'engin.
     * Exemple :
     * - Engin FAO, appellée aussi CSITEP (Classification Standard Internationale Type des Engins de
     * Pêche), ou, en anglais : International Standard Statistical Classification of Fishing Gear
     * (ISSCFG)
     * : ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
     * - Engin CNTS (DPMA SIP)
     * - Engin EU (basé sur les engins FAO, mais adapté au contexte réglementaire européen) :
     * exemple : 	- extension pour signifier 'pas d'engin' : NO
     * extension pour signifier 'engin inconnu' : NK (Not Known)
     * 'ligne avec canne (...)' : BTF (code utilisé pour des données historique)
     * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans tmpsih)
     * - Engin Métier Ifremer (basé sur la classification FAO, et etendue aux besoins
     * Ifremer/francais)
     * Pour ObsMer, la classification utilisée est : FAO
     * Pour les observations au débarquement, la classification utilisée est : FAO + CNTS (pour
     * recroiser
     * avec les déclarations)
     * @param toGearClassificationIn GearClassification
     */
    public void setToGearClassification(GearClassification toGearClassificationIn)
    {
        this.toGearClassification = toGearClassificationIn;
    }

    private GearClassification fromGearClassification;

    /**
     * Une classification d'engin permet le regroupement d'un ensemble cohérent d'engin.
     * Exemple :
     * - Engin FAO, appellée aussi CSITEP (Classification Standard Internationale Type des Engins de
     * Pêche), ou, en anglais : International Standard Statistical Classification of Fishing Gear
     * (ISSCFG)
     * : ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
     * - Engin CNTS (DPMA SIP)
     * - Engin EU (basé sur les engins FAO, mais adapté au contexte réglementaire européen) :
     * exemple : 	- extension pour signifier 'pas d'engin' : NO
     * extension pour signifier 'engin inconnu' : NK (Not Known)
     * 'ligne avec canne (...)' : BTF (code utilisé pour des données historique)
     * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans tmpsih)
     * - Engin Métier Ifremer (basé sur la classification FAO, et etendue aux besoins
     * Ifremer/francais)
     * Pour ObsMer, la classification utilisée est : FAO
     * Pour les observations au débarquement, la classification utilisée est : FAO + CNTS (pour
     * recroiser
     * avec les déclarations)
     * @return this.fromGearClassification GearClassification
     */
    public GearClassification getFromGearClassification()
    {
        return this.fromGearClassification;
    }

    /**
     * Une classification d'engin permet le regroupement d'un ensemble cohérent d'engin.
     * Exemple :
     * - Engin FAO, appellée aussi CSITEP (Classification Standard Internationale Type des Engins de
     * Pêche), ou, en anglais : International Standard Statistical Classification of Fishing Gear
     * (ISSCFG)
     * : ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
     * - Engin CNTS (DPMA SIP)
     * - Engin EU (basé sur les engins FAO, mais adapté au contexte réglementaire européen) :
     * exemple : 	- extension pour signifier 'pas d'engin' : NO
     * extension pour signifier 'engin inconnu' : NK (Not Known)
     * 'ligne avec canne (...)' : BTF (code utilisé pour des données historique)
     * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans tmpsih)
     * - Engin Métier Ifremer (basé sur la classification FAO, et etendue aux besoins
     * Ifremer/francais)
     * Pour ObsMer, la classification utilisée est : FAO
     * Pour les observations au débarquement, la classification utilisée est : FAO + CNTS (pour
     * recroiser
     * avec les déclarations)
     * @param fromGearClassificationIn GearClassification
     */
    public void setFromGearClassification(GearClassification fromGearClassificationIn)
    {
        this.fromGearClassification = fromGearClassificationIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link GearClassificationAssociation}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link GearClassificationAssociation}.
         * @return new GearClassificationAssociationImpl()
         */
        public static GearClassificationAssociation newInstance()
        {
            return new GearClassificationAssociationImpl();
        }


        /**
         * Constructs a new instance of {@link GearClassificationAssociation}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param updateDate Timestamp
         * @param toGearClassification GearClassification
         * @param fromGearClassification GearClassification
         * @return newInstance GearClassificationAssociation
         */
        public static GearClassificationAssociation newInstance(Timestamp updateDate, GearClassification toGearClassification, GearClassification fromGearClassification)
        {
            final GearClassificationAssociation entity = new GearClassificationAssociationImpl();
            entity.setUpdateDate(updateDate);
            entity.setToGearClassification(toGearClassification);
            entity.setFromGearClassification(fromGearClassification);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(GearClassificationAssociation o)
    {
        int cmp = 0;
        if (this.getGearClassificationAssociationPk() != null)
        {
            cmp = this.getGearClassificationAssociationPk().compareTo(o.getGearClassificationAssociationPk());
        }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// GearClassificationAssociation.java merge-point
}