// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.grouping;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.ObjectType;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Une classification de regroupement ne traite que d’un seul type de
 * données du référentiel à la fois (<i>ObjectType</i>).
 * Il peut s’agir de regroupement sur les métiers, les lieux, les espèces,
 * etc.
 * </p>
 * <p>
 * En revanche, un même type de données du référentiel (ex : Métier) peut
 * avoir plusieurs classification de regroupement distinctes (DCR, Ifremer,
 * Natura 2000, …)
 * </p>
 * <p>
 * </p>
 * <p>
 * Une classification de regroupement peut contenir un ou plusieurs niveaux
 * de regroupement (<i>GroupingLevel</i>).
 * </p>
 * </body>
 * </html>
 * @see GroupingClassification
 */
public interface GroupingClassificationDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link GroupingClassification}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of GroupingClassification from the persistent store.
     * @param id
     * @return GroupingClassification
     */
    public GroupingClassification get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of GroupingClassification from the persistent store.
     * @param id
     * @return GroupingClassification
     */
    public GroupingClassification load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link GroupingClassification}.
     *
     * @return the loaded entities.
     */
    public Collection<GroupingClassification> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of GroupingClassification and adds it to the persistent store.
     * @param groupingClassification
     * @return GroupingClassification
     */
    public GroupingClassification create(GroupingClassification groupingClassification);

    /**
     * <p>
     * Does the same thing as {@link #create(GroupingClassification)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param groupingClassification
     * @return Object
     */
    public Object create(int transform, GroupingClassification groupingClassification);

    /**
     * Creates a new instance of GroupingClassification and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of GroupingClassification
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<GroupingClassification> create(Collection<GroupingClassification> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(GroupingClassification)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<GroupingClassification> entities);

    /**
     * <p>
     * Creates a new <code>GroupingClassification</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param label 
     * @param name 
     * @param description 
     * @param isMandatory Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe d'exploitation).
     * @param comments 
     * @param updateDate 
     * @param objectReferenceQuery <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
A SQL query that must return identifier (column ID or CODE).
</p>
<p>
Use this query to limit a grouping classification type to a list of
entities.
</p>
<p>
</p>
<p>
<b>For instance :</b>
</p>
<ul>
<li>
Limit a grouping classification to commercial species :
</li>
</ul>
<p>
<i>select ID
<br>from TAXON_GROUP
<br>where TAXON_GROUP_TYPE_FK=2 -- FAO species</i>
</p>
</body>
</html>
     * @return GroupingClassification
     */
    public GroupingClassification create(
        String label,
        String name,
        String description,
        Boolean isMandatory,
        String comments,
        Timestamp updateDate,
        String objectReferenceQuery);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, Boolean, String, Timestamp, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param label 
     * @param name 
     * @param description 
     * @param isMandatory Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe d'exploitation).
     * @param comments 
     * @param updateDate 
     * @param objectReferenceQuery <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
A SQL query that must return identifier (column ID or CODE).
</p>
<p>
Use this query to limit a grouping classification type to a list of
entities.
</p>
<p>
</p>
<p>
<b>For instance :</b>
</p>
<ul>
<li>
Limit a grouping classification to commercial species :
</li>
</ul>
<p>
<i>select ID
<br>from TAXON_GROUP
<br>where TAXON_GROUP_TYPE_FK=2 -- FAO species</i>
</p>
</body>
</html>
     * @return GroupingClassification
     */
    public Object create(
        int transform,
        String label,
        String name,
        String description,
        Boolean isMandatory,
        String comments,
        Timestamp updateDate,
        String objectReferenceQuery);

    /**
     * <p>
     * Creates a new <code>GroupingClassification</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param isMandatory
     * @param label
     * @param name
     * @param objectType
     * @param updateDate
     * @return GroupingClassification
     */
    public GroupingClassification create(
        Boolean isMandatory,
        String label,
        String name,
        ObjectType objectType,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Boolean, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param isMandatory
     * @param label
     * @param name
     * @param objectType
     * @param updateDate
     * @return Object
     */
    public Object create(
        int transform,
        Boolean isMandatory,
        String label,
        String name,
        ObjectType objectType,
        Timestamp updateDate);

    /**
     * Updates the <code>groupingClassification</code> instance in the persistent store.
     * @param groupingClassification
     */
    public void update(GroupingClassification groupingClassification);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<GroupingClassification> entities);

    /**
     * Removes the instance of GroupingClassification from the persistent store.
     * @param groupingClassification
     */
    public void remove(GroupingClassification groupingClassification);

    /**
     * Removes the instance of GroupingClassification having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<GroupingClassification> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<GroupingClassification> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.grouping.GroupingClassificationDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.grouping.GroupingClassificationDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final GroupingClassification entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,GroupingClassification)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.grouping.GroupingClassificationDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,GroupingClassification)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}