// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.location;

import com.vividsolutions.jts.geom.MultiPolygon;
import fr.ifremer.adagio.core.dao.referential.Status;
import fr.ifremer.adagio.core.dao.referential.ValidityStatus;
import java.sql.Timestamp;

/**
 * Géomtérie polygonale (multi polygone) associée au lieu.
 * A utiliser uniquement pour les lieux ayant une géométrie polygonale ou multi polygonale : n'avoir
 * qu'un seul type de géométrie dans une table permet d'optimiser les index spatiaux d'Oracle,
 * utilisés pour les requêtes spatiales.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class LocationArea
    extends LocationImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6242618510520312301L;

    // Generate 2 attributes
    private MultiPolygon position;

    /**
     * 
     * @return this.position MultiPolygon
     */
    public MultiPolygon getPosition()
    {
        return this.position;
    }

    /**
     * 
     * @param positionIn MultiPolygon
     */
    public void setPosition(MultiPolygon positionIn)
    {
        this.position = positionIn;
    }

    private Timestamp positionUpdateDate;

    /**
     * 
     * @return this.positionUpdateDate Timestamp
     */
    public Timestamp getPositionUpdateDate()
    {
        return this.positionUpdateDate;
    }

    /**
     * 
     * @param positionUpdateDateIn Timestamp
     */
    public void setPositionUpdateDate(Timestamp positionUpdateDateIn)
    {
        this.positionUpdateDate = positionUpdateDateIn;
    }

    // Generate 0 associations
    /**
     * This entity does not have any identifiers
     * but since it extends the <code>LocationImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.referential.location.Location#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>LocationImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.referential.location.Location#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link LocationArea}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link LocationArea}.
         * @return new LocationAreaImpl()
         */
        public static LocationArea newInstance()
        {
            return new LocationAreaImpl();
        }

        /**
         * Constructs a new instance of {@link LocationArea}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param name String
         * @param updateDate Timestamp
         * @param validityStatus ValidityStatus
         * @param locationClassification LocationClassification
         * @param locationLevel LocationLevel
         * @param status Status
         * @param position MultiPolygon
         * @return newInstance
         */
        public static LocationArea newInstance(String name, Timestamp updateDate, ValidityStatus validityStatus, LocationClassification locationClassification, LocationLevel locationLevel, Status status, MultiPolygon position)
        {
            final LocationArea entity = new LocationAreaImpl();
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setValidityStatus(validityStatus);
            entity.setLocationClassification(locationClassification);
            entity.setLocationLevel(locationLevel);
            entity.setStatus(status);
            entity.setPosition(position);
            return entity;
        }

        /**
         * Constructs a new instance of {@link LocationArea}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param bathymetry Float
         * @param utFormat Short
         * @param daylightSavingTime Boolean
         * @param comments String
         * @param updateDate Timestamp
         * @param validityStatus ValidityStatus
         * @param locationClassification LocationClassification
         * @param locationLevel LocationLevel
         * @param status Status
         * @param position MultiPolygon
         * @param positionUpdateDate Timestamp
         * @return newInstance LocationArea
         */
        public static LocationArea newInstance(String label, String name, Float bathymetry, Short utFormat, Boolean daylightSavingTime, String comments, Timestamp updateDate, ValidityStatus validityStatus, LocationClassification locationClassification, LocationLevel locationLevel, Status status, MultiPolygon position, Timestamp positionUpdateDate)
        {
            final LocationArea entity = new LocationAreaImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setBathymetry(bathymetry);
            entity.setUtFormat(utFormat);
            entity.setDaylightSavingTime(daylightSavingTime);
            entity.setComments(comments);
            entity.setUpdateDate(updateDate);
            entity.setValidityStatus(validityStatus);
            entity.setLocationClassification(locationClassification);
            entity.setLocationLevel(locationLevel);
            entity.setStatus(status);
            entity.setPosition(position);
            entity.setPositionUpdateDate(positionUpdateDate);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(LocationArea o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getPosition() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPosition().compareTo(o.getPosition()));
            }
            if (this.getPositionUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPositionUpdateDate().compareTo(o.getPositionUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// LocationArea.java merge-point
}