// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.location;

import com.vividsolutions.jts.geom.MultiPolygon;
import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.Status;
import fr.ifremer.adagio.core.dao.referential.ValidityStatus;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Géomtérie polygonale (multi polygone) associée au lieu.
 * A utiliser uniquement pour les lieux ayant une géométrie polygonale ou multi polygonale : n'avoir
 * qu'un seul type de géométrie dans une table permet d'optimiser les index spatiaux d'Oracle,
 * utilisés pour les requêtes spatiales.
 * @see LocationArea
 */
public interface LocationAreaDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link LocationArea}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of LocationArea from the persistent store.
     * @param id
     * @return LocationArea
     */
    public LocationArea get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of LocationArea from the persistent store.
     * @param id
     * @return LocationArea
     */
    public LocationArea load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link LocationArea}.
     *
     * @return the loaded entities.
     */
    public Collection<LocationArea> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of LocationArea and adds it to the persistent store.
     * @param locationArea
     * @return LocationArea
     */
    public LocationArea create(LocationArea locationArea);

    /**
     * <p>
     * Does the same thing as {@link #create(LocationArea)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param locationArea
     * @return Object
     */
    public Object create(int transform, LocationArea locationArea);

    /**
     * Creates a new instance of LocationArea and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of LocationArea
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<LocationArea> create(Collection<LocationArea> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(LocationArea)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<LocationArea> entities);

    /**
     * <p>
     * Creates a new <code>LocationArea</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param position 
     * @param positionUpdateDate 
     * @param label Code du lieuExemple : pour les ports : BR, SB
     * @param name Libellé du lieu
     * @param bathymetry Valeur de la bathymétrie sur le lieu (optionnel). La bathymétrie peut être positive ou négative.
     * @param utFormat Format UT (Universal Time) de l'heure pour le lieu (0, +1, -4...).
En France métropolitaine, par exemple : +1 (= heure Europe/Paris)
     * @param daylightSavingTime Indique s'il faut opérer le changement d'heure hiver-été, vrai par défaut.
En France métropolitaine, par exemple : Vrai.
     * @param comments 
     * @param updateDate 
     * @return LocationArea
     */
    public LocationArea create(
        MultiPolygon position,
        Timestamp positionUpdateDate,
        String label,
        String name,
        Float bathymetry,
        Short utFormat,
        Boolean daylightSavingTime,
        String comments,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(MultiPolygon, Timestamp, String, String, Float, Short, Boolean, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param position 
     * @param positionUpdateDate 
     * @param label Code du lieuExemple : pour les ports : BR, SB
     * @param name Libellé du lieu
     * @param bathymetry Valeur de la bathymétrie sur le lieu (optionnel). La bathymétrie peut être positive ou négative.
     * @param utFormat Format UT (Universal Time) de l'heure pour le lieu (0, +1, -4...).
En France métropolitaine, par exemple : +1 (= heure Europe/Paris)
     * @param daylightSavingTime Indique s'il faut opérer le changement d'heure hiver-été, vrai par défaut.
En France métropolitaine, par exemple : Vrai.
     * @param comments 
     * @param updateDate 
     * @return LocationArea
     */
    public Object create(
        int transform,
        MultiPolygon position,
        Timestamp positionUpdateDate,
        String label,
        String name,
        Float bathymetry,
        Short utFormat,
        Boolean daylightSavingTime,
        String comments,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>LocationArea</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param locationClassification
     * @param locationLevel
     * @param name
     * @param status
     * @param updateDate
     * @param validityStatus
     * @param position
     * @return LocationArea
     */
    public LocationArea create(
        LocationClassification locationClassification,
        LocationLevel locationLevel,
        String name,
        Status status,
        Timestamp updateDate,
        ValidityStatus validityStatus,
        MultiPolygon position);

    /**
     * <p>
     * Does the same thing as {@link #create(MultiPolygon, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param locationClassification
     * @param locationLevel
     * @param name
     * @param status
     * @param updateDate
     * @param validityStatus
     * @param position
     * @return Object
     */
    public Object create(
        int transform,
        LocationClassification locationClassification,
        LocationLevel locationLevel,
        String name,
        Status status,
        Timestamp updateDate,
        ValidityStatus validityStatus,
        MultiPolygon position);

    /**
     * Updates the <code>locationArea</code> instance in the persistent store.
     * @param locationArea
     */
    public void update(LocationArea locationArea);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<LocationArea> entities);

    /**
     * Removes the instance of LocationArea from the persistent store.
     * @param locationArea
     */
    public void remove(LocationArea locationArea);

    /**
     * Removes the instance of LocationArea having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<LocationArea> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<LocationArea> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.location.LocationAreaDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.location.LocationAreaDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final LocationArea entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,LocationArea)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.location.LocationAreaDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,LocationArea)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}