// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.regulation;

import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.pmfm.Unit;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * The lowest individual size allowed in landings or markets. Established
 * by fishery management and enforced through control at landing sites or
 * markets, it is intended to minimize the catch of small (undersized) fish
 * or juveniles giving them a better chance to grow before being vulnerable
 * to fishing. Based on yield per recruit considerations and models, it
 * aims at avoiding or correcting growth overfishing
 * </p>
 * <p>
 * </p>
 * <p>
 * Other Definitions
 * </p>
 * <p>
 * Legislated size below which individuals of some fish species, if caught,
 * are not to be retained
 * </p>
 * <p>
 * </p>
 * <p>
 * <font size="3"><u><i>Comonwealth of Australia (1997):</i></u><i>
 * http://www.brs.gov.au/fish/gloss.html
 * </i></font><br><font size="3"><i>
 * </i></font><br>    </p>
 * <p>
 * </p>
 * <p>
 * A fishery management control on size at landing (or in the market)
 * intended to minimize the catch of small (undersized) fish or juveniles
 * giving them a better chance to grow before being vulnerable to fishing.
 * Based on yield per recruit considerations and models, it aims at
 * avoiding or correcting growth overfishing.
 * </p>
 * <p>
 * </p>
 * <p>
 * <u><i>Restrepo V. (1999):</i></u><i> Annotated Glossary of Terms in
 * Executive Summary Reports of the International Commission for the
 * Conservation of Atlantic Tunas&#180; Standing Committee on Research and
 * Statistics (SCRS). ICCAT .</i>
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class MinimumSizeAllowed
    implements Serializable, Comparable<MinimumSizeAllowed>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 610507981839147914L;

    // Generate 3 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Float minimumSize;

    /**
     * 
     * @return this.minimumSize Float
     */
    public Float getMinimumSize()
    {
        return this.minimumSize;
    }

    /**
     * 
     * @param minimumSizeIn Float
     */
    public void setMinimumSize(Float minimumSizeIn)
    {
        this.minimumSize = minimumSizeIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 4 associations
    private Corpus corpus;

    /**
     * Recueil de textes, de documents qui ont trait à une même matière.
     * Ex :
     * * Corpus 1 : réglemente/défini la peche sur des espèces données, sur une zone particulière,
     * mais
     * sans définir de droit de produire.
     * * UGS : Unité de Gestion Statistique. Sert à définir les "stocks réglementaires annuels" liés
     * aux
     * quotas.
     * * zone d'effort
     * @return this.corpus Corpus
     */
    public Corpus getCorpus()
    {
        return this.corpus;
    }

    /**
     * Recueil de textes, de documents qui ont trait à une même matière.
     * Ex :
     * * Corpus 1 : réglemente/défini la peche sur des espèces données, sur une zone particulière,
     * mais
     * sans définir de droit de produire.
     * * UGS : Unité de Gestion Statistique. Sert à définir les "stocks réglementaires annuels" liés
     * aux
     * quotas.
     * * zone d'effort
     * @param corpusIn Corpus
     */
    public void setCorpus(Corpus corpusIn)
    {
        this.corpus = corpusIn;
    }

    private Unit sizeUnit;

    /**
     * Unité d'une mesure.
     * Nombre de lignes : 30
     * @return this.sizeUnit Unit
     */
    public Unit getSizeUnit()
    {
        return this.sizeUnit;
    }

    /**
     * Unité d'une mesure.
     * Nombre de lignes : 30
     * @param sizeUnitIn Unit
     */
    public void setSizeUnit(Unit sizeUnitIn)
    {
        this.sizeUnit = sizeUnitIn;
    }

    private Collection<Location> locations = new HashSet<Location>();

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.locations Collection<Location>
     */
    public Collection<Location> getLocations()
    {
        return this.locations;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param locationsIn Collection<Location>
     */
    public void setLocations(Collection<Location> locationsIn)
    {
        this.locations = locationsIn;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param elementToAdd Location
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addLocations(Location elementToAdd)
    {
        return this.locations.add(elementToAdd);
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param elementToRemove Location
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeLocations(Location elementToRemove)
    {
        return this.locations.remove(elementToRemove);
    }

    private TaxonGroup taxonGroup;

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    /**
     * Returns <code>true</code> if the argument is an MinimumSizeAllowed instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof MinimumSizeAllowed))
        {
            return false;
        }
        final MinimumSizeAllowed that = (MinimumSizeAllowed)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link MinimumSizeAllowed}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link MinimumSizeAllowed}.
         * @return new MinimumSizeAllowedImpl()
         */
        public static MinimumSizeAllowed newInstance()
        {
            return new MinimumSizeAllowedImpl();
        }


        /**
         * Constructs a new instance of {@link MinimumSizeAllowed}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param minimumSize Float
         * @param updateDate Timestamp
         * @param corpus Corpus
         * @param sizeUnit Unit
         * @param locations Collection<Location>
         * @param taxonGroup TaxonGroup
         * @return newInstance MinimumSizeAllowed
         */
        public static MinimumSizeAllowed newInstance(Float minimumSize, Timestamp updateDate, Corpus corpus, Unit sizeUnit, Collection<Location> locations, TaxonGroup taxonGroup)
        {
            final MinimumSizeAllowed entity = new MinimumSizeAllowedImpl();
            entity.setMinimumSize(minimumSize);
            entity.setUpdateDate(updateDate);
            entity.setCorpus(corpus);
            entity.setSizeUnit(sizeUnit);
            entity.setLocations(locations);
            entity.setTaxonGroup(taxonGroup);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(MinimumSizeAllowed o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getMinimumSize() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMinimumSize().compareTo(o.getMinimumSize()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// MinimumSizeAllowed.java merge-point
}