// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.taxon;

import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.pmfm.Parameter;
import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import fr.ifremer.adagio.core.dao.referential.pmfm.Unit;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Définition des type de mensuration à appliquer (PSFM/paramètre/unité, précision), suivant
 * l'espèce commerciale, le lieu, la présentation (optionnel), et la période de validité.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonGroupLengthPmfm
    implements Serializable, Comparable<TaxonGroupLengthPmfm>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -7900471178485426657L;

    // Generate 6 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Date startDate;

    /**
     * Date de début de validité de l'association avec une mensuration.
     * @return this.startDate Date
     */
    public Date getStartDate()
    {
        return this.startDate;
    }

    /**
     * Date de début de validité de l'association avec une mensuration.
     * @param startDateIn Date
     */
    public void setStartDate(Date startDateIn)
    {
        this.startDate = startDateIn;
    }

    private Date endDate;

    /**
     * Date de fin de validité de l'association avec une mensuration (optionnelle).
     * Si vide, signifie que l'association est toujours valable
     * @return this.endDate Date
     */
    public Date getEndDate()
    {
        return this.endDate;
    }

    /**
     * Date de fin de validité de l'association avec une mensuration (optionnelle).
     * Si vide, signifie que l'association est toujours valable
     * @param endDateIn Date
     */
    public void setEndDate(Date endDateIn)
    {
        this.endDate = endDateIn;
    }

    private String description;

    /**
     * Description de l'association avec une mensuration.
     * Par exemple : la référence du manuel ou du protocole de terrain, etc.
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * Description de l'association avec une mensuration.
     * Par exemple : la référence du manuel ou du protocole de terrain, etc.
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Float precision;

    /**
     * Précision de la mensuration, exprimée dans l'unité de la mensuration.
     * Il s'agit d'un champ technique, recopié à partir de la table PMFM.
     * ATTENTION : Doit toujours être cohérent avec la valeur de la table PMFM.
     * @return this.precision Float
     */
    public Float getPrecision()
    {
        return this.precision;
    }

    /**
     * Précision de la mensuration, exprimée dans l'unité de la mensuration.
     * Il s'agit d'un champ technique, recopié à partir de la table PMFM.
     * ATTENTION : Doit toujours être cohérent avec la valeur de la table PMFM.
     * @param precisionIn Float
     */
    public void setPrecision(Float precisionIn)
    {
        this.precision = precisionIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 6 associations
    private Unit unit;

    /**
     * Champ technique, recopié à partir de l'unité du PSFM.
     * ATTENTION : Doit toujours être cohérent avec la table PMFM
     * @return this.unit Unit
     */
    public Unit getUnit()
    {
        return this.unit;
    }

    /**
     * Champ technique, recopié à partir de l'unité du PSFM.
     * ATTENTION : Doit toujours être cohérent avec la table PMFM
     * @param unitIn Unit
     */
    public void setUnit(Unit unitIn)
    {
        this.unit = unitIn;
    }

    private QualitativeValue dressing;

    /**
     * Présentation de l'individu / du poisson, servant à déterminer le bon type de mensuration à
     * appliquer.
     * @return this.dressing QualitativeValue
     */
    public QualitativeValue getDressing()
    {
        return this.dressing;
    }

    /**
     * Présentation de l'individu / du poisson, servant à déterminer le bon type de mensuration à
     * appliquer.
     * @param dressingIn QualitativeValue
     */
    public void setDressing(QualitativeValue dressingIn)
    {
        this.dressing = dressingIn;
    }

    private Parameter parameter;

    /**
     * Champ technique, recopié à partir du code pamètre du PSFM.
     * ATTENTION : Doit toujours être cohérent avec la table PMFM
     * @return this.parameter Parameter
     */
    public Parameter getParameter()
    {
        return this.parameter;
    }

    /**
     * Champ technique, recopié à partir du code pamètre du PSFM.
     * ATTENTION : Doit toujours être cohérent avec la table PMFM
     * @param parameterIn Parameter
     */
    public void setParameter(Parameter parameterIn)
    {
        this.parameter = parameterIn;
    }

    private Pmfm pmfm;

    /**
     * PSFM représentant le type de mensuration à appliquer.
     * Les champs du PSFM généralement utilisés pour exploiter la mansuration (code paramètre,
     * unité, précision) ont été recopiés dans des champs techniques de la table.
     * @return this.pmfm Pmfm
     */
    public Pmfm getPmfm()
    {
        return this.pmfm;
    }

    /**
     * PSFM représentant le type de mensuration à appliquer.
     * Les champs du PSFM généralement utilisés pour exploiter la mansuration (code paramètre,
     * unité, précision) ont été recopiés dans des champs techniques de la table.
     * @param pmfmIn Pmfm
     */
    public void setPmfm(Pmfm pmfmIn)
    {
        this.pmfm = pmfmIn;
    }

    private TaxonGroup taxonGroup;

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    private Location location;

    /**
     * Lieux (terrestre) d'application de la relation.
     * @return this.location Location
     */
    public Location getLocation()
    {
        return this.location;
    }

    /**
     * Lieux (terrestre) d'application de la relation.
     * @param locationIn Location
     */
    public void setLocation(Location locationIn)
    {
        this.location = locationIn;
    }

    /**
     * Returns <code>true</code> if the argument is an TaxonGroupLengthPmfm instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonGroupLengthPmfm))
        {
            return false;
        }
        final TaxonGroupLengthPmfm that = (TaxonGroupLengthPmfm)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TaxonGroupLengthPmfm}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonGroupLengthPmfm}.
         * @return new TaxonGroupLengthPmfmImpl()
         */
        public static TaxonGroupLengthPmfm newInstance()
        {
            return new TaxonGroupLengthPmfmImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonGroupLengthPmfm}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param startDate Date
         * @param description String
         * @param updateDate Timestamp
         * @param unit Unit
         * @param parameter Parameter
         * @param pmfm Pmfm
         * @param taxonGroup TaxonGroup
         * @param location Location
         * @return newInstance
         */
        public static TaxonGroupLengthPmfm newInstance(Date startDate, String description, Timestamp updateDate, Unit unit, Parameter parameter, Pmfm pmfm, TaxonGroup taxonGroup, Location location)
        {
            final TaxonGroupLengthPmfm entity = new TaxonGroupLengthPmfmImpl();
            entity.setStartDate(startDate);
            entity.setDescription(description);
            entity.setUpdateDate(updateDate);
            entity.setUnit(unit);
            entity.setParameter(parameter);
            entity.setPmfm(pmfm);
            entity.setTaxonGroup(taxonGroup);
            entity.setLocation(location);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonGroupLengthPmfm}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param startDate Date
         * @param endDate Date
         * @param description String
         * @param precision Float
         * @param updateDate Timestamp
         * @param unit Unit
         * @param dressing QualitativeValue
         * @param parameter Parameter
         * @param pmfm Pmfm
         * @param taxonGroup TaxonGroup
         * @param location Location
         * @return newInstance TaxonGroupLengthPmfm
         */
        public static TaxonGroupLengthPmfm newInstance(Date startDate, Date endDate, String description, Float precision, Timestamp updateDate, Unit unit, QualitativeValue dressing, Parameter parameter, Pmfm pmfm, TaxonGroup taxonGroup, Location location)
        {
            final TaxonGroupLengthPmfm entity = new TaxonGroupLengthPmfmImpl();
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setDescription(description);
            entity.setPrecision(precision);
            entity.setUpdateDate(updateDate);
            entity.setUnit(unit);
            entity.setDressing(dressing);
            entity.setParameter(parameter);
            entity.setPmfm(pmfm);
            entity.setTaxonGroup(taxonGroup);
            entity.setLocation(location);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonGroupLengthPmfm o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getStartDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStartDate().compareTo(o.getStartDate()));
            }
            if (this.getEndDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDate().compareTo(o.getEndDate()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getPrecision() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPrecision().compareTo(o.getPrecision()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonGroupLengthPmfm.java merge-point
}