// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.taxon;

import fr.ifremer.adagio.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Classe regroupant les taxons. Il s'agit en fait d'une combinaison entre un rang taxinomique, un
 * nom de taxon, un code et éventuellement un auteur et une date.
 * Cette classe regroupe les taxons valides, provisoires, obsolètes, virtuels et les synonymes.
 * On garde l'historique du passage en taxon valide, puis du passage en synonyme (date de fin
 * référent).
 * Dans COST : "Use the FAO reference list ftp://ftp.fao.org/FI/stat/data/ASFIS_sp.zip"
 * @see TaxonName
 */
public interface TaxonNameDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link TaxonName}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of TaxonName from the persistent store.
     * @param id
     * @return TaxonName
     */
    public TaxonName get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of TaxonName from the persistent store.
     * @param id
     * @return TaxonName
     */
    public TaxonName load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link TaxonName}.
     *
     * @return the loaded entities.
     */
    public Collection<TaxonName> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of TaxonName and adds it to the persistent store.
     * @param taxonName
     * @return TaxonName
     */
    public TaxonName create(TaxonName taxonName);

    /**
     * <p>
     * Does the same thing as {@link #create(TaxonName)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param taxonName
     * @return Object
     */
    public Object create(int transform, TaxonName taxonName);

    /**
     * Creates a new instance of TaxonName and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of TaxonName
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<TaxonName> create(Collection<TaxonName> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(TaxonName)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<TaxonName> entities);

    /**
     * <p>
     * Creates a new <code>TaxonName</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param name Nom latin présent dans la nomenclature du libellé. Il obéit aux règles de la concaténation du
libellé décrites dans le règle [R0018].
     * @param completeName 
     * @param isNaming Indique si les regles de nomenclature sont à appliquer.
     * @param isReferent 
     * @param upperRank Ce numéro d'ordre du taxon dans l'arbre phylogénique permet de classer les fils d'un même taxon père
et donc l'ensemble des taxons valides les uns par rapport aux autres. Il permet notamment de gérer
les ordre d'affichage suivant l'ordre taxinomique.
     * @param isVirtual 
     * @param isObsolete Indique qu’un taxon est obsolète
     * @param isTemporary Un libellé peut être provisoire (sp1,sp2 etc.)
     * @param startDate Date à laquelle le taxon est devenu valide. Cette date peut être vide si le libellé n'a jamais été
valide. Cette date est renseignée automatiquement par le système.
     * @param endDate Date où le libellé n'est plus référent et a été remplacé par un autre libellé. Cette date est
renseignée automatiquement par le système.
     * @param comments Commentaire associé au libellé du taxon.
     * @param creationDate Date de création système du libellé. Renseigné automatiquement par le système.
     * @param updateDate Date de mise à jour système du libellé. Renseigné automatiquement par le système.
     * @return TaxonName
     */
    public TaxonName create(
        String name,
        String completeName,
        Boolean isNaming,
        Boolean isReferent,
        Integer upperRank,
        Boolean isVirtual,
        Boolean isObsolete,
        Boolean isTemporary,
        Date startDate,
        Date endDate,
        String comments,
        Date creationDate,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Boolean, Boolean, Integer, Boolean, Boolean, Boolean, Date, Date, String, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param name Nom latin présent dans la nomenclature du libellé. Il obéit aux règles de la concaténation du
libellé décrites dans le règle [R0018].
     * @param completeName 
     * @param isNaming Indique si les regles de nomenclature sont à appliquer.
     * @param isReferent 
     * @param upperRank Ce numéro d'ordre du taxon dans l'arbre phylogénique permet de classer les fils d'un même taxon père
et donc l'ensemble des taxons valides les uns par rapport aux autres. Il permet notamment de gérer
les ordre d'affichage suivant l'ordre taxinomique.
     * @param isVirtual 
     * @param isObsolete Indique qu’un taxon est obsolète
     * @param isTemporary Un libellé peut être provisoire (sp1,sp2 etc.)
     * @param startDate Date à laquelle le taxon est devenu valide. Cette date peut être vide si le libellé n'a jamais été
valide. Cette date est renseignée automatiquement par le système.
     * @param endDate Date où le libellé n'est plus référent et a été remplacé par un autre libellé. Cette date est
renseignée automatiquement par le système.
     * @param comments Commentaire associé au libellé du taxon.
     * @param creationDate Date de création système du libellé. Renseigné automatiquement par le système.
     * @param updateDate Date de mise à jour système du libellé. Renseigné automatiquement par le système.
     * @return TaxonName
     */
    public Object create(
        int transform,
        String name,
        String completeName,
        Boolean isNaming,
        Boolean isReferent,
        Integer upperRank,
        Boolean isVirtual,
        Boolean isObsolete,
        Boolean isTemporary,
        Date startDate,
        Date endDate,
        String comments,
        Date creationDate,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>TaxonName</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param creationDate
     * @param isNaming
     * @param isObsolete
     * @param isReferent
     * @param isTemporary
     * @param isVirtual
     * @param name
     * @param referenceTaxon
     * @param startDate
     * @param taxonomicLevel
     * @param updateDate
     * @param upperRank
     * @return TaxonName
     */
    public TaxonName create(
        Date creationDate,
        Boolean isNaming,
        Boolean isObsolete,
        Boolean isReferent,
        Boolean isTemporary,
        Boolean isVirtual,
        String name,
        ReferenceTaxon referenceTaxon,
        Date startDate,
        TaxonomicLevel taxonomicLevel,
        Timestamp updateDate,
        Integer upperRank);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Boolean, Boolean, Integer, Boolean, Boolean, Boolean, Date, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param creationDate
     * @param isNaming
     * @param isObsolete
     * @param isReferent
     * @param isTemporary
     * @param isVirtual
     * @param name
     * @param referenceTaxon
     * @param startDate
     * @param taxonomicLevel
     * @param updateDate
     * @param upperRank
     * @return Object
     */
    public Object create(
        int transform,
        Date creationDate,
        Boolean isNaming,
        Boolean isObsolete,
        Boolean isReferent,
        Boolean isTemporary,
        Boolean isVirtual,
        String name,
        ReferenceTaxon referenceTaxon,
        Date startDate,
        TaxonomicLevel taxonomicLevel,
        Timestamp updateDate,
        Integer upperRank);

    /**
     * Updates the <code>taxonName</code> instance in the persistent store.
     * @param taxonName
     */
    public void update(TaxonName taxonName);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<TaxonName> entities);

    /**
     * Removes the instance of TaxonName from the persistent store.
     * @param taxonName
     */
    public void remove(TaxonName taxonName);

    /**
     * Removes the instance of TaxonName having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<TaxonName> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<TaxonName> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final TaxonName entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,TaxonName)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,TaxonName)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}