// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.grouping;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.referential.ObjectType;
import fr.ifremer.adagio.core.dao.referential.grouping.Grouping;
import fr.ifremer.adagio.core.dao.referential.grouping.GroupingClassification;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Table technique, calculé par routine.
 * </p>
 * <p>
 * </p>
 * <p>
 * Permet de lister les navires appartenant à un regroupement (Ex : pour
 * les typologies).
 * </p>
 * <p>
 * </p>
 * <p>
 * L’appartenance d’un navire à un regroupement est définie par une période
 * de validité, et un lieu de validité.
 * </p>
 * <p>
 * </p>
 * <p>
 * La date de fin de la période est optionnelle (si toujours en cours de
 * validité). Le lieu de validité est généralement une zone en mer.
 * </p>
 * </body>
 * </html>
 * @see GroupingVesselHierarchy
 */
public interface GroupingVesselHierarchyDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link GroupingVesselHierarchy}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of GroupingVesselHierarchy from the persistent store.
     * @param id
     * @return GroupingVesselHierarchy
     */
    public GroupingVesselHierarchy get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of GroupingVesselHierarchy from the persistent store.
     * @param id
     * @return GroupingVesselHierarchy
     */
    public GroupingVesselHierarchy load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link GroupingVesselHierarchy}.
     *
     * @return the loaded entities.
     */
    public Collection<GroupingVesselHierarchy> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of GroupingVesselHierarchy and adds it to the persistent store.
     * @param groupingVesselHierarchy
     * @return GroupingVesselHierarchy
     */
    public GroupingVesselHierarchy create(GroupingVesselHierarchy groupingVesselHierarchy);

    /**
     * <p>
     * Does the same thing as {@link #create(GroupingVesselHierarchy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param groupingVesselHierarchy
     * @return Object
     */
    public Object create(int transform, GroupingVesselHierarchy groupingVesselHierarchy);

    /**
     * Creates a new instance of GroupingVesselHierarchy and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of GroupingVesselHierarchy
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<GroupingVesselHierarchy> create(Collection<GroupingVesselHierarchy> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(GroupingVesselHierarchy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<GroupingVesselHierarchy> entities);

    /**
     * <p>
     * Creates a new <code>GroupingVesselHierarchy</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param startDate Début de validité de l'association Navire/Lieu/Regroupement
     * @param endDate Fin  de validité de l'association Group/Navire/Lieu. Optionnelle : si vide, signifie "en cours de
validité".
     * @param updateDate 
     * @return GroupingVesselHierarchy
     */
    public GroupingVesselHierarchy create(
        Date startDate,
        Date endDate,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param startDate Début de validité de l'association Navire/Lieu/Regroupement
     * @param endDate Fin  de validité de l'association Group/Navire/Lieu. Optionnelle : si vide, signifie "en cours de
validité".
     * @param updateDate 
     * @return GroupingVesselHierarchy
     */
    public Object create(
        int transform,
        Date startDate,
        Date endDate,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>GroupingVesselHierarchy</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param grouping
     * @param groupingClassification
     * @param location
     * @param originObjectType
     * @param originProgram
     * @param startDate
     * @param updateDate
     * @param vessel
     * @return GroupingVesselHierarchy
     */
    public GroupingVesselHierarchy create(
        Grouping grouping,
        GroupingClassification groupingClassification,
        Location location,
        ObjectType originObjectType,
        Program originProgram,
        Date startDate,
        Timestamp updateDate,
        Vessel vessel);

    /**
     * <p>
     * Does the same thing as {@link #create(Date, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param grouping
     * @param groupingClassification
     * @param location
     * @param originObjectType
     * @param originProgram
     * @param startDate
     * @param updateDate
     * @param vessel
     * @return Object
     */
    public Object create(
        int transform,
        Grouping grouping,
        GroupingClassification groupingClassification,
        Location location,
        ObjectType originObjectType,
        Program originProgram,
        Date startDate,
        Timestamp updateDate,
        Vessel vessel);

    /**
     * Updates the <code>groupingVesselHierarchy</code> instance in the persistent store.
     * @param groupingVesselHierarchy
     */
    public void update(GroupingVesselHierarchy groupingVesselHierarchy);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<GroupingVesselHierarchy> entities);

    /**
     * Removes the instance of GroupingVesselHierarchy from the persistent store.
     * @param groupingVesselHierarchy
     */
    public void remove(GroupingVesselHierarchy groupingVesselHierarchy);

    /**
     * Removes the instance of GroupingVesselHierarchy having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<GroupingVesselHierarchy> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<GroupingVesselHierarchy> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.technical.optimization.grouping.GroupingVesselHierarchyDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.technical.optimization.grouping.GroupingVesselHierarchyDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final GroupingVesselHierarchy entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,GroupingVesselHierarchy)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.technical.optimization.grouping.GroupingVesselHierarchyDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,GroupingVesselHierarchy)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}