// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.location;

import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;

/**
 * Permet de surcharger les attributs de LocationHierarchy, dans l'algotithme de remplissage (cf
 * procédure P_FILL_LOCATION_HIERARCHY)
 * Par exemple, dans le cas du SIG-SIH  : besoin de forcer isMainAssociation dans le cas de 
 * secteurs en mer répartis à 50/50 sous deux lieux pères. Il faut alors choisir un seul père
 * principal.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class LocationHierarchyOverride
    implements Serializable, Comparable<LocationHierarchyOverride>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -4807162256702111565L;

    private LocationHierarchyOverridePK locationHierarchyOverridePk;

    /**
     * Get the composite primary key identifier class
     * @return locationHierarchyOverridePk
     */
    public LocationHierarchyOverridePK getLocationHierarchyOverridePk()
    {
        return this.locationHierarchyOverridePk;
    }

    /**
     * Set the composite primary key identifier class
     * @param locationHierarchyOverridePkIn
     */
    public void setLocationHierarchyOverridePk(LocationHierarchyOverridePK locationHierarchyOverridePkIn) {
        this.locationHierarchyOverridePk = locationHierarchyOverridePkIn;
    }

    // Generate 2 attributes
    private Float childSurfaceRatio;

    /**
     * 
     * @return this.childSurfaceRatio Float
     */
    public Float getChildSurfaceRatio()
    {
        return this.childSurfaceRatio;
    }

    /**
     * 
     * @param childSurfaceRatioIn Float
     */
    public void setChildSurfaceRatio(Float childSurfaceRatioIn)
    {
        this.childSurfaceRatio = childSurfaceRatioIn;
    }

    private Boolean isMainAssociation;

    /**
     * 
     * @return this.isMainAssociation Boolean
     */
    public Boolean getIsMainAssociation()
    {
        return this.isMainAssociation;
    }

    /**
     * 
     * @param isMainAssociationIn Boolean
     */
    public void setIsMainAssociation(Boolean isMainAssociationIn)
    {
        this.isMainAssociation = isMainAssociationIn;
    }

    // Generate 2 associations
    private Location parent;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.parent Location
     */
    public Location getParent()
    {
        return this.parent;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param parentIn Location
     */
    public void setParent(Location parentIn)
    {
        this.parent = parentIn;
    }

    private Location location;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.location Location
     */
    public Location getLocation()
    {
        return this.location;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param locationIn Location
     */
    public void setLocation(Location locationIn)
    {
        this.location = locationIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link LocationHierarchyOverride}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link LocationHierarchyOverride}.
         * @return new LocationHierarchyOverrideImpl()
         */
        public static LocationHierarchyOverride newInstance()
        {
            return new LocationHierarchyOverrideImpl();
        }

        /**
         * Constructs a new instance of {@link LocationHierarchyOverride}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param parent Location
         * @param location Location
         * @return newInstance
         */
        public static LocationHierarchyOverride newInstance(Location parent, Location location)
        {
            final LocationHierarchyOverride entity = new LocationHierarchyOverrideImpl();
            entity.setParent(parent);
            entity.setLocation(location);
            return entity;
        }

        /**
         * Constructs a new instance of {@link LocationHierarchyOverride}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param childSurfaceRatio Float
         * @param isMainAssociation Boolean
         * @param parent Location
         * @param location Location
         * @return newInstance LocationHierarchyOverride
         */
        public static LocationHierarchyOverride newInstance(Float childSurfaceRatio, Boolean isMainAssociation, Location parent, Location location)
        {
            final LocationHierarchyOverride entity = new LocationHierarchyOverrideImpl();
            entity.setChildSurfaceRatio(childSurfaceRatio);
            entity.setIsMainAssociation(isMainAssociation);
            entity.setParent(parent);
            entity.setLocation(location);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(LocationHierarchyOverride o)
    {
        int cmp = 0;
        if (this.getLocationHierarchyOverridePk() != null)
        {
            cmp = this.getLocationHierarchyOverridePk().compareTo(o.getLocationHierarchyOverridePk());
        }
            if (this.getChildSurfaceRatio() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getChildSurfaceRatio().compareTo(o.getChildSurfaceRatio()));
            }
            if (this.getIsMainAssociation() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIsMainAssociation().compareTo(o.getIsMainAssociation()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// LocationHierarchyOverride.java merge-point
}