// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.location;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Permet de surcharger les attributs de LocationHierarchy, dans l'algotithme de remplissage (cf
 * procédure P_FILL_LOCATION_HIERARCHY)
 * Par exemple, dans le cas du SIG-SIH  : besoin de forcer isMainAssociation dans le cas de 
 * secteurs en mer répartis à 50/50 sous deux lieux pères. Il faut alors choisir un seul père
 * principal.
 * @see LocationHierarchyOverride
 */
public interface LocationHierarchyOverrideDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link LocationHierarchyOverride}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of LocationHierarchyOverride from the persistent store.
     * @param locationHierarchyOverridePk
     * @return LocationHierarchyOverride
     */
    public LocationHierarchyOverride get(LocationHierarchyOverridePK locationHierarchyOverridePk);

    /**
     * <p>
     * Does the same thing as {@link #get(LocationHierarchyOverridePK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param locationHierarchyOverridePk the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, LocationHierarchyOverridePK locationHierarchyOverridePk);

    /**
     * Loads an instance of LocationHierarchyOverride from the persistent store.
     * @param locationHierarchyOverridePk
     * @return LocationHierarchyOverride
     */
    public LocationHierarchyOverride load(LocationHierarchyOverridePK locationHierarchyOverridePk);

    /**
     * <p>
     * Does the same thing as {@link #load(LocationHierarchyOverridePK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param locationHierarchyOverridePk the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, LocationHierarchyOverridePK locationHierarchyOverridePk);

    /**
     * Loads all entities of type {@link LocationHierarchyOverride}.
     *
     * @return the loaded entities.
     */
    public Collection<LocationHierarchyOverride> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of LocationHierarchyOverride and adds it to the persistent store.
     * @param locationHierarchyOverride
     * @return LocationHierarchyOverride
     */
    public LocationHierarchyOverride create(LocationHierarchyOverride locationHierarchyOverride);

    /**
     * <p>
     * Does the same thing as {@link #create(LocationHierarchyOverride)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param locationHierarchyOverride
     * @return Object
     */
    public Object create(int transform, LocationHierarchyOverride locationHierarchyOverride);

    /**
     * Creates a new instance of LocationHierarchyOverride and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of LocationHierarchyOverride
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<LocationHierarchyOverride> create(Collection<LocationHierarchyOverride> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(LocationHierarchyOverride)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<LocationHierarchyOverride> entities);

    /**
     * <p>
     * Creates a new <code>LocationHierarchyOverride</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param childSurfaceRatio 
     * @param isMainAssociation 
     * @return LocationHierarchyOverride
     */
    public LocationHierarchyOverride create(
        Float childSurfaceRatio,
        Boolean isMainAssociation);

    /**
     * <p>
     * Does the same thing as {@link #create(Float, Boolean)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param childSurfaceRatio 
     * @param isMainAssociation 
     * @return LocationHierarchyOverride
     */
    public Object create(
        int transform,
        Float childSurfaceRatio,
        Boolean isMainAssociation);

    /**
     * <p>
     * Creates a new <code>LocationHierarchyOverride</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param location
     * @param parent
     * @return LocationHierarchyOverride
     */
    public LocationHierarchyOverride create(
        Location location,
        Location parent);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param location
     * @param parent
     * @return Object
     */
    public Object create(
        int transform,
        Location location,
        Location parent);

    /**
     * Updates the <code>locationHierarchyOverride</code> instance in the persistent store.
     * @param locationHierarchyOverride
     */
    public void update(LocationHierarchyOverride locationHierarchyOverride);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<LocationHierarchyOverride> entities);

    /**
     * Removes the instance of LocationHierarchyOverride from the persistent store.
     * @param locationHierarchyOverride
     */
    public void remove(LocationHierarchyOverride locationHierarchyOverride);

    /**
     * Removes the instance of LocationHierarchyOverride having the given
     * <code>identifier</code> from the persistent store.
     * @param locationHierarchyOverridePk
     */
    public void remove(LocationHierarchyOverridePK locationHierarchyOverridePk);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<LocationHierarchyOverride> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<LocationHierarchyOverride> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.technical.optimization.location.LocationHierarchyOverrideDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.technical.optimization.location.LocationHierarchyOverrideDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final LocationHierarchyOverride entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,LocationHierarchyOverride)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.technical.optimization.location.LocationHierarchyOverrideDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,LocationHierarchyOverride)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}