// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.vessel;

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.data.vessel.VesselOwner;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.util.Date;

/**
 * Denormalized table for vessel. Useful to retrieve information on vessel, such as name, owner,
 * registration country...
 * This table is NOT synchronized between Harmonie and Allegro databases.
 * @since 3.6.0
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DenormalizedVessel
    implements Serializable, Comparable<DenormalizedVessel>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6627973365953775032L;

    // Generate 7 attributes
    private String code;

    /**
     * Vesse code. Same as Vessel.code
     * @return this.code String
     */
    public String getCode()
    {
        return this.code;
    }

    /**
     * Vesse code. Same as Vessel.code
     * @param codeIn String
     */
    public void setCode(String codeIn)
    {
        this.code = codeIn;
    }

    private String name;

    /**
     * Copy of VesselFeatures.name
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * Copy of VesselFeatures.name
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String internationalRegistrationCode;

    /**
     * Copy of VesselRegistrationPeriod.internationalRegistrationCode
     * @return this.internationalRegistrationCode String
     */
    public String getInternationalRegistrationCode()
    {
        return this.internationalRegistrationCode;
    }

    /**
     * Copy of VesselRegistrationPeriod.internationalRegistrationCode
     * @param internationalRegistrationCodeIn String
     */
    public void setInternationalRegistrationCode(String internationalRegistrationCodeIn)
    {
        this.internationalRegistrationCode = internationalRegistrationCodeIn;
    }

    private String registrationCode;

    /**
     * Copy of VesselRegistrationPeriod.registrationCode
     * @return this.registrationCode String
     */
    public String getRegistrationCode()
    {
        return this.registrationCode;
    }

    /**
     * Copy of VesselRegistrationPeriod.registrationCode
     * @param registrationCodeIn String
     */
    public void setRegistrationCode(String registrationCodeIn)
    {
        this.registrationCode = registrationCodeIn;
    }

    private Date registrationStartDate;

    /**
     * Copy of VesselRegistrationPeriod.startDateTime
     * @return this.registrationStartDate Date
     */
    public Date getRegistrationStartDate()
    {
        return this.registrationStartDate;
    }

    /**
     * Copy of VesselRegistrationPeriod.startDateTime
     * @param registrationStartDateIn Date
     */
    public void setRegistrationStartDate(Date registrationStartDateIn)
    {
        this.registrationStartDate = registrationStartDateIn;
    }

    private Date registrationEndDate;

    /**
     * Copy of VesselRegistrationPeriod.endDateTime
     * @return this.registrationEndDate Date
     */
    public Date getRegistrationEndDate()
    {
        return this.registrationEndDate;
    }

    /**
     * Copy of VesselRegistrationPeriod.endDateTime
     * @param registrationEndDateIn Date
     */
    public void setRegistrationEndDate(Date registrationEndDateIn)
    {
        this.registrationEndDate = registrationEndDateIn;
    }

    private Short rankOrder = Short.valueOf("1");

    /**
     * Useful when more than one "name" found in VesselFeatures, for one registration period.
     * @return this.rankOrder Short
     */
    public Short getRankOrder()
    {
        return this.rankOrder;
    }

    /**
     * Useful when more than one "name" found in VesselFeatures, for one registration period.
     * @param rankOrderIn Short
     */
    public void setRankOrder(Short rankOrderIn)
    {
        this.rankOrder = rankOrderIn;
    }

    // Generate 5 associations
    private Location registrationLocation;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.registrationLocation Location
     */
    public Location getRegistrationLocation()
    {
        return this.registrationLocation;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param registrationLocationIn Location
     */
    public void setRegistrationLocation(Location registrationLocationIn)
    {
        this.registrationLocation = registrationLocationIn;
    }

    private Location registrationCountry;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.registrationCountry Location
     */
    public Location getRegistrationCountry()
    {
        return this.registrationCountry;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param registrationCountryIn Location
     */
    public void setRegistrationCountry(Location registrationCountryIn)
    {
        this.registrationCountry = registrationCountryIn;
    }

    private VesselOwner vesselOwner;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Armateur (ou propri&#233;taire) de navire(s). Personne physique ou morale.
     * </p>
     * <p>
     * </p>
     * <p>
     * Dans le cas de pecheur &#224; pied ou groupement de navires, <i>VesselOwner</i>
     * permet aussi de porter les informations sur le pecheur &#224; pied, ou sur le
     * responsable du groupement de navire.
     * </p>
     * <p>
     * </p>
     * <p>
     * Nombre de lignes : 20900
     * </p>
     * </body>
     * </html>
     * @return this.vesselOwner VesselOwner
     */
    public VesselOwner getVesselOwner()
    {
        return this.vesselOwner;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Armateur (ou propri&#233;taire) de navire(s). Personne physique ou morale.
     * </p>
     * <p>
     * </p>
     * <p>
     * Dans le cas de pecheur &#224; pied ou groupement de navires, <i>VesselOwner</i>
     * permet aussi de porter les informations sur le pecheur &#224; pied, ou sur le
     * responsable du groupement de navire.
     * </p>
     * <p>
     * </p>
     * <p>
     * Nombre de lignes : 20900
     * </p>
     * </body>
     * </html>
     * @param vesselOwnerIn VesselOwner
     */
    public void setVesselOwner(VesselOwner vesselOwnerIn)
    {
        this.vesselOwner = vesselOwnerIn;
    }

    private Location basePortLocation;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.basePortLocation Location
     */
    public Location getBasePortLocation()
    {
        return this.basePortLocation;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param basePortLocationIn Location
     */
    public void setBasePortLocation(Location basePortLocationIn)
    {
        this.basePortLocation = basePortLocationIn;
    }

    private Program program;

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    /**
     * Returns <code>true</code> if the argument is an DenormalizedVessel instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DenormalizedVessel))
        {
            return false;
        }
        final DenormalizedVessel that = (DenormalizedVessel)object;
        if (this.code == null || that.getCode() == null || !this.code.equals(that.getCode()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.code == null ? 0 : this.code.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link DenormalizedVessel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DenormalizedVessel}.
         * @return new DenormalizedVesselImpl()
         */
        public static DenormalizedVessel newInstance()
        {
            return new DenormalizedVesselImpl();
        }

        /**
         * Constructs a new instance of {@link DenormalizedVessel}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param registrationStartDate Date
         * @param rankOrder Short
         * @param registrationLocation Location
         * @param registrationCountry Location
         * @param program Program
         * @return newInstance
         */
        public static DenormalizedVessel newInstance(Date registrationStartDate, Short rankOrder, Location registrationLocation, Location registrationCountry, Program program)
        {
            final DenormalizedVessel entity = new DenormalizedVesselImpl();
            entity.setRegistrationStartDate(registrationStartDate);
            entity.setRankOrder(rankOrder);
            entity.setRegistrationLocation(registrationLocation);
            entity.setRegistrationCountry(registrationCountry);
            entity.setProgram(program);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DenormalizedVessel}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param name String
         * @param internationalRegistrationCode String
         * @param registrationCode String
         * @param registrationStartDate Date
         * @param registrationEndDate Date
         * @param rankOrder Short
         * @param registrationLocation Location
         * @param registrationCountry Location
         * @param vesselOwner VesselOwner
         * @param basePortLocation Location
         * @param program Program
         * @return newInstance DenormalizedVessel
         */
        public static DenormalizedVessel newInstance(String name, String internationalRegistrationCode, String registrationCode, Date registrationStartDate, Date registrationEndDate, Short rankOrder, Location registrationLocation, Location registrationCountry, VesselOwner vesselOwner, Location basePortLocation, Program program)
        {
            final DenormalizedVessel entity = new DenormalizedVesselImpl();
            entity.setName(name);
            entity.setInternationalRegistrationCode(internationalRegistrationCode);
            entity.setRegistrationCode(registrationCode);
            entity.setRegistrationStartDate(registrationStartDate);
            entity.setRegistrationEndDate(registrationEndDate);
            entity.setRankOrder(rankOrder);
            entity.setRegistrationLocation(registrationLocation);
            entity.setRegistrationCountry(registrationCountry);
            entity.setVesselOwner(vesselOwner);
            entity.setBasePortLocation(basePortLocation);
            entity.setProgram(program);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DenormalizedVessel o)
    {
        int cmp = 0;
        if (this.getCode() != null)
        {
            cmp = this.getCode().compareTo(o.getCode());
        }
        else
        {
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getInternationalRegistrationCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getInternationalRegistrationCode().compareTo(o.getInternationalRegistrationCode()));
            }
            if (this.getRegistrationCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRegistrationCode().compareTo(o.getRegistrationCode()));
            }
            if (this.getRegistrationStartDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRegistrationStartDate().compareTo(o.getRegistrationStartDate()));
            }
            if (this.getRegistrationEndDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRegistrationEndDate().compareTo(o.getRegistrationEndDate()));
            }
            if (this.getRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRankOrder().compareTo(o.getRankOrder()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DenormalizedVessel.java merge-point
}