// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.versionning;

import fr.ifremer.adagio.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Historiqque des versions du système.
 * Chaque mise à jour du schéma entraine une insertion dans cette table.
 * @see SystemVersion
 */
public interface SystemVersionDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link SystemVersion}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of SystemVersion from the persistent store.
     * @param id
     * @return SystemVersion
     */
    public SystemVersion get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of SystemVersion from the persistent store.
     * @param id
     * @return SystemVersion
     */
    public SystemVersion load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link SystemVersion}.
     *
     * @return the loaded entities.
     */
    public Collection<SystemVersion> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of SystemVersion and adds it to the persistent store.
     * @param systemVersion
     * @return SystemVersion
     */
    public SystemVersion create(SystemVersion systemVersion);

    /**
     * <p>
     * Does the same thing as {@link #create(SystemVersion)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param systemVersion
     * @return Object
     */
    public Object create(int transform, SystemVersion systemVersion);

    /**
     * Creates a new instance of SystemVersion and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of SystemVersion
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<SystemVersion> create(Collection<SystemVersion> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(SystemVersion)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<SystemVersion> entities);

    /**
     * <p>
     * Creates a new <code>SystemVersion</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param label <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
The version string. Version identifiers should have three or four
components:
</p>
<p>
</p>
<ol>
<li>
Major version. A non-negative integer.
</li>
<li>
Minor version. A non-negative integer.
</li>
<li>
Micro version. A non-negative integer.
</li>
<li>
Qualifier (optional). A text string compatible with regex :
([0-9]|[a-zA-Z]|_|-)+
</li>
</ol>
<p>
</p>
<p>
See osgi Version specification : <a
href="http://www.osgi.org/javadoc/r4v42/org/osgi/framework/Version.html">http://www.osgi.org/javadoc/r4v42/org/osgi/framework/Version.html</a>
</p>
<p>
</p>
<p>
Example :
</p>
<ul>
<li>
3.4.1
</li>
<li>
3.4.1.20130820
</li>
<li>
...
</li>
</ul>
<p>
</p>
</body>
</html>
     * @param description 
     * @param creationDate 
     * @param comments 
     * @param updateDate 
     * @return SystemVersion
     */
    public SystemVersion create(
        String label,
        String description,
        Date creationDate,
        String comments,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param label <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
The version string. Version identifiers should have three or four
components:
</p>
<p>
</p>
<ol>
<li>
Major version. A non-negative integer.
</li>
<li>
Minor version. A non-negative integer.
</li>
<li>
Micro version. A non-negative integer.
</li>
<li>
Qualifier (optional). A text string compatible with regex :
([0-9]|[a-zA-Z]|_|-)+
</li>
</ol>
<p>
</p>
<p>
See osgi Version specification : <a
href="http://www.osgi.org/javadoc/r4v42/org/osgi/framework/Version.html">http://www.osgi.org/javadoc/r4v42/org/osgi/framework/Version.html</a>
</p>
<p>
</p>
<p>
Example :
</p>
<ul>
<li>
3.4.1
</li>
<li>
3.4.1.20130820
</li>
<li>
...
</li>
</ul>
<p>
</p>
</body>
</html>
     * @param description 
     * @param creationDate 
     * @param comments 
     * @param updateDate 
     * @return SystemVersion
     */
    public Object create(
        int transform,
        String label,
        String description,
        Date creationDate,
        String comments,
        Timestamp updateDate);


    /**
     * Updates the <code>systemVersion</code> instance in the persistent store.
     * @param systemVersion
     */
    public void update(SystemVersion systemVersion);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<SystemVersion> entities);

    /**
     * Removes the instance of SystemVersion from the persistent store.
     * @param systemVersion
     */
    public void remove(SystemVersion systemVersion);

    /**
     * Removes the instance of SystemVersion having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<SystemVersion> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<SystemVersion> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.technical.versionning.SystemVersionDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.technical.versionning.SystemVersionDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final SystemVersion entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,SystemVersion)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.technical.versionning.SystemVersionDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,SystemVersion)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}