// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.batch.denormalized;

import fr.ifremer.adagio.core.dao.data.operation.Operation;
import fr.ifremer.adagio.core.dao.data.survey.sale.Sale;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.Method;
import fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
 * d'optimisation de l'exploitation de ces données.
 * Des champs additionnels sont également calculés dans cette table.
 * ATTENTION : Table technique. (RAZ des données possible).
 * Elle est remplie par le traitement de dénormalisation des lots.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DenormalizedBatch
    implements Serializable, Comparable<DenormalizedBatch>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1664833771613007885L;

    // Generate 23 attributes
    private Long id;

    /**
     * Identifiant unique du lot.
     * Même identifiant que le lot de la table BATCH correspondant : pas de numérotation
     * automatique.
     * @return this.id Long
     */
    public Long getId()
    {
        return this.id;
    }

    /**
     * Identifiant unique du lot.
     * Même identifiant que le lot de la table BATCH correspondant : pas de numérotation
     * automatique.
     * @param idIn Long
     */
    public void setId(Long idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * le label du lot d'origine, recopié depuis BATCH.LABEL
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * le label du lot d'origine, recopié depuis BATCH.LABEL
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private Short rankOrder;

    /**
     * Le numéro d'ordre au sein du lot père.
     * Recopié à partir de BATCH.RANK_ORDER.
     * @return this.rankOrder Short
     */
    public Short getRankOrder()
    {
        return this.rankOrder;
    }

    /**
     * Le numéro d'ordre au sein du lot père.
     * Recopié à partir de BATCH.RANK_ORDER.
     * @param rankOrderIn Short
     */
    public void setRankOrder(Short rankOrderIn)
    {
        this.rankOrder = rankOrderIn;
    }

    private Short flatRankOrder;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Le numéro d'ordre au sein de l'arbre d'échantillonnage déplié.
     * </p>
     * <p>
     * </p>
     * <p>
     * Ce numéro est calculé par la dénormalisation, en rangeant les lots par
     * leur RANK_ORDER, puis en insérant entre eux leur fils, eux aussi
     * ordonnés par leur RANK_ORDER; Ainsi de suite.
     * </p>
     * <p>
     * <b>Ce numéro permet donc d'ordonner les lots d'un même arbre
     * d'échantillonnage sous la forme d'un arbre entièrement déplié.
     * </b>    </p>
     * <p>
     * <b>
     * </b>    </p>
     * <p>
     * Cela est notamment utilisé dans les rapports PDF de formulaire terrain
     * avec données saisies.
     * </p>
     * </body>
     * </html>
     * @return this.flatRankOrder Short
     */
    public Short getFlatRankOrder()
    {
        return this.flatRankOrder;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Le numéro d'ordre au sein de l'arbre d'échantillonnage déplié.
     * </p>
     * <p>
     * </p>
     * <p>
     * Ce numéro est calculé par la dénormalisation, en rangeant les lots par
     * leur RANK_ORDER, puis en insérant entre eux leur fils, eux aussi
     * ordonnés par leur RANK_ORDER; Ainsi de suite.
     * </p>
     * <p>
     * <b>Ce numéro permet donc d'ordonner les lots d'un même arbre
     * d'échantillonnage sous la forme d'un arbre entièrement déplié.
     * </b>    </p>
     * <p>
     * <b>
     * </b>    </p>
     * <p>
     * Cela est notamment utilisé dans les rapports PDF de formulaire terrain
     * avec données saisies.
     * </p>
     * </body>
     * </html>
     * @param flatRankOrderIn Short
     */
    public void setFlatRankOrder(Short flatRankOrderIn)
    {
        this.flatRankOrder = flatRankOrderIn;
    }

    private Float weight;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Poids de référence du lot.
     * </p>
     * <p>
     * Recopié à partir du QUANTIFICATION_MEASUREMENT ayant
     * IS_REFERENCE_QUANTIFICATION=1.
     * </p>
     * <p>
     * </p>
     * <p>
     * Permet un affichage et une utilisation plus simple de ce poids de
     * référence.
     * </p>
     * <p>
     * Ce poids n'est pas élevé, mais il s'agit bien du poids observé et saisi
     * (par exemple sous Allegro)
     * </p>
     * </body>
     * </html>
     * @return this.weight Float
     */
    public Float getWeight()
    {
        return this.weight;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Poids de référence du lot.
     * </p>
     * <p>
     * Recopié à partir du QUANTIFICATION_MEASUREMENT ayant
     * IS_REFERENCE_QUANTIFICATION=1.
     * </p>
     * <p>
     * </p>
     * <p>
     * Permet un affichage et une utilisation plus simple de ce poids de
     * référence.
     * </p>
     * <p>
     * Ce poids n'est pas élevé, mais il s'agit bien du poids observé et saisi
     * (par exemple sous Allegro)
     * </p>
     * </body>
     * </html>
     * @param weightIn Float
     */
    public void setWeight(Float weightIn)
    {
        this.weight = weightIn;
    }

    private Float indirectWeight;

    /**
     * Poids calculé à partir de la somme des poids de référence des lots fils.
     * Calculé par le traitement d'élévation, lorsque la remontée des poids est possible (si
     * l'inventaire du lot est exhaustif).
     * ce poids n'est pas élevé : le taux d'échantillonnage du lot courant n'est pas encore
     * appliqué.
     * @return this.indirectWeight Float
     */
    public Float getIndirectWeight()
    {
        return this.indirectWeight;
    }

    /**
     * Poids calculé à partir de la somme des poids de référence des lots fils.
     * Calculé par le traitement d'élévation, lorsque la remontée des poids est possible (si
     * l'inventaire du lot est exhaustif).
     * ce poids n'est pas élevé : le taux d'échantillonnage du lot courant n'est pas encore
     * appliqué.
     * @param indirectWeightIn Float
     */
    public void setIndirectWeight(Float indirectWeightIn)
    {
        this.indirectWeight = indirectWeightIn;
    }

    private Float elevateContextWeight;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Poids élevé du lot, dans le même contexte que lors de l'observation
     * (contrairement à <i>elevateWeight</i> qui est l'élévation de
     * l'équivalent poids vif et plein).
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
     * indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
     * dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
     * des éventuels lots fraction, etc.
     * </p>
     * <p>
     * Le poids indirect ne peut pas être utilisé pour ce champ si les fils ne
     * sont pas de même présentation/état.
     * </p>
     * <p>
     * </p>
     * <p>
     * Evolutions mantis liées :
     * </p>
     * <p>
     * - #13524 (et discussion thématique #13376).
     * </p>
     * </body>
     * </html>
     * @return this.elevateContextWeight Float
     */
    public Float getElevateContextWeight()
    {
        return this.elevateContextWeight;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Poids élevé du lot, dans le même contexte que lors de l'observation
     * (contrairement à <i>elevateWeight</i> qui est l'élévation de
     * l'équivalent poids vif et plein).
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
     * indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
     * dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
     * des éventuels lots fraction, etc.
     * </p>
     * <p>
     * Le poids indirect ne peut pas être utilisé pour ce champ si les fils ne
     * sont pas de même présentation/état.
     * </p>
     * <p>
     * </p>
     * <p>
     * Evolutions mantis liées :
     * </p>
     * <p>
     * - #13524 (et discussion thématique #13376).
     * </p>
     * </body>
     * </html>
     * @param elevateContextWeightIn Float
     */
    public void setElevateContextWeight(Float elevateContextWeightIn)
    {
        this.elevateContextWeight = elevateContextWeightIn;
    }

    private Float indirectContextWeight;

    /**
     * Contextual weight, calculated using child weights (cf mantis #17728)
     * @return this.indirectContextWeight Float
     */
    public Float getIndirectContextWeight()
    {
        return this.indirectContextWeight;
    }

    /**
     * Contextual weight, calculated using child weights (cf mantis #17728)
     * @param indirectContextWeightIn Float
     */
    public void setIndirectContextWeight(Float indirectContextWeightIn)
    {
        this.indirectContextWeight = indirectContextWeightIn;
    }

    private Float elevateWeight;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Poids élevé du lot, en équivalent poids vif et plein.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
     * indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
     * dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
     * des éventuels lots fraction, etc.
     * </p>
     * <p>
     * </p>
     * <p>
     * Evolutions mantis liées :
     * </p>
     * <p>
     * - distinction avec <i>elevateContextWeight</i> : #13524 (et discussion
     * thématique #13376).
     * </p>
     * </body>
     * </html>
     * @return this.elevateWeight Float
     */
    public Float getElevateWeight()
    {
        return this.elevateWeight;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Poids élevé du lot, en équivalent poids vif et plein.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
     * indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
     * dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
     * des éventuels lots fraction, etc.
     * </p>
     * <p>
     * </p>
     * <p>
     * Evolutions mantis liées :
     * </p>
     * <p>
     * - distinction avec <i>elevateContextWeight</i> : #13524 (et discussion
     * thématique #13376).
     * </p>
     * </body>
     * </html>
     * @param elevateWeightIn Float
     */
    public void setElevateWeight(Float elevateWeightIn)
    {
        this.elevateWeight = elevateWeightIn;
    }

    private Integer individualCount;

    /**
     * Nombre d'individus observés ou comptés.
     * Recopié à partir de BATCH.INDIVIDUAL_COUNT.
     * @return this.individualCount Integer
     */
    public Integer getIndividualCount()
    {
        return this.individualCount;
    }

    /**
     * Nombre d'individus observés ou comptés.
     * Recopié à partir de BATCH.INDIVIDUAL_COUNT.
     * @param individualCountIn Integer
     */
    public void setIndividualCount(Integer individualCountIn)
    {
        this.individualCount = individualCountIn;
    }

    private Integer indirectIndividualCount;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Nombre d'individus calculé à partir de la somme des nombre d&quot;individus
     * des lots fils.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation, lorsque la remontée depuis
     * les lots fils est possible, c'est à dire si l'inventaire du lot est
     * exhaustif.
     * </p>
     * <p>
     * </p>
     * <p>
     * Ce nombre d&quot;individu n'est pas élevé : le taux d'échantillonnage du lot
     * courant n'est pas encore appliqué. Pour avoir la valeur élevée, voir le
     * champ <i>elevateIndividualCount</i>.
     * </p>
     * </body>
     * </html>
     * @return this.indirectIndividualCount Integer
     */
    public Integer getIndirectIndividualCount()
    {
        return this.indirectIndividualCount;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Nombre d'individus calculé à partir de la somme des nombre d&quot;individus
     * des lots fils.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation, lorsque la remontée depuis
     * les lots fils est possible, c'est à dire si l'inventaire du lot est
     * exhaustif.
     * </p>
     * <p>
     * </p>
     * <p>
     * Ce nombre d&quot;individu n'est pas élevé : le taux d'échantillonnage du lot
     * courant n'est pas encore appliqué. Pour avoir la valeur élevée, voir le
     * champ <i>elevateIndividualCount</i>.
     * </p>
     * </body>
     * </html>
     * @param indirectIndividualCountIn Integer
     */
    public void setIndirectIndividualCount(Integer indirectIndividualCountIn)
    {
        this.indirectIndividualCount = indirectIndividualCountIn;
    }

    private Integer elevateIndividualCount;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Nombre d'individu élevé du lot.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le nombre
     * d'individus indirects des lots fils utilisé ou non. Le choix de la
     * méthode de calcul dépend de l'exhaustiivité de l'inventaire, des taux
     * d'échantillonnage présents, des éventuels lots fraction, etc.
     * </p>
     * </body>
     * </html>
     * @return this.elevateIndividualCount Integer
     */
    public Integer getElevateIndividualCount()
    {
        return this.elevateIndividualCount;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Nombre d'individu élevé du lot.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le nombre
     * d'individus indirects des lots fils utilisé ou non. Le choix de la
     * méthode de calcul dépend de l'exhaustiivité de l'inventaire, des taux
     * d'échantillonnage présents, des éventuels lots fraction, etc.
     * </p>
     * </body>
     * </html>
     * @param elevateIndividualCountIn Integer
     */
    public void setElevateIndividualCount(Integer elevateIndividualCountIn)
    {
        this.elevateIndividualCount = elevateIndividualCountIn;
    }

    private Float samplingRatio;

    /**
     * Taux d'échantillonnage du lot.
     * Recopié depuis BATCH.SAMPLING_RATIO.
     * @return this.samplingRatio Float
     */
    public Float getSamplingRatio()
    {
        return this.samplingRatio;
    }

    /**
     * Taux d'échantillonnage du lot.
     * Recopié depuis BATCH.SAMPLING_RATIO.
     * @param samplingRatioIn Float
     */
    public void setSamplingRatio(Float samplingRatioIn)
    {
        this.samplingRatio = samplingRatioIn;
    }

    private String samplingRatioText;

    /**
     * Valeur textuelle du taux d'échantillonnage du lot (par exemple, telle que saisie sous Allegro
     * et non pas la conversion en valeur décimale).
     * Recopié depuis BATCH.SAMPLING_RATIO_TEXT.
     * @return this.samplingRatioText String
     */
    public String getSamplingRatioText()
    {
        return this.samplingRatioText;
    }

    /**
     * Valeur textuelle du taux d'échantillonnage du lot (par exemple, telle que saisie sous Allegro
     * et non pas la conversion en valeur décimale).
     * Recopié depuis BATCH.SAMPLING_RATIO_TEXT.
     * @param samplingRatioTextIn String
     */
    public void setSamplingRatioText(String samplingRatioTextIn)
    {
        this.samplingRatioText = samplingRatioTextIn;
    }

    private Boolean exhaustiveInventory;

    /**
     * Inventaire exhaustif (en terme d'espèce scientifique) : Oui (=1) ou Non (=0).
     * Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @return this.exhaustiveInventory Boolean
     */
    public Boolean getExhaustiveInventory()
    {
        return this.exhaustiveInventory;
    }

    /**
     * Inventaire exhaustif (en terme d'espèce scientifique) : Oui (=1) ou Non (=0).
     * Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @param exhaustiveInventoryIn Boolean
     */
    public void setExhaustiveInventory(Boolean exhaustiveInventoryIn)
    {
        this.exhaustiveInventory = exhaustiveInventoryIn;
    }

    private Boolean childBatchsReplication;

    /**
     * Les lots fils sont-ils des replicats statistiques (homogène en terme de répartition
     * statistique) : Oui (=1) ou Non (=0).
     * Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @return this.childBatchsReplication Boolean
     */
    public Boolean getChildBatchsReplication()
    {
        return this.childBatchsReplication;
    }

    /**
     * Les lots fils sont-ils des replicats statistiques (homogène en terme de répartition
     * statistique) : Oui (=1) ou Non (=0).
     * Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @param childBatchsReplicationIn Boolean
     */
    public void setChildBatchsReplication(Boolean childBatchsReplicationIn)
    {
        this.childBatchsReplication = childBatchsReplicationIn;
    }

    private String comments;

    /**
     * Commentaires sur le lot.
     * Recopié depuis BATCH.COMMENTS.
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * Commentaires sur le lot.
     * Recopié depuis BATCH.COMMENTS.
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Short treeLevel;

    /**
     * Niveau de profondeur du lot, dans l'arbre d'échantillonnage.
     * Calculé par le traitement de dénormalisation.
     * Le lot parent de l'arbre a un niveau "1"; Les fils de ce lot parent ont un niveau "2", etc.
     * @return this.treeLevel Short
     */
    public Short getTreeLevel()
    {
        return this.treeLevel;
    }

    /**
     * Niveau de profondeur du lot, dans l'arbre d'échantillonnage.
     * Calculé par le traitement de dénormalisation.
     * Le lot parent de l'arbre a un niveau "1"; Les fils de ce lot parent ont un niveau "2", etc.
     * @param treeLevelIn Short
     */
    public void setTreeLevel(Short treeLevelIn)
    {
        this.treeLevel = treeLevelIn;
    }

    private String treeIndent;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Chaine de caractère représentant les ramifications du lot par rapport à
     * ses pères, dans le cas d'un affichage des lots ordonné par
     * FLAT_RANK_ORDER.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple d'arbre :
     * </p>
     * <p>
     * &lt;lot_root&gt;
     * </p>
     * <p>
     * &#160;|- &lt;lot 1&gt; &#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
     * TREE_INDENT = &quot;&#160;|-&quot;
     * </p>
     * <p>
     * &#160;|- &lt;lot 2&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
     * TREE_INDENT = &quot;&#160;|-&quot;&#160;&#160;&#160;&#160;&#160;&#160;
     * </p>
     * <p>
     * &#160;| &#160;&#160;|- &lt;lot 2.1&gt;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT =
     * &quot;&#160;| &#160;&#160;|-&quot;&#160;&#160;
     * </p>
     * <p>
     * &#160;| &#160;&#160;|_ &lt;lot 2.2&gt;&#160;&#160;&#160;=&gt; TREE_INDENT = &quot;&#160;|
     * &#160;&#160;|_&quot;&#160;
     * </p>
     * <p>
     * &#160;|_ &lt;lot 3&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
     * TREE_INDENT = &quot;&#160;|_&quot;
     * </p>
     * <p>
     * </p>
     * <p>
     * Ce champ est notamment utilisé pour les rapports PDF de formulaire
     * terrain, qui représentent l'arbre tel qu'il a été saisi sous Allegro.
     * Dans le cas de ces rapports, les indentations sont remplacées à la volée
     * par des images, afin d'afficher l'arbre sous la forme d'un explorateur à
     * la manière de l'explorateur MS-Windows.
     * </p>
     * </body>
     * </html>
     * @return this.treeIndent String
     */
    public String getTreeIndent()
    {
        return this.treeIndent;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Chaine de caractère représentant les ramifications du lot par rapport à
     * ses pères, dans le cas d'un affichage des lots ordonné par
     * FLAT_RANK_ORDER.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple d'arbre :
     * </p>
     * <p>
     * &lt;lot_root&gt;
     * </p>
     * <p>
     * &#160;|- &lt;lot 1&gt; &#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
     * TREE_INDENT = &quot;&#160;|-&quot;
     * </p>
     * <p>
     * &#160;|- &lt;lot 2&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
     * TREE_INDENT = &quot;&#160;|-&quot;&#160;&#160;&#160;&#160;&#160;&#160;
     * </p>
     * <p>
     * &#160;| &#160;&#160;|- &lt;lot 2.1&gt;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT =
     * &quot;&#160;| &#160;&#160;|-&quot;&#160;&#160;
     * </p>
     * <p>
     * &#160;| &#160;&#160;|_ &lt;lot 2.2&gt;&#160;&#160;&#160;=&gt; TREE_INDENT = &quot;&#160;|
     * &#160;&#160;|_&quot;&#160;
     * </p>
     * <p>
     * &#160;|_ &lt;lot 3&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
     * TREE_INDENT = &quot;&#160;|_&quot;
     * </p>
     * <p>
     * </p>
     * <p>
     * Ce champ est notamment utilisé pour les rapports PDF de formulaire
     * terrain, qui représentent l'arbre tel qu'il a été saisi sous Allegro.
     * Dans le cas de ces rapports, les indentations sont remplacées à la volée
     * par des images, afin d'afficher l'arbre sous la forme d'un explorateur à
     * la manière de l'explorateur MS-Windows.
     * </p>
     * </body>
     * </html>
     * @param treeIndentIn String
     */
    public void setTreeIndent(String treeIndentIn)
    {
        this.treeIndent = treeIndentIn;
    }

    private String sortingValuesText;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Chaine de caractère concaténant les critères de classement du lot.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Les valeurs de tri sont récupérées à partir de SORTING_MEASUREMENT, puis
     * représentées suivant les cas par leur valeur numérique ou qualitative.
     * </p>
     * <p>
     * </p>
     * <!--StartFragment-->S<span
     * style="white-space:normal;font-size:13px;text-align:-webkit-auto;word-spacing:0px;font-family:arial,
     * sans-serif;letter-spacing:normal;text-indent:0px;font-variant:normal;color:rgb(34, 34,
     * 34);font-weight:normal;display:inline
     * !important;line-height:normal;font-style:normal;text-transform:none;float:none;">’il
     * s’agit de valeurs qualitatives, leur code et leur description sont
     * concaténés.</span><!--EndFragment-->
     * </body>
     * </html>
     * @return this.sortingValuesText String
     */
    public String getSortingValuesText()
    {
        return this.sortingValuesText;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Chaine de caractère concaténant les critères de classement du lot.
     * </p>
     * <p>
     * </p>
     * <p>
     * Calculé par le traitement de dénormalisation.
     * </p>
     * <p>
     * </p>
     * <p>
     * Les valeurs de tri sont récupérées à partir de SORTING_MEASUREMENT, puis
     * représentées suivant les cas par leur valeur numérique ou qualitative.
     * </p>
     * <p>
     * </p>
     * <!--StartFragment-->S<span
     * style="white-space:normal;font-size:13px;text-align:-webkit-auto;word-spacing:0px;font-family:arial,
     * sans-serif;letter-spacing:normal;text-indent:0px;font-variant:normal;color:rgb(34, 34,
     * 34);font-weight:normal;display:inline
     * !important;line-height:normal;font-style:normal;text-transform:none;float:none;">’il
     * s’agit de valeurs qualitatives, leur code et leur description sont
     * concaténés.</span><!--EndFragment-->
     * </body>
     * </html>
     * @param sortingValuesTextIn String
     */
    public void setSortingValuesText(String sortingValuesTextIn)
    {
        this.sortingValuesText = sortingValuesTextIn;
    }

    private Boolean isLanding;

    /**
     * Indique si le lot fait parti de la branche de l'arbre rattaché à la partie débarqué (PR).
     * Calculé par le traitement de dénormalisation.
     * Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PR",
     * alors IS_LANDING vaut 1, sinon 0.
     * @return this.isLanding Boolean
     */
    public Boolean isIsLanding()
    {
        return this.isLanding;
    }

    /**
     * Indique si le lot fait parti de la branche de l'arbre rattaché à la partie débarqué (PR).
     * Calculé par le traitement de dénormalisation.
     * Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PR",
     * alors IS_LANDING vaut 1, sinon 0.
     * @param isLandingIn Boolean
     */
    public void setIsLanding(Boolean isLandingIn)
    {
        this.isLanding = isLandingIn;
    }

    private Boolean isDiscard;

    /**
     * Indique si le lot fait parti de la branche de l'arbre rattaché à la partie rejettée (PNR).
     * Calculé par le traitement de dénormalisation.
     * Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PNR",
     * alors IS_LANDING vaut 1, sinon 0.
     * @return this.isDiscard Boolean
     */
    public Boolean isIsDiscard()
    {
        return this.isDiscard;
    }

    /**
     * Indique si le lot fait parti de la branche de l'arbre rattaché à la partie rejettée (PNR).
     * Calculé par le traitement de dénormalisation.
     * Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PNR",
     * alors IS_LANDING vaut 1, sinon 0.
     * @param isDiscardIn Boolean
     */
    public void setIsDiscard(Boolean isDiscardIn)
    {
        this.isDiscard = isDiscardIn;
    }

    private Timestamp updateDate;

    /**
     * Date de dernière mis à jour.
     * Champ technique mise à jour automatiquement (par trigger)
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * Date de dernière mis à jour.
     * Champ technique mise à jour automatiquement (par trigger)
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 12 associations
    private Method weightMethod;

    /**
     * La méthode, issue du PSFM, qui a servie à obtenir le poids de référence du lot.
     * @return this.weightMethod Method
     */
    public Method getWeightMethod()
    {
        return this.weightMethod;
    }

    /**
     * La méthode, issue du PSFM, qui a servie à obtenir le poids de référence du lot.
     * @param weightMethodIn Method
     */
    public void setWeightMethod(Method weightMethodIn)
    {
        this.weightMethod = weightMethodIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Indice qualité du lot.
     * Ce champ est rempli à partir de BATCH.QUALITY_FLAG, avec une propagation du lot père vers les
     * fils de l'indice qualité le pire.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Indice qualité du lot.
     * Ce champ est rempli à partir de BATCH.QUALITY_FLAG, avec une propagation du lot père vers les
     * fils de l'indice qualité le pire.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private TaxonGroup inheritedTaxonGroup;

    /**
     * L'espèce commerciale (TAXON_GROUP) déterminée par héritage des lots pères.
     * Calculé par le traitement de dénormalisation.
     * Ce champs est utile pour exploiter les données à partir d'une sélection de lots correspondant
     * à des attentes précises en terme de complétude de données.
     * Exemple : récupération des lots ayant un poids ET une espèce comemrciale (héritée ou non) ET
     * issus de la PR, etc.
     * Il est utilisé par exemple dans les rapports de restitution OBSMER destinés aux
     * professionnels, ou encore dans les exports au format COST ou FREE.
     * @return this.inheritedTaxonGroup TaxonGroup
     */
    public TaxonGroup getInheritedTaxonGroup()
    {
        return this.inheritedTaxonGroup;
    }

    /**
     * L'espèce commerciale (TAXON_GROUP) déterminée par héritage des lots pères.
     * Calculé par le traitement de dénormalisation.
     * Ce champs est utile pour exploiter les données à partir d'une sélection de lots correspondant
     * à des attentes précises en terme de complétude de données.
     * Exemple : récupération des lots ayant un poids ET une espèce comemrciale (héritée ou non) ET
     * issus de la PR, etc.
     * Il est utilisé par exemple dans les rapports de restitution OBSMER destinés aux
     * professionnels, ou encore dans les exports au format COST ou FREE.
     * @param inheritedTaxonGroupIn TaxonGroup
     */
    public void setInheritedTaxonGroup(TaxonGroup inheritedTaxonGroupIn)
    {
        this.inheritedTaxonGroup = inheritedTaxonGroupIn;
    }

    private TaxonGroup calculatedTaxonGroup;

    /**
     * L'espèce commerciale déterminée à partir de l'espèce commerciale.
     * Calculé par le traitement de dénormalisation.
     * Dans le cas où le lot ni aucun de ses lots pères indique une espèce comemrciale, le
     * traitement détermine la plus forte probalité d'appartenance de l'espèce scientifique à une
     * espèce ciommerciale.
     * Pour cela, les correspondances existantes entre TAXON_GROUP et REFERENCE_TAXON sont
     * exploitées (cf table TAXON_GROUP_HISTORICAL_RECORD), ou le cas échéant les correspodnances
     * trouvées dans l'arbre d'achantillonnage courant (typiquement dans la "partie retenue" PR, ou
     * les deux types d'espèces une chance d'avoir été déjà saisis).
     * Ce champ sert à afficher le nom comemrciale probable, à côté de chaque informations relatifs
     * à une espèce scientifique. C'est le cas par exemple dans les rapports de restitution OBSMER
     * aux professionnels.
     * @return this.calculatedTaxonGroup TaxonGroup
     */
    public TaxonGroup getCalculatedTaxonGroup()
    {
        return this.calculatedTaxonGroup;
    }

    /**
     * L'espèce commerciale déterminée à partir de l'espèce commerciale.
     * Calculé par le traitement de dénormalisation.
     * Dans le cas où le lot ni aucun de ses lots pères indique une espèce comemrciale, le
     * traitement détermine la plus forte probalité d'appartenance de l'espèce scientifique à une
     * espèce ciommerciale.
     * Pour cela, les correspondances existantes entre TAXON_GROUP et REFERENCE_TAXON sont
     * exploitées (cf table TAXON_GROUP_HISTORICAL_RECORD), ou le cas échéant les correspodnances
     * trouvées dans l'arbre d'achantillonnage courant (typiquement dans la "partie retenue" PR, ou
     * les deux types d'espèces une chance d'avoir été déjà saisis).
     * Ce champ sert à afficher le nom comemrciale probable, à côté de chaque informations relatifs
     * à une espèce scientifique. C'est le cas par exemple dans les rapports de restitution OBSMER
     * aux professionnels.
     * @param calculatedTaxonGroupIn TaxonGroup
     */
    public void setCalculatedTaxonGroup(TaxonGroup calculatedTaxonGroupIn)
    {
        this.calculatedTaxonGroup = calculatedTaxonGroupIn;
    }

    private ReferenceTaxon inheritedReferenceTaxon;

    /**
     * L'espèce scientifique (REFRENCE_TAXON) déterminée par héritage des lots pères.
     * Calculé par le traitement de dénormalisation.
     * Ce champs est utile pour exploiter les données à partir d'une sélection de lots correspodnant
     * à des attentes précises en terme de complétude de données.
     * Exemple : récupération des lots ayant un poids ET une espèce scientifique (héritée ou non) ET
     * issus de la PNR, etc.
     * Il est utilisé par exemple dans les rapports de restitution OBSMER destinés aux
     * professionnels, ou encore dans les exports au format COST ou FREE.
     * @return this.inheritedReferenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getInheritedReferenceTaxon()
    {
        return this.inheritedReferenceTaxon;
    }

    /**
     * L'espèce scientifique (REFRENCE_TAXON) déterminée par héritage des lots pères.
     * Calculé par le traitement de dénormalisation.
     * Ce champs est utile pour exploiter les données à partir d'une sélection de lots correspodnant
     * à des attentes précises en terme de complétude de données.
     * Exemple : récupération des lots ayant un poids ET une espèce scientifique (héritée ou non) ET
     * issus de la PNR, etc.
     * Il est utilisé par exemple dans les rapports de restitution OBSMER destinés aux
     * professionnels, ou encore dans les exports au format COST ou FREE.
     * @param inheritedReferenceTaxonIn ReferenceTaxon
     */
    public void setInheritedReferenceTaxon(ReferenceTaxon inheritedReferenceTaxonIn)
    {
        this.inheritedReferenceTaxon = inheritedReferenceTaxonIn;
    }

    private Collection<DenormalizedBatch> childBatchs = new HashSet<DenormalizedBatch>();

    /**
     * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
     * d'optimisation de l'exploitation de ces données.
     * Des champs additionnels sont également calculés dans cette table.
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @return this.childBatchs Collection<DenormalizedBatch>
     */
    public Collection<DenormalizedBatch> getChildBatchs()
    {
        return this.childBatchs;
    }

    /**
     * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
     * d'optimisation de l'exploitation de ces données.
     * Des champs additionnels sont également calculés dans cette table.
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @param childBatchsIn Collection<DenormalizedBatch>
     */
    public void setChildBatchs(Collection<DenormalizedBatch> childBatchsIn)
    {
        this.childBatchs = childBatchsIn;
    }

    /**
     * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
     * d'optimisation de l'exploitation de ces données.
     * Des champs additionnels sont également calculés dans cette table.
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @param elementToAdd DenormalizedBatch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addChildBatchs(DenormalizedBatch elementToAdd)
    {
        return this.childBatchs.add(elementToAdd);
    }

    /**
     * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
     * d'optimisation de l'exploitation de ces données.
     * Des champs additionnels sont également calculés dans cette table.
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @param elementToRemove DenormalizedBatch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeChildBatchs(DenormalizedBatch elementToRemove)
    {
        return this.childBatchs.remove(elementToRemove);
    }

    private DenormalizedBatch parentBatch;

    /**
     * Le lot parent.
     * recopié à partir de BATCH.PARENT_BATCH_FK
     * @return this.parentBatch DenormalizedBatch
     */
    public DenormalizedBatch getParentBatch()
    {
        return this.parentBatch;
    }

    /**
     * Le lot parent.
     * recopié à partir de BATCH.PARENT_BATCH_FK
     * @param parentBatchIn DenormalizedBatch
     */
    public void setParentBatch(DenormalizedBatch parentBatchIn)
    {
        this.parentBatch = parentBatchIn;
    }

    private Operation operation;

    /**
     * L'opération à laquelle est rattachée l'arbre d'échantillonnage.
     * Recopiée à partir du lien entre le lot root et l'opération (via OPERATION.CATCH_BATCH_FK),
     * puis reporté pour chaque lot fils de l'arbre.
     * Ce champ permet d'accéder sans requête SQL hiérarchique à tous les lots d'un arbre.
     * @return this.operation Operation
     */
    public Operation getOperation()
    {
        return this.operation;
    }

    /**
     * L'opération à laquelle est rattachée l'arbre d'échantillonnage.
     * Recopiée à partir du lien entre le lot root et l'opération (via OPERATION.CATCH_BATCH_FK),
     * puis reporté pour chaque lot fils de l'arbre.
     * Ce champ permet d'accéder sans requête SQL hiérarchique à tous les lots d'un arbre.
     * @param operationIn Operation
     */
    public void setOperation(Operation operationIn)
    {
        this.operation = operationIn;
    }

    private Sale sale;

    /**
     * La vente à laquelle est rattachée l'arbre d'échantillonnage.
     * Recopiée à partir du lien entre le lot root et la vente( via SALE.CATCH_BATCH_FK), puis
     * reporté pour chaque lot fils de l'arbre.
     * Ce champ permet d'accéder sans requête SQL hiérarchique à tous les lots d'un arbre.
     * @return this.sale Sale
     */
    public Sale getSale()
    {
        return this.sale;
    }

    /**
     * La vente à laquelle est rattachée l'arbre d'échantillonnage.
     * Recopiée à partir du lien entre le lot root et la vente( via SALE.CATCH_BATCH_FK), puis
     * reporté pour chaque lot fils de l'arbre.
     * Ce champ permet d'accéder sans requête SQL hiérarchique à tous les lots d'un arbre.
     * @param saleIn Sale
     */
    public void setSale(Sale saleIn)
    {
        this.sale = saleIn;
    }

    private Collection<DenormalisedBatchSortingValue> denormalisedBatchSortingValues = new HashSet<DenormalisedBatchSortingValue>();

    /**
     * Table technique stockant les critères de classement d'un lot, ainsi que les critères de
     * classement
     * des lots père (par héritage).
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @return this.denormalisedBatchSortingValues Collection<DenormalisedBatchSortingValue>
     */
    public Collection<DenormalisedBatchSortingValue> getDenormalisedBatchSortingValues()
    {
        return this.denormalisedBatchSortingValues;
    }

    /**
     * Table technique stockant les critères de classement d'un lot, ainsi que les critères de
     * classement
     * des lots père (par héritage).
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @param denormalisedBatchSortingValuesIn Collection<DenormalisedBatchSortingValue>
     */
    public void setDenormalisedBatchSortingValues(Collection<DenormalisedBatchSortingValue> denormalisedBatchSortingValuesIn)
    {
        this.denormalisedBatchSortingValues = denormalisedBatchSortingValuesIn;
    }

    /**
     * Table technique stockant les critères de classement d'un lot, ainsi que les critères de
     * classement
     * des lots père (par héritage).
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @param elementToAdd DenormalisedBatchSortingValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addDenormalisedBatchSortingValues(DenormalisedBatchSortingValue elementToAdd)
    {
        return this.denormalisedBatchSortingValues.add(elementToAdd);
    }

    /**
     * Table technique stockant les critères de classement d'un lot, ainsi que les critères de
     * classement
     * des lots père (par héritage).
     * ATTENTION : Table technique. (RAZ des données possible).
     * Elle est remplie par le traitement de dénormalisation des lots.
     * @param elementToRemove DenormalisedBatchSortingValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeDenormalisedBatchSortingValues(DenormalisedBatchSortingValue elementToRemove)
    {
        return this.denormalisedBatchSortingValues.remove(elementToRemove);
    }

    private ReferenceTaxon referenceTaxon;

    /**
     * L'espèce scientifique (REFERENCE_TAXON) saisie sur le lot.
     * Il s'agit de l'espèce sélectionnée (sous Allegro ou ISCAX) directement sur le lot courant
     * (pas d'héritage).
     * Recopiée depuis BATCH.REFERENCE_TAXON_FK.
     * @return this.referenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    /**
     * L'espèce scientifique (REFERENCE_TAXON) saisie sur le lot.
     * Il s'agit de l'espèce sélectionnée (sous Allegro ou ISCAX) directement sur le lot courant
     * (pas d'héritage).
     * Recopiée depuis BATCH.REFERENCE_TAXON_FK.
     * @param referenceTaxonIn ReferenceTaxon
     */
    public void setReferenceTaxon(ReferenceTaxon referenceTaxonIn)
    {
        this.referenceTaxon = referenceTaxonIn;
    }

    private TaxonGroup taxonGroup;

    /**
     * L'espèce commerciale (TAXON_GROUP) saisie sur le lot.
     * Il s'agit de l'espèce sélectionnée (sous Allegro ou ISCAX) directement sur le lot courant
     * (pas d'héritage).
     * Recopiée depuis BATCH.TAXON_GROUP_FK.
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * L'espèce commerciale (TAXON_GROUP) saisie sur le lot.
     * Il s'agit de l'espèce sélectionnée (sous Allegro ou ISCAX) directement sur le lot courant
     * (pas d'héritage).
     * Recopiée depuis BATCH.TAXON_GROUP_FK.
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    /**
     * Returns <code>true</code> if the argument is an DenormalizedBatch instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DenormalizedBatch))
        {
            return false;
        }
        final DenormalizedBatch that = (DenormalizedBatch)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link DenormalizedBatch}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DenormalizedBatch}.
         * @return new DenormalizedBatchImpl()
         */
        public static DenormalizedBatch newInstance()
        {
            return new DenormalizedBatchImpl();
        }

        /**
         * Constructs a new instance of {@link DenormalizedBatch}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param rankOrder Short
         * @param flatRankOrder Short
         * @param treeLevel Short
         * @param isLanding Boolean
         * @param isDiscard Boolean
         * @param updateDate Timestamp
         * @param qualityFlag QualityFlag
         * @return newInstance
         */
        public static DenormalizedBatch newInstance(Short rankOrder, Short flatRankOrder, Short treeLevel, Boolean isLanding, Boolean isDiscard, Timestamp updateDate, QualityFlag qualityFlag)
        {
            final DenormalizedBatch entity = new DenormalizedBatchImpl();
            entity.setRankOrder(rankOrder);
            entity.setFlatRankOrder(flatRankOrder);
            entity.setTreeLevel(treeLevel);
            entity.setIsLanding(isLanding);
            entity.setIsDiscard(isDiscard);
            entity.setUpdateDate(updateDate);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DenormalizedBatch}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param rankOrder Short
         * @param flatRankOrder Short
         * @param weight Float
         * @param indirectWeight Float
         * @param elevateContextWeight Float
         * @param indirectContextWeight Float
         * @param elevateWeight Float
         * @param individualCount Integer
         * @param indirectIndividualCount Integer
         * @param elevateIndividualCount Integer
         * @param samplingRatio Float
         * @param samplingRatioText String
         * @param exhaustiveInventory Boolean
         * @param childBatchsReplication Boolean
         * @param comments String
         * @param treeLevel Short
         * @param treeIndent String
         * @param sortingValuesText String
         * @param isLanding Boolean
         * @param isDiscard Boolean
         * @param updateDate Timestamp
         * @param weightMethod Method
         * @param qualityFlag QualityFlag
         * @param inheritedTaxonGroup TaxonGroup
         * @param calculatedTaxonGroup TaxonGroup
         * @param inheritedReferenceTaxon ReferenceTaxon
         * @param childBatchs Collection<DenormalizedBatch>
         * @param parentBatch DenormalizedBatch
         * @param operation Operation
         * @param sale Sale
         * @param denormalisedBatchSortingValues Collection<DenormalisedBatchSortingValue>
         * @param referenceTaxon ReferenceTaxon
         * @param taxonGroup TaxonGroup
         * @return newInstance DenormalizedBatch
         */
        public static DenormalizedBatch newInstance(String label, Short rankOrder, Short flatRankOrder, Float weight, Float indirectWeight, Float elevateContextWeight, Float indirectContextWeight, Float elevateWeight, Integer individualCount, Integer indirectIndividualCount, Integer elevateIndividualCount, Float samplingRatio, String samplingRatioText, Boolean exhaustiveInventory, Boolean childBatchsReplication, String comments, Short treeLevel, String treeIndent, String sortingValuesText, Boolean isLanding, Boolean isDiscard, Timestamp updateDate, Method weightMethod, QualityFlag qualityFlag, TaxonGroup inheritedTaxonGroup, TaxonGroup calculatedTaxonGroup, ReferenceTaxon inheritedReferenceTaxon, Collection<DenormalizedBatch> childBatchs, DenormalizedBatch parentBatch, Operation operation, Sale sale, Collection<DenormalisedBatchSortingValue> denormalisedBatchSortingValues, ReferenceTaxon referenceTaxon, TaxonGroup taxonGroup)
        {
            final DenormalizedBatch entity = new DenormalizedBatchImpl();
            entity.setLabel(label);
            entity.setRankOrder(rankOrder);
            entity.setFlatRankOrder(flatRankOrder);
            entity.setWeight(weight);
            entity.setIndirectWeight(indirectWeight);
            entity.setElevateContextWeight(elevateContextWeight);
            entity.setIndirectContextWeight(indirectContextWeight);
            entity.setElevateWeight(elevateWeight);
            entity.setIndividualCount(individualCount);
            entity.setIndirectIndividualCount(indirectIndividualCount);
            entity.setElevateIndividualCount(elevateIndividualCount);
            entity.setSamplingRatio(samplingRatio);
            entity.setSamplingRatioText(samplingRatioText);
            entity.setExhaustiveInventory(exhaustiveInventory);
            entity.setChildBatchsReplication(childBatchsReplication);
            entity.setComments(comments);
            entity.setTreeLevel(treeLevel);
            entity.setTreeIndent(treeIndent);
            entity.setSortingValuesText(sortingValuesText);
            entity.setIsLanding(isLanding);
            entity.setIsDiscard(isDiscard);
            entity.setUpdateDate(updateDate);
            entity.setWeightMethod(weightMethod);
            entity.setQualityFlag(qualityFlag);
            entity.setInheritedTaxonGroup(inheritedTaxonGroup);
            entity.setCalculatedTaxonGroup(calculatedTaxonGroup);
            entity.setInheritedReferenceTaxon(inheritedReferenceTaxon);
            entity.setChildBatchs(childBatchs);
            entity.setParentBatch(parentBatch);
            entity.setOperation(operation);
            entity.setSale(sale);
            entity.setDenormalisedBatchSortingValues(denormalisedBatchSortingValues);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setTaxonGroup(taxonGroup);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DenormalizedBatch o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRankOrder().compareTo(o.getRankOrder()));
            }
            if (this.getFlatRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFlatRankOrder().compareTo(o.getFlatRankOrder()));
            }
            if (this.getWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getWeight().compareTo(o.getWeight()));
            }
            if (this.getIndirectWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndirectWeight().compareTo(o.getIndirectWeight()));
            }
            if (this.getElevateContextWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getElevateContextWeight().compareTo(o.getElevateContextWeight()));
            }
            if (this.getIndirectContextWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndirectContextWeight().compareTo(o.getIndirectContextWeight()));
            }
            if (this.getElevateWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getElevateWeight().compareTo(o.getElevateWeight()));
            }
            if (this.getIndividualCount() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndividualCount().compareTo(o.getIndividualCount()));
            }
            if (this.getIndirectIndividualCount() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndirectIndividualCount().compareTo(o.getIndirectIndividualCount()));
            }
            if (this.getElevateIndividualCount() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getElevateIndividualCount().compareTo(o.getElevateIndividualCount()));
            }
            if (this.getSamplingRatio() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingRatio().compareTo(o.getSamplingRatio()));
            }
            if (this.getSamplingRatioText() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingRatioText().compareTo(o.getSamplingRatioText()));
            }
            if (this.getExhaustiveInventory() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getExhaustiveInventory().compareTo(o.getExhaustiveInventory()));
            }
            if (this.getChildBatchsReplication() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getChildBatchsReplication().compareTo(o.getChildBatchsReplication()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getTreeLevel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTreeLevel().compareTo(o.getTreeLevel()));
            }
            if (this.getTreeIndent() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTreeIndent().compareTo(o.getTreeIndent()));
            }
            if (this.getSortingValuesText() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSortingValuesText().compareTo(o.getSortingValuesText()));
            }
            if (this.isIsLanding() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsLanding().compareTo(o.isIsLanding()));
            }
            if (this.isIsDiscard() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsDiscard().compareTo(o.isIsDiscard()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DenormalizedBatch.java merge-point
}