// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.batch.denormalized;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Table technique mettant "à plat" les informations utiles de la table BATCH, a des fins
 * d'optimisation de l'exploitation de ces données.
 * Des champs additionnels sont également calculés dans cette table.
 * ATTENTION : Table technique. (RAZ des données possible).
 * Elle est remplie par le traitement de dénormalisation des lots.
 * @see DenormalizedBatch
 */
public interface DenormalizedBatchDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link DenormalizedBatch}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of DenormalizedBatch from the persistent store.
     * @param id
     * @return DenormalizedBatch
     */
    public DenormalizedBatch get(Long id);

    /**
     * <p>
     * Does the same thing as {@link #get(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Long id);

    /**
     * Loads an instance of DenormalizedBatch from the persistent store.
     * @param id
     * @return DenormalizedBatch
     */
    public DenormalizedBatch load(Long id);

    /**
     * <p>
     * Does the same thing as {@link #load(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Long id);

    /**
     * Loads all entities of type {@link DenormalizedBatch}.
     *
     * @return the loaded entities.
     */
    public Collection<DenormalizedBatch> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of DenormalizedBatch and adds it to the persistent store.
     * @param denormalizedBatch
     * @return DenormalizedBatch
     */
    public DenormalizedBatch create(DenormalizedBatch denormalizedBatch);

    /**
     * <p>
     * Does the same thing as {@link #create(DenormalizedBatch)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param denormalizedBatch
     * @return Object
     */
    public Object create(int transform, DenormalizedBatch denormalizedBatch);

    /**
     * Creates a new instance of DenormalizedBatch and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of DenormalizedBatch
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<DenormalizedBatch> create(Collection<DenormalizedBatch> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(DenormalizedBatch)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<DenormalizedBatch> entities);

    /**
     * <p>
     * Creates a new <code>DenormalizedBatch</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param label le label du lot d'origine, recopié depuis BATCH.LABEL
     * @param rankOrder Le numéro d'ordre au sein du lot père.
Recopié à partir de BATCH.RANK_ORDER.
     * @param flatRankOrder <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Le numéro d'ordre au sein de l'arbre d'échantillonnage déplié.
</p>
<p>
</p>
<p>
Ce numéro est calculé par la dénormalisation, en rangeant les lots par
leur RANK_ORDER, puis en insérant entre eux leur fils, eux aussi
ordonnés par leur RANK_ORDER; Ainsi de suite.
</p>
<p>
<b>Ce numéro permet donc d'ordonner les lots d'un même arbre
d'échantillonnage sous la forme d'un arbre entièrement déplié.
</b>    </p>
<p>
<b>
</b>    </p>
<p>
Cela est notamment utilisé dans les rapports PDF de formulaire terrain
avec données saisies.
</p>
</body>
</html>
     * @param weight <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Poids de référence du lot.
</p>
<p>
Recopié à partir du QUANTIFICATION_MEASUREMENT ayant
IS_REFERENCE_QUANTIFICATION=1.
</p>
<p>
</p>
<p>
Permet un affichage et une utilisation plus simple de ce poids de
référence.
</p>
<p>
Ce poids n'est pas élevé, mais il s'agit bien du poids observé et saisi
(par exemple sous Allegro)
</p>
</body>
</html>
     * @param indirectWeight Poids calculé à partir de la somme des poids de référence des lots fils.
Calculé par le traitement d'élévation, lorsque la remontée des poids est possible (si l'inventaire
du lot est exhaustif).
ce poids n'est pas élevé : le taux d'échantillonnage du lot courant n'est pas encore appliqué.
     * @param elevateContextWeight <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Poids élevé du lot, dans le même contexte que lors de l'observation
(contrairement à <i>elevateWeight</i> qui est l'élévation de
l'équivalent poids vif et plein).
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
des éventuels lots fraction, etc.
</p>
<p>
Le poids indirect ne peut pas être utilisé pour ce champ si les fils ne
sont pas de même présentation/état.
</p>
<p>
</p>
<p>
Evolutions mantis liées :
</p>
<p>
- #13524 (et discussion thématique #13376).
</p>
</body>
</html>
     * @param indirectContextWeight Contextual weight, calculated using child weights (cf mantis #17728)
     * @param elevateWeight <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Poids élevé du lot, en équivalent poids vif et plein.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
des éventuels lots fraction, etc.
</p>
<p>
</p>
<p>
Evolutions mantis liées :
</p>
<p>
- distinction avec <i>elevateContextWeight</i> : #13524 (et discussion
thématique #13376).
</p>
</body>
</html>
     * @param individualCount Nombre d'individus observés ou comptés.
Recopié à partir de BATCH.INDIVIDUAL_COUNT.
     * @param indirectIndividualCount <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Nombre d'individus calculé à partir de la somme des nombre d&quot;individus
des lots fils.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation, lorsque la remontée depuis
les lots fils est possible, c'est à dire si l'inventaire du lot est
exhaustif.
</p>
<p>
</p>
<p>
Ce nombre d&quot;individu n'est pas élevé : le taux d'échantillonnage du lot
courant n'est pas encore appliqué. Pour avoir la valeur élevée, voir le
champ <i>elevateIndividualCount</i>.
</p>
</body>
</html>
     * @param elevateIndividualCount <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Nombre d'individu élevé du lot.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Suivant les cas, les taux d'échantillonnage ont été appliqués, le nombre
d'individus indirects des lots fils utilisé ou non. Le choix de la
méthode de calcul dépend de l'exhaustiivité de l'inventaire, des taux
d'échantillonnage présents, des éventuels lots fraction, etc.
</p>
</body>
</html>
     * @param samplingRatio Taux d'échantillonnage du lot.
Recopié depuis BATCH.SAMPLING_RATIO.
     * @param samplingRatioText Valeur textuelle du taux d'échantillonnage du lot (par exemple, telle que saisie sous Allegro et non
pas la conversion en valeur décimale).
Recopié depuis BATCH.SAMPLING_RATIO_TEXT.
     * @param exhaustiveInventory Inventaire exhaustif (en terme d'espèce scientifique) : Oui (=1) ou Non (=0).
Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @param childBatchsReplication Les lots fils sont-ils des replicats statistiques (homogène en terme de répartition statistique) :
Oui (=1) ou Non (=0).
Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @param comments Commentaires sur le lot.
Recopié depuis BATCH.COMMENTS.
     * @param treeLevel Niveau de profondeur du lot, dans l'arbre d'échantillonnage.
Calculé par le traitement de dénormalisation.
Le lot parent de l'arbre a un niveau "1"; Les fils de ce lot parent ont un niveau "2", etc.
     * @param treeIndent <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Chaine de caractère représentant les ramifications du lot par rapport à
ses pères, dans le cas d'un affichage des lots ordonné par
FLAT_RANK_ORDER.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Exemple d'arbre :
</p>
<p>
&lt;lot_root&gt;
</p>
<p>
&#160;|- &lt;lot 1&gt; &#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT
= &quot;&#160;|-&quot;
</p>
<p>
&#160;|- &lt;lot 2&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
TREE_INDENT = &quot;&#160;|-&quot;&#160;&#160;&#160;&#160;&#160;&#160;
</p>
<p>
&#160;| &#160;&#160;|- &lt;lot 2.1&gt;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT = &quot;&#160;|
&#160;&#160;|-&quot;&#160;&#160;
</p>
<p>
&#160;| &#160;&#160;|_ &lt;lot 2.2&gt;&#160;&#160;&#160;=&gt; TREE_INDENT = &quot;&#160;|
&#160;&#160;|_&quot;&#160;
</p>
<p>
&#160;|_ &lt;lot 3&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT
= &quot;&#160;|_&quot;
</p>
<p>
</p>
<p>
Ce champ est notamment utilisé pour les rapports PDF de formulaire
terrain, qui représentent l'arbre tel qu'il a été saisi sous Allegro.
Dans le cas de ces rapports, les indentations sont remplacées à la volée
par des images, afin d'afficher l'arbre sous la forme d'un explorateur à
la manière de l'explorateur MS-Windows.
</p>
</body>
</html>
     * @param sortingValuesText <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Chaine de caractère concaténant les critères de classement du lot.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Les valeurs de tri sont récupérées à partir de SORTING_MEASUREMENT, puis
représentées suivant les cas par leur valeur numérique ou qualitative.
</p>
<p>
</p>
<!--StartFragment-->S<span
style="white-space:normal;font-size:13px;text-align:-webkit-auto;word-spacing:0px;font-family:arial,
sans-serif;letter-spacing:normal;text-indent:0px;font-variant:normal;color:rgb(34, 34,
34);font-weight:normal;display:inline
!important;line-height:normal;font-style:normal;text-transform:none;float:none;">’il
s’agit de valeurs qualitatives, leur code et leur description sont
concaténés.</span><!--EndFragment-->
</body>
</html>
     * @param isLanding Indique si le lot fait parti de la branche de l'arbre rattaché à la partie débarqué (PR).
Calculé par le traitement de dénormalisation.
Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PR", alors
IS_LANDING vaut 1, sinon 0.
     * @param isDiscard Indique si le lot fait parti de la branche de l'arbre rattaché à la partie rejettée (PNR).
Calculé par le traitement de dénormalisation.
Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PNR", alors
IS_LANDING vaut 1, sinon 0.
     * @param updateDate Date de dernière mis à jour.
Champ technique mise à jour automatiquement (par trigger)
     * @return DenormalizedBatch
     */
    public DenormalizedBatch create(
        String label,
        Short rankOrder,
        Short flatRankOrder,
        Float weight,
        Float indirectWeight,
        Float elevateContextWeight,
        Float indirectContextWeight,
        Float elevateWeight,
        Integer individualCount,
        Integer indirectIndividualCount,
        Integer elevateIndividualCount,
        Float samplingRatio,
        String samplingRatioText,
        Boolean exhaustiveInventory,
        Boolean childBatchsReplication,
        String comments,
        Short treeLevel,
        String treeIndent,
        String sortingValuesText,
        Boolean isLanding,
        Boolean isDiscard,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, Short, Short, Float, Float, Float, Float, Float, Integer, Integer, Integer, Float, String, Boolean, Boolean, String, Short, String, String, Boolean, Boolean, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param label le label du lot d'origine, recopié depuis BATCH.LABEL
     * @param rankOrder Le numéro d'ordre au sein du lot père.
Recopié à partir de BATCH.RANK_ORDER.
     * @param flatRankOrder <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Le numéro d'ordre au sein de l'arbre d'échantillonnage déplié.
</p>
<p>
</p>
<p>
Ce numéro est calculé par la dénormalisation, en rangeant les lots par
leur RANK_ORDER, puis en insérant entre eux leur fils, eux aussi
ordonnés par leur RANK_ORDER; Ainsi de suite.
</p>
<p>
<b>Ce numéro permet donc d'ordonner les lots d'un même arbre
d'échantillonnage sous la forme d'un arbre entièrement déplié.
</b>    </p>
<p>
<b>
</b>    </p>
<p>
Cela est notamment utilisé dans les rapports PDF de formulaire terrain
avec données saisies.
</p>
</body>
</html>
     * @param weight <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Poids de référence du lot.
</p>
<p>
Recopié à partir du QUANTIFICATION_MEASUREMENT ayant
IS_REFERENCE_QUANTIFICATION=1.
</p>
<p>
</p>
<p>
Permet un affichage et une utilisation plus simple de ce poids de
référence.
</p>
<p>
Ce poids n'est pas élevé, mais il s'agit bien du poids observé et saisi
(par exemple sous Allegro)
</p>
</body>
</html>
     * @param indirectWeight Poids calculé à partir de la somme des poids de référence des lots fils.
Calculé par le traitement d'élévation, lorsque la remontée des poids est possible (si l'inventaire
du lot est exhaustif).
ce poids n'est pas élevé : le taux d'échantillonnage du lot courant n'est pas encore appliqué.
     * @param elevateContextWeight <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Poids élevé du lot, dans le même contexte que lors de l'observation
(contrairement à <i>elevateWeight</i> qui est l'élévation de
l'équivalent poids vif et plein).
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
des éventuels lots fraction, etc.
</p>
<p>
Le poids indirect ne peut pas être utilisé pour ce champ si les fils ne
sont pas de même présentation/état.
</p>
<p>
</p>
<p>
Evolutions mantis liées :
</p>
<p>
- #13524 (et discussion thématique #13376).
</p>
</body>
</html>
     * @param indirectContextWeight Contextual weight, calculated using child weights (cf mantis #17728)
     * @param elevateWeight <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Poids élevé du lot, en équivalent poids vif et plein.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids
indirect des lots fils utilisé ou non. Le choix de la méthode de calcul
dépend de l'exhaustiivité de l'inventaire, des taux d'échantillonnage,
des éventuels lots fraction, etc.
</p>
<p>
</p>
<p>
Evolutions mantis liées :
</p>
<p>
- distinction avec <i>elevateContextWeight</i> : #13524 (et discussion
thématique #13376).
</p>
</body>
</html>
     * @param individualCount Nombre d'individus observés ou comptés.
Recopié à partir de BATCH.INDIVIDUAL_COUNT.
     * @param indirectIndividualCount <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Nombre d'individus calculé à partir de la somme des nombre d&quot;individus
des lots fils.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation, lorsque la remontée depuis
les lots fils est possible, c'est à dire si l'inventaire du lot est
exhaustif.
</p>
<p>
</p>
<p>
Ce nombre d&quot;individu n'est pas élevé : le taux d'échantillonnage du lot
courant n'est pas encore appliqué. Pour avoir la valeur élevée, voir le
champ <i>elevateIndividualCount</i>.
</p>
</body>
</html>
     * @param elevateIndividualCount <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Nombre d'individu élevé du lot.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Suivant les cas, les taux d'échantillonnage ont été appliqués, le nombre
d'individus indirects des lots fils utilisé ou non. Le choix de la
méthode de calcul dépend de l'exhaustiivité de l'inventaire, des taux
d'échantillonnage présents, des éventuels lots fraction, etc.
</p>
</body>
</html>
     * @param samplingRatio Taux d'échantillonnage du lot.
Recopié depuis BATCH.SAMPLING_RATIO.
     * @param samplingRatioText Valeur textuelle du taux d'échantillonnage du lot (par exemple, telle que saisie sous Allegro et non
pas la conversion en valeur décimale).
Recopié depuis BATCH.SAMPLING_RATIO_TEXT.
     * @param exhaustiveInventory Inventaire exhaustif (en terme d'espèce scientifique) : Oui (=1) ou Non (=0).
Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @param childBatchsReplication Les lots fils sont-ils des replicats statistiques (homogène en terme de répartition statistique) :
Oui (=1) ou Non (=0).
Recopié de puis BATCH.EXHAUSTIVE_INVENTORY.
     * @param comments Commentaires sur le lot.
Recopié depuis BATCH.COMMENTS.
     * @param treeLevel Niveau de profondeur du lot, dans l'arbre d'échantillonnage.
Calculé par le traitement de dénormalisation.
Le lot parent de l'arbre a un niveau "1"; Les fils de ce lot parent ont un niveau "2", etc.
     * @param treeIndent <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Chaine de caractère représentant les ramifications du lot par rapport à
ses pères, dans le cas d'un affichage des lots ordonné par
FLAT_RANK_ORDER.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Exemple d'arbre :
</p>
<p>
&lt;lot_root&gt;
</p>
<p>
&#160;|- &lt;lot 1&gt; &#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT
= &quot;&#160;|-&quot;
</p>
<p>
&#160;|- &lt;lot 2&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt;
TREE_INDENT = &quot;&#160;|-&quot;&#160;&#160;&#160;&#160;&#160;&#160;
</p>
<p>
&#160;| &#160;&#160;|- &lt;lot 2.1&gt;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT = &quot;&#160;|
&#160;&#160;|-&quot;&#160;&#160;
</p>
<p>
&#160;| &#160;&#160;|_ &lt;lot 2.2&gt;&#160;&#160;&#160;=&gt; TREE_INDENT = &quot;&#160;|
&#160;&#160;|_&quot;&#160;
</p>
<p>
&#160;|_ &lt;lot 3&gt;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;=&gt; TREE_INDENT
= &quot;&#160;|_&quot;
</p>
<p>
</p>
<p>
Ce champ est notamment utilisé pour les rapports PDF de formulaire
terrain, qui représentent l'arbre tel qu'il a été saisi sous Allegro.
Dans le cas de ces rapports, les indentations sont remplacées à la volée
par des images, afin d'afficher l'arbre sous la forme d'un explorateur à
la manière de l'explorateur MS-Windows.
</p>
</body>
</html>
     * @param sortingValuesText <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Chaine de caractère concaténant les critères de classement du lot.
</p>
<p>
</p>
<p>
Calculé par le traitement de dénormalisation.
</p>
<p>
</p>
<p>
Les valeurs de tri sont récupérées à partir de SORTING_MEASUREMENT, puis
représentées suivant les cas par leur valeur numérique ou qualitative.
</p>
<p>
</p>
<!--StartFragment-->S<span
style="white-space:normal;font-size:13px;text-align:-webkit-auto;word-spacing:0px;font-family:arial,
sans-serif;letter-spacing:normal;text-indent:0px;font-variant:normal;color:rgb(34, 34,
34);font-weight:normal;display:inline
!important;line-height:normal;font-style:normal;text-transform:none;float:none;">’il
s’agit de valeurs qualitatives, leur code et leur description sont
concaténés.</span><!--EndFragment-->
</body>
</html>
     * @param isLanding Indique si le lot fait parti de la branche de l'arbre rattaché à la partie débarqué (PR).
Calculé par le traitement de dénormalisation.
Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PR", alors
IS_LANDING vaut 1, sinon 0.
     * @param isDiscard Indique si le lot fait parti de la branche de l'arbre rattaché à la partie rejettée (PNR).
Calculé par le traitement de dénormalisation.
Si le lot ou un de ses lots pères à le critère de classement (SORTING_MEASUREMENT) "PNR", alors
IS_LANDING vaut 1, sinon 0.
     * @param updateDate Date de dernière mis à jour.
Champ technique mise à jour automatiquement (par trigger)
     * @return DenormalizedBatch
     */
    public Object create(
        int transform,
        String label,
        Short rankOrder,
        Short flatRankOrder,
        Float weight,
        Float indirectWeight,
        Float elevateContextWeight,
        Float indirectContextWeight,
        Float elevateWeight,
        Integer individualCount,
        Integer indirectIndividualCount,
        Integer elevateIndividualCount,
        Float samplingRatio,
        String samplingRatioText,
        Boolean exhaustiveInventory,
        Boolean childBatchsReplication,
        String comments,
        Short treeLevel,
        String treeIndent,
        String sortingValuesText,
        Boolean isLanding,
        Boolean isDiscard,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>DenormalizedBatch</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param flatRankOrder
     * @param isDiscard
     * @param isLanding
     * @param qualityFlag
     * @param rankOrder
     * @param treeLevel
     * @param updateDate
     * @return DenormalizedBatch
     */
    public DenormalizedBatch create(
        Short flatRankOrder,
        Boolean isDiscard,
        Boolean isLanding,
        QualityFlag qualityFlag,
        Short rankOrder,
        Short treeLevel,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Short, Short, Short, Boolean, Boolean, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param flatRankOrder
     * @param isDiscard
     * @param isLanding
     * @param qualityFlag
     * @param rankOrder
     * @param treeLevel
     * @param updateDate
     * @return Object
     */
    public Object create(
        int transform,
        Short flatRankOrder,
        Boolean isDiscard,
        Boolean isLanding,
        QualityFlag qualityFlag,
        Short rankOrder,
        Short treeLevel,
        Timestamp updateDate);

    /**
     * Updates the <code>denormalizedBatch</code> instance in the persistent store.
     * @param denormalizedBatch
     */
    public void update(DenormalizedBatch denormalizedBatch);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<DenormalizedBatch> entities);

    /**
     * Removes the instance of DenormalizedBatch from the persistent store.
     * @param denormalizedBatch
     */
    public void remove(DenormalizedBatch denormalizedBatch);

    /**
     * Removes the instance of DenormalizedBatch having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Long id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<DenormalizedBatch> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<DenormalizedBatch> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.batch.denormalized.DenormalizedBatchDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.batch.denormalized.DenormalizedBatchDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final DenormalizedBatch entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,DenormalizedBatch)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.batch.denormalized.DenormalizedBatchDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,DenormalizedBatch)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}