// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.operation.denormalized;

import fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip;
import fr.ifremer.adagio.core.dao.referential.gear.Gear;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.metier.Metier;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Opération sous forme dénormalisée (mise en colonne des mesures, etc).
 * L'intéret est l'optimisation des routine d'extraction (ex : extraction COST), d'exploitation des
 * données (reporting BIRT), etc.
 * ATTENTION : Table technique. (RAZ des données possible) Ne pas remplir directement, mais passer
 * par OPERATION.
 * Elle est remplie par le traitement de dénormalisation des lots.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DenormalizedOperation
    implements Serializable, Comparable<DenormalizedOperation>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 5302340262291034958L;

    // Generate 8 attributes
    private Long id;

    /**
     * Identifiant de l'opération.
     * Doit etre identique à celui de la table OPERATION : pas de numérotation automatique.
     * @return this.id Long
     */
    public Long getId()
    {
        return this.id;
    }

    /**
     * Identifiant de l'opération.
     * Doit etre identique à celui de la table OPERATION : pas de numérotation automatique.
     * @param idIn Long
     */
    public void setId(Long idIn)
    {
        this.id = idIn;
    }

    private Short rankOrder;

    /**
     * Numéro d'ordre de l'opération dans la marée.
     * L'ordre est déterminée par un tri par odre croissant des dates de fin d'opération.
     * @return this.rankOrder Short
     */
    public Short getRankOrder()
    {
        return this.rankOrder;
    }

    /**
     * Numéro d'ordre de l'opération dans la marée.
     * L'ordre est déterminée par un tri par odre croissant des dates de fin d'opération.
     * @param rankOrderIn Short
     */
    public void setRankOrder(Short rankOrderIn)
    {
        this.rankOrder = rankOrderIn;
    }

    private Boolean isLandingSampling;

    /**
     * La partie retenue a t'elle été échantillonnée comme le prévoit le protocole ?
     * (cf manuel de l'observateur du programme de collecte concerné)
     * @return this.isLandingSampling Boolean
     */
    public Boolean isIsLandingSampling()
    {
        return this.isLandingSampling;
    }

    /**
     * La partie retenue a t'elle été échantillonnée comme le prévoit le protocole ?
     * (cf manuel de l'observateur du programme de collecte concerné)
     * @param isLandingSamplingIn Boolean
     */
    public void setIsLandingSampling(Boolean isLandingSamplingIn)
    {
        this.isLandingSampling = isLandingSamplingIn;
    }

    private Boolean isDiscardSampling;

    /**
     * La partie non retenue a t'elle été échantillonnée comme le prévoit le protocole ?
     * (cf manuel de l'observateur du programme de collecte concerné)
     * @return this.isDiscardSampling Boolean
     */
    public Boolean isIsDiscardSampling()
    {
        return this.isDiscardSampling;
    }

    /**
     * La partie non retenue a t'elle été échantillonnée comme le prévoit le protocole ?
     * (cf manuel de l'observateur du programme de collecte concerné)
     * @param isDiscardSamplingIn Boolean
     */
    public void setIsDiscardSampling(Boolean isDiscardSamplingIn)
    {
        this.isDiscardSampling = isDiscardSamplingIn;
    }

    private Float gearMeshSize;

    /**
     * Maillage étiré de l'engin (en millimètre).
     * Le traitement de dénormalisation remplit ce champ à partir de GEAR_PHYSICAL_FEATURES (de
     * l'operation) et GEAR_PHYSICAL_MEASUREMENT, pour le PMFM correspondant (dont le paramètre est
     * configuré dans le traitement de dénormalisation).
     * @return this.gearMeshSize Float
     */
    public Float getGearMeshSize()
    {
        return this.gearMeshSize;
    }

    /**
     * Maillage étiré de l'engin (en millimètre).
     * Le traitement de dénormalisation remplit ce champ à partir de GEAR_PHYSICAL_FEATURES (de
     * l'operation) et GEAR_PHYSICAL_MEASUREMENT, pour le PMFM correspondant (dont le paramètre est
     * configuré dans le traitement de dénormalisation).
     * @param gearMeshSizeIn Float
     */
    public void setGearMeshSize(Float gearMeshSizeIn)
    {
        this.gearMeshSize = gearMeshSizeIn;
    }

    private Float gearDepth;

    /**
     * Profondeur moyenne de l'engin (en mètre).
     * ref : COST
     * Le traitement de dénormalisation remplit ce champ à partir de GEAR_USE_FEATURES (de
     * l'opération) et GEAR_USE_MEASUREMENT, pour le PMFM correspondant (dont le paramètre est
     * configuré dans le traitement de dénormalisation).
     * @return this.gearDepth Float
     */
    public Float getGearDepth()
    {
        return this.gearDepth;
    }

    /**
     * Profondeur moyenne de l'engin (en mètre).
     * ref : COST
     * Le traitement de dénormalisation remplit ce champ à partir de GEAR_USE_FEATURES (de
     * l'opération) et GEAR_USE_MEASUREMENT, pour le PMFM correspondant (dont le paramètre est
     * configuré dans le traitement de dénormalisation).
     * @param gearDepthIn Float
     */
    public void setGearDepth(Float gearDepthIn)
    {
        this.gearDepth = gearDepthIn;
    }

    private Float mainWaterDepth;

    /**
     * Hauteur d'eau moyenne (en mètre)?
     * ref : COST ?
     * Le traitement de dénormalisation remplit ce champ à partir de VESSEL_USE_FEATURES (de
     * l'opération) et VESSEL_USE_MEASUREMENT, pour le PMFM correspondant (dont le paramètre est
     * configuré dans le traitement de dénormalisation).
     * @return this.mainWaterDepth Float
     */
    public Float getMainWaterDepth()
    {
        return this.mainWaterDepth;
    }

    /**
     * Hauteur d'eau moyenne (en mètre)?
     * ref : COST ?
     * Le traitement de dénormalisation remplit ce champ à partir de VESSEL_USE_FEATURES (de
     * l'opération) et VESSEL_USE_MEASUREMENT, pour le PMFM correspondant (dont le paramètre est
     * configuré dans le traitement de dénormalisation).
     * @param mainWaterDepthIn Float
     */
    public void setMainWaterDepth(Float mainWaterDepthIn)
    {
        this.mainWaterDepth = mainWaterDepthIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 7 associations
    private FishingTrip fishingTrip;

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @return this.fishingTrip FishingTrip
     */
    public FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @param fishingTripIn FishingTrip
     */
    public void setFishingTrip(FishingTrip fishingTripIn)
    {
        this.fishingTrip = fishingTripIn;
    }

    private QualitativeValue selectiveDevice;

    /**
     * Liste des valeurs qualitatives que peut prendre un paramètre.
     * Par exemple :
     * - pour le paramètre Sexe : "Mâle" et "Femelle"
     * - pour le paramètre Présentation : "Vidé", "Entier", ...
     * - pour le paramètre Catégorie : "Gros", "Moyen", ...
     * @return this.selectiveDevice QualitativeValue
     */
    public QualitativeValue getSelectiveDevice()
    {
        return this.selectiveDevice;
    }

    /**
     * Liste des valeurs qualitatives que peut prendre un paramètre.
     * Par exemple :
     * - pour le paramètre Sexe : "Mâle" et "Femelle"
     * - pour le paramètre Présentation : "Vidé", "Entier", ...
     * - pour le paramètre Catégorie : "Gros", "Moyen", ...
     * @param selectiveDeviceIn QualitativeValue
     */
    public void setSelectiveDevice(QualitativeValue selectiveDeviceIn)
    {
        this.selectiveDevice = selectiveDeviceIn;
    }

    private Location rectangleLocation;

    /**
     * Rectangle statistique
     * @return this.rectangleLocation Location
     */
    public Location getRectangleLocation()
    {
        return this.rectangleLocation;
    }

    /**
     * Rectangle statistique
     * @param rectangleLocationIn Location
     */
    public void setRectangleLocation(Location rectangleLocationIn)
    {
        this.rectangleLocation = rectangleLocationIn;
    }

    private Location areaLocation;

    /**
     * Area (cf spécifications COST)
     * @return this.areaLocation Location
     */
    public Location getAreaLocation()
    {
        return this.areaLocation;
    }

    /**
     * Area (cf spécifications COST)
     * @param areaLocationIn Location
     */
    public void setAreaLocation(Location areaLocationIn)
    {
        this.areaLocation = areaLocationIn;
    }

    private Location subpolygonLocation;

    /**
     * Sous-polygone (cf spécifications COST)
     * @return this.subpolygonLocation Location
     */
    public Location getSubpolygonLocation()
    {
        return this.subpolygonLocation;
    }

    /**
     * Sous-polygone (cf spécifications COST)
     * @param subpolygonLocationIn Location
     */
    public void setSubpolygonLocation(Location subpolygonLocationIn)
    {
        this.subpolygonLocation = subpolygonLocationIn;
    }

    private Metier metier;

    /**
     * Optionel, car les campagnes scientifiques n'ont pas de métier.
     * @return this.metier Metier
     */
    public Metier getMetier()
    {
        return this.metier;
    }

    /**
     * Optionel, car les campagnes scientifiques n'ont pas de métier.
     * @param metierIn Metier
     */
    public void setMetier(Metier metierIn)
    {
        this.metier = metierIn;
    }

    private Gear gear;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @return this.gear Gear
     */
    public Gear getGear()
    {
        return this.gear;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
     * </p>
     * <p>
     * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
     * classification, via les liens d'engin parents/enfants.
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'Engin EU corpus' :
     * </p>
     * <p>
     * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
     * </p>
     * <p>
     * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
     * </p>
     * <p>
     * * corpus 2 (...)<br>- ...
     * </p>
     * <p>
     * <br>
     * </p>
     * <p>
     * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
     * '03.0.0')<br>
     * </p>
     * <p>
     * - 'OTB' 'chalut de fond'<br>
     * </p>
     * <p>
     * - chalut p&#233;lagique
     * </p>
     * <p>
     * - ...<br>* 'Filets'
     * </p>
     * </body>
     * </html>
     * @param gearIn Gear
     */
    public void setGear(Gear gearIn)
    {
        this.gear = gearIn;
    }

    /**
     * Returns <code>true</code> if the argument is an DenormalizedOperation instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DenormalizedOperation))
        {
            return false;
        }
        final DenormalizedOperation that = (DenormalizedOperation)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link DenormalizedOperation}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DenormalizedOperation}.
         * @return new DenormalizedOperationImpl()
         */
        public static DenormalizedOperation newInstance()
        {
            return new DenormalizedOperationImpl();
        }

        /**
         * Constructs a new instance of {@link DenormalizedOperation}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param rankOrder Short
         * @param isLandingSampling Boolean
         * @param isDiscardSampling Boolean
         * @param updateDate Timestamp
         * @param fishingTrip FishingTrip
         * @return newInstance
         */
        public static DenormalizedOperation newInstance(Short rankOrder, Boolean isLandingSampling, Boolean isDiscardSampling, Timestamp updateDate, FishingTrip fishingTrip)
        {
            final DenormalizedOperation entity = new DenormalizedOperationImpl();
            entity.setRankOrder(rankOrder);
            entity.setIsLandingSampling(isLandingSampling);
            entity.setIsDiscardSampling(isDiscardSampling);
            entity.setUpdateDate(updateDate);
            entity.setFishingTrip(fishingTrip);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DenormalizedOperation}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param rankOrder Short
         * @param isLandingSampling Boolean
         * @param isDiscardSampling Boolean
         * @param gearMeshSize Float
         * @param gearDepth Float
         * @param mainWaterDepth Float
         * @param updateDate Timestamp
         * @param fishingTrip FishingTrip
         * @param selectiveDevice QualitativeValue
         * @param rectangleLocation Location
         * @param areaLocation Location
         * @param subpolygonLocation Location
         * @param metier Metier
         * @param gear Gear
         * @return newInstance DenormalizedOperation
         */
        public static DenormalizedOperation newInstance(Short rankOrder, Boolean isLandingSampling, Boolean isDiscardSampling, Float gearMeshSize, Float gearDepth, Float mainWaterDepth, Timestamp updateDate, FishingTrip fishingTrip, QualitativeValue selectiveDevice, Location rectangleLocation, Location areaLocation, Location subpolygonLocation, Metier metier, Gear gear)
        {
            final DenormalizedOperation entity = new DenormalizedOperationImpl();
            entity.setRankOrder(rankOrder);
            entity.setIsLandingSampling(isLandingSampling);
            entity.setIsDiscardSampling(isDiscardSampling);
            entity.setGearMeshSize(gearMeshSize);
            entity.setGearDepth(gearDepth);
            entity.setMainWaterDepth(mainWaterDepth);
            entity.setUpdateDate(updateDate);
            entity.setFishingTrip(fishingTrip);
            entity.setSelectiveDevice(selectiveDevice);
            entity.setRectangleLocation(rectangleLocation);
            entity.setAreaLocation(areaLocation);
            entity.setSubpolygonLocation(subpolygonLocation);
            entity.setMetier(metier);
            entity.setGear(gear);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DenormalizedOperation o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRankOrder().compareTo(o.getRankOrder()));
            }
            if (this.isIsLandingSampling() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsLandingSampling().compareTo(o.isIsLandingSampling()));
            }
            if (this.isIsDiscardSampling() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsDiscardSampling().compareTo(o.isIsDiscardSampling()));
            }
            if (this.getGearMeshSize() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getGearMeshSize().compareTo(o.getGearMeshSize()));
            }
            if (this.getGearDepth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getGearDepth().compareTo(o.getGearDepth()));
            }
            if (this.getMainWaterDepth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMainWaterDepth().compareTo(o.getMainWaterDepth()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DenormalizedOperation.java merge-point
}