// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.grouping;

import fr.ifremer.adagio.core.dao.referential.ObjectType;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Une classification de regroupement ne traite que d’un seul type de
 * données du référentiel à la fois (<i>ObjectType</i>).
 * Il peut s’agir de regroupement sur les métiers, les lieux, les espèces,
 * etc.
 * </p>
 * <p>
 * En revanche, un même type de données du référentiel (ex : Métier) peut
 * avoir plusieurs classification de regroupement distinctes (DCR, Ifremer,
 * Natura 2000, …)
 * </p>
 * <p>
 * </p>
 * <p>
 * Une classification de regroupement peut contenir un ou plusieurs niveaux
 * de regroupement (<i>GroupingLevel</i>).
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class GroupingClassification
    implements Serializable, Comparable<GroupingClassification>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8645564444836256070L;

    // Generate 8 attributes
    private Integer id;

    /**
     * Identifiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Identifiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * 
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * 
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private String name;

    /**
     * 
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * 
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Boolean isMandatory = Boolean.valueOf(false);

    /**
     * Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe
     * d'exploitation).
     * @return this.isMandatory Boolean
     */
    public Boolean isIsMandatory()
    {
        return this.isMandatory;
    }

    /**
     * Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe
     * d'exploitation).
     * @param isMandatoryIn Boolean
     */
    public void setIsMandatory(Boolean isMandatoryIn)
    {
        this.isMandatory = isMandatoryIn;
    }

    private String comments;

    /**
     * 
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * 
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private String objectReferenceQuery;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * A SQL query that must return identifier (column ID or CODE).
     * </p>
     * <p>
     * Use this query to limit a grouping classification type to a list of
     * entities.
     * </p>
     * <p>
     * </p>
     * <p>
     * <b>For instance :</b>
     * </p>
     * <ul>
     * <li>
     * Limit a grouping classification to commercial species :
     * </li>
     * </ul>
     * <p>
     * <i>select ID
     * <br>from TAXON_GROUP
     * <br>where TAXON_GROUP_TYPE_FK=2 -- FAO species</i>
     * </p>
     * </body>
     * </html>
     * @return this.objectReferenceQuery String
     */
    public String getObjectReferenceQuery()
    {
        return this.objectReferenceQuery;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * A SQL query that must return identifier (column ID or CODE).
     * </p>
     * <p>
     * Use this query to limit a grouping classification type to a list of
     * entities.
     * </p>
     * <p>
     * </p>
     * <p>
     * <b>For instance :</b>
     * </p>
     * <ul>
     * <li>
     * Limit a grouping classification to commercial species :
     * </li>
     * </ul>
     * <p>
     * <i>select ID
     * <br>from TAXON_GROUP
     * <br>where TAXON_GROUP_TYPE_FK=2 -- FAO species</i>
     * </p>
     * </body>
     * </html>
     * @param objectReferenceQueryIn String
     */
    public void setObjectReferenceQuery(String objectReferenceQueryIn)
    {
        this.objectReferenceQuery = objectReferenceQueryIn;
    }

    // Generate 5 associations
    private ObjectType objectType;

    /**
     * Liste des types d'objets qui peuvent etre associés à la photo ou à un fichier attaché. Cette
     * liste
     * ne peut pas etre modifiée par l'utilisateur.
     * généralement, il s'agit des noms des tables (en majuscule + underscore)
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Liste des types d'objets qui peuvent etre associés à la photo ou à un fichier attaché. Cette
     * liste
     * ne peut pas etre modifiée par l'utilisateur.
     * généralement, il s'agit des noms des tables (en majuscule + underscore)
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    /**
     * Returns <code>true</code> if the argument is an GroupingClassification instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof GroupingClassification))
        {
            return false;
        }
        final GroupingClassification that = (GroupingClassification)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link GroupingClassification}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link GroupingClassification}.
         * @return new GroupingClassificationImpl()
         */
        public static GroupingClassification newInstance()
        {
            return new GroupingClassificationImpl();
        }

        /**
         * Constructs a new instance of {@link GroupingClassification}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param name String
         * @param isMandatory Boolean
         * @param updateDate Timestamp
         * @param objectType ObjectType
         * @return newInstance
         */
        public static GroupingClassification newInstance(String label, String name, Boolean isMandatory, Timestamp updateDate, ObjectType objectType)
        {
            final GroupingClassification entity = new GroupingClassificationImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setIsMandatory(isMandatory);
            entity.setUpdateDate(updateDate);
            entity.setObjectType(objectType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link GroupingClassification}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param description String
         * @param isMandatory Boolean
         * @param comments String
         * @param updateDate Timestamp
         * @param objectReferenceQuery String
         * @param objectType ObjectType
         * @return newInstance GroupingClassification
         */
        public static GroupingClassification newInstance(String label, String name, String description, Boolean isMandatory, String comments, Timestamp updateDate, String objectReferenceQuery, ObjectType objectType)
        {
            final GroupingClassification entity = new GroupingClassificationImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setDescription(description);
            entity.setIsMandatory(isMandatory);
            entity.setComments(comments);
            entity.setUpdateDate(updateDate);
            entity.setObjectReferenceQuery(objectReferenceQuery);
            entity.setObjectType(objectType);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(GroupingClassification o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.isIsMandatory() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsMandatory().compareTo(o.isIsMandatory()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getObjectReferenceQuery() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectReferenceQuery().compareTo(o.getObjectReferenceQuery()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// GroupingClassification.java merge-point
}