// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.transcribing;

import fr.ifremer.adagio.core.dao.referential.ObjectType;
import fr.ifremer.adagio.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Type de transcodage, permettant de faire communiquer un système d'information externes avec le
 * système Allegro.
 * Exemple :
 * - Harmonie 1 : DRB_ESPECE.ESP_COD,
 * - Harmonie 1 : DRI_PARAMETER.PAR_ID,
 * - SIPA : SACAPT présentation des espèces,
 * etc
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TranscribingItemType
    implements Serializable, Comparable<TranscribingItemType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -3345601706751182488L;

    // Generate 8 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * Le mnémonique du type de transcodage.
     * Ce mnémonique respecte une structure qui permet d'identifier de manière unique le type de
     * transcodage.
     * Ce mnémonique peut ainsi être utilisé par des constantes, dans des requetes SQL, du code,
     * etc.
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * Le mnémonique du type de transcodage.
     * Ce mnémonique respecte une structure qui permet d'identifier de manière unique le type de
     * transcodage.
     * Ce mnémonique peut ainsi être utilisé par des constantes, dans des requetes SQL, du code,
     * etc.
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private String name;

    /**
     * Le libellé du type de transcodage.
     * Généralement, on utilise le formalisme suivant :
     * <code_système>-<table_système>.<champ_système>
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * Le libellé du type de transcodage.
     * Généralement, on utilise le formalisme suivant :
     * <code_système>-<table_système>.<champ_système>
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private Boolean isMandatory = Boolean.valueOf(false);

    /**
     * Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe
     * d'exploitation).
     * @return this.isMandatory Boolean
     */
    public Boolean isIsMandatory()
    {
        return this.isMandatory;
    }

    /**
     * Permet de savoir si la classification est à maintenir obligatoirement (par l'équipe
     * d'exploitation).
     * @param isMandatoryIn Boolean
     */
    public void setIsMandatory(Boolean isMandatoryIn)
    {
        this.isMandatory = isMandatoryIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private String comments;

    /**
     * Commentaire décrivant le rang taxinomique
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * Commentaire décrivant le rang taxinomique
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private String objectReferenceQuery;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * SQL query that return an ID or a CODE, to limit the transcribing type to
     * a list of entities.
     * </p>
     * <p>
     * <b>For instance :</b>
     * </p>
     * <ul>
     * <li>
     * Limit a transcribing type to commercial species :
     * </li>
     * </ul>
     * <p>
     * select ID
     * <br>from TAXON_GROUP
     * <br>where TAXON_GROUP_TYPE_FK=2 -- FAO species
     * </p>
     * </body>
     * </html>
     * @return this.objectReferenceQuery String
     */
    public String getObjectReferenceQuery()
    {
        return this.objectReferenceQuery;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * SQL query that return an ID or a CODE, to limit the transcribing type to
     * a list of entities.
     * </p>
     * <p>
     * <b>For instance :</b>
     * </p>
     * <ul>
     * <li>
     * Limit a transcribing type to commercial species :
     * </li>
     * </ul>
     * <p>
     * select ID
     * <br>from TAXON_GROUP
     * <br>where TAXON_GROUP_TYPE_FK=2 -- FAO species
     * </p>
     * </body>
     * </html>
     * @param objectReferenceQueryIn String
     */
    public void setObjectReferenceQuery(String objectReferenceQueryIn)
    {
        this.objectReferenceQuery = objectReferenceQueryIn;
    }

    // Generate 5 associations
    private TranscribingSystem transcribingSystem;

    /**
     * Le système d'information (SI) concerné par le type de transcodage. (optionnel)
     * A remplir uniquement si les données de transcodage doivent être accessible depuis les vues de
     * compatibilité v3.1.2 (TRANSCRIBING_METIER, TRANSCRIBING_PMFM, TRANSCRIBING_QUALITATIVE_VALUE,
     * TRANSCRIBING_GEAR...)
     * @return this.transcribingSystem TranscribingSystem
     */
    public TranscribingSystem getTranscribingSystem()
    {
        return this.transcribingSystem;
    }

    /**
     * Le système d'information (SI) concerné par le type de transcodage. (optionnel)
     * A remplir uniquement si les données de transcodage doivent être accessible depuis les vues de
     * compatibilité v3.1.2 (TRANSCRIBING_METIER, TRANSCRIBING_PMFM, TRANSCRIBING_QUALITATIVE_VALUE,
     * TRANSCRIBING_GEAR...)
     * @param transcribingSystemIn TranscribingSystem
     */
    public void setTranscribingSystem(TranscribingSystem transcribingSystemIn)
    {
        this.transcribingSystem = transcribingSystemIn;
    }

    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * - en cours de suppression : '3'
     * -  : '4'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private TranscribingSide transcribingSide;

    /**
     * Sens du transcodage.
     * @return this.transcribingSide TranscribingSide
     */
    public TranscribingSide getTranscribingSide()
    {
        return this.transcribingSide;
    }

    /**
     * Sens du transcodage.
     * @param transcribingSideIn TranscribingSide
     */
    public void setTranscribingSide(TranscribingSide transcribingSideIn)
    {
        this.transcribingSide = transcribingSideIn;
    }

    private ObjectType objectType;

    /**
     * Nature de l'objet transcodé (Généralement, le nom de la table portant l'entité)
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Nature de l'objet transcodé (Généralement, le nom de la table portant l'entité)
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    /**
     * Returns <code>true</code> if the argument is an TranscribingItemType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TranscribingItemType))
        {
            return false;
        }
        final TranscribingItemType that = (TranscribingItemType)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TranscribingItemType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TranscribingItemType}.
         * @return new TranscribingItemTypeImpl()
         */
        public static TranscribingItemType newInstance()
        {
            return new TranscribingItemTypeImpl();
        }

        /**
         * Constructs a new instance of {@link TranscribingItemType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param name String
         * @param isMandatory Boolean
         * @param updateDate Timestamp
         * @param status Status
         * @param transcribingSide TranscribingSide
         * @param objectType ObjectType
         * @return newInstance
         */
        public static TranscribingItemType newInstance(String label, String name, Boolean isMandatory, Timestamp updateDate, Status status, TranscribingSide transcribingSide, ObjectType objectType)
        {
            final TranscribingItemType entity = new TranscribingItemTypeImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setIsMandatory(isMandatory);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setTranscribingSide(transcribingSide);
            entity.setObjectType(objectType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TranscribingItemType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param isMandatory Boolean
         * @param description String
         * @param comments String
         * @param updateDate Timestamp
         * @param objectReferenceQuery String
         * @param transcribingSystem TranscribingSystem
         * @param status Status
         * @param transcribingSide TranscribingSide
         * @param objectType ObjectType
         * @return newInstance TranscribingItemType
         */
        public static TranscribingItemType newInstance(String label, String name, Boolean isMandatory, String description, String comments, Timestamp updateDate, String objectReferenceQuery, TranscribingSystem transcribingSystem, Status status, TranscribingSide transcribingSide, ObjectType objectType)
        {
            final TranscribingItemType entity = new TranscribingItemTypeImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setIsMandatory(isMandatory);
            entity.setDescription(description);
            entity.setComments(comments);
            entity.setUpdateDate(updateDate);
            entity.setObjectReferenceQuery(objectReferenceQuery);
            entity.setTranscribingSystem(transcribingSystem);
            entity.setStatus(status);
            entity.setTranscribingSide(transcribingSide);
            entity.setObjectType(objectType);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TranscribingItemType o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.isIsMandatory() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsMandatory().compareTo(o.isIsMandatory()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getObjectReferenceQuery() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectReferenceQuery().compareTo(o.getObjectReferenceQuery()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TranscribingItemType.java merge-point
}